2003-01-01  Paul Eggert  <eggert@twinsun.com>

	* Version 1.875.

2002-12-30  Paul Eggert  <eggert@twinsun.com>

	* src/scan-gram.l (<INITIAL,SC_AFTER_IDENTIFIER,SC_PRE_CODE>","):
	Moved here from...
	(<INITIAL>","): Here.  This causes stray "," to be treated
	more uniformly.

	* src/scan-gram.l (<SC_BRACED_CODE>"}"): Output ";" before the
	last brace in braced code when not in Yacc mode, for compatibility
	with Bison 1.35.  This resurrects the 2001-12-15 patch to
	src/reader.c.

	* src/reader.h (YYDECL): Use YYSTYPE, not its deprecated alias
	yystype.  This follows up the 2002-12-24 YYSTYPE bug fix.

2002-12-28  Paul Eggert  <eggert@twinsun.com>

	* src/symtab.c (symbol_make_alias): Set type of SYMVAL to be
	that of SYM's type.  This fixes Debian bug 168069, reported by
	Thomas Olsson.
	
2002-12-28  Paul Eggert  <eggert@twinsun.com>

	Version 1.75f.

	Switch back to the Yacc style of conflict reports, undoing some
	of the 2002-07-30 change.
	* doc/bison.texinfo (Understanding): Use Yacc style for
	conflict reports.  Also, use new way of locating rules.
	* src/conflicts.c (conflict_report):
	Renamed from conflict_report_yacc, removing the old
	'conflict_report'.  Translate the entire conflict report at once,
	so that we don't assume that "," has the same interpretation in
	all languages.
	(conflicts_output): Use Yacc-style conflict report for each state,
	instead of our more-complicated style.
	(conflicts_print): Use Yacc-style conflict report, except print
	the input file name when not emulating Yacc.
	* tests/conflicts.at (Unresolved SR Conflicts, Defaulted
	Conflicted Reduction, %expect not enough, %expect too much,
	%expect with reduce conflicts): Switch to Yacc-style conflict reports.
	* tests/existing.at (GNU Cim Grammar): Likewise.
	* tests/glr-regr1.at (Badly Collapsed GLR States): Likewise.

	* src/complain.c (warn_at, warn, complain_at, complain, fatal_at,
	fatal): Don't invoke fflush; it's not needed and it might even be
	harmful for stdout, as stdout might not be open.
	* src/reduce.c (reduce_print): Likewise.

2002-12-27  Paul Eggert  <eggert@twinsun.com>

	Fix a bug where error locations were not being recorded correctly.
	This problem was originally reported by Paul Hilfinger in
	<http://mail.gnu.org/pipermail/bug-bison/2002-November/001901.html>.

	* data/yacc.c (yyparse): New local var yylerrsp, to record the
	top of the location stack's error locations.
	(yyerrlab): Set it.  When discarding a token, push its location
	onto yylerrsp so that we don't lose track of the error's end.
	(yyerrlab1): Now is only the target of YYERROR, so that we can
	properly record the location of the action that failed.  For GCC
	2.93 and later, insert an __attribute__ ((__unused__)) to avoid
	GCC warning about yyerrlab1 being unused if YYERROR is unused.
	(yyerrlab2): New label, which yyerrlab now falls through to.
	Compute the error's location by applying YYLLOC_DEFAULT to
	the locations of all the symbols that went into the error.
	* doc/bison.texinfo (Location Default Action): Mention that
	YYLLOC_DEFAULT is also invoked for syntax errors.
	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR):
	Error locations include the locations of all the tokens that were
	discarded, not just the last token.
	
2002-12-26  Paul Eggert  <eggert@twinsun.com>

	* src/files.c: Include quote.h.
	(compute_output_file_names): Warn if we detect conflicting
	outputs to the same file.  This should catch the misunderstanding
	exemplified by Debian Bug 165349, reported by Bruce Stephens..

	* src/conflicts.c (conflicts_print): If the user specifies
	"%expect N", report an error if there are any reduce/reduce
	conflicts.  This is what the manual says should happen.
	This fixes Debian bug 130890, reported by Anthony DeRobertis.
	* tests/conflicts.at (%expect with reduce conflicts): New test.

	Don't use m4_include on relative file names, as it doesn't work as
	desired if there happens to be a file with that name under ".".
	
	* m4sugar/version.m4: Remove; it was included but it wasn't used.
	* data/Makefile.am (dist_m4sugar_DATA): Remove m4sugar/version.m4.
	* data/m4sugar/m4sugar.m4: Don't include m4sugar/version.m4.
	* data/glr.c, data/lalr1.cc, data/yacc.c: Don't include c.m4.
	* src/output.c (output_skeleton): Use full path names when
	specifying a file to include; don't rely on include path, as
	it's unreliable when the working file contains a file with
	that name.
	
2002-12-25  Paul Eggert  <eggert@twinsun.com>

	Remove obsolete references to bison.simple and bison.hairy.
	Problem mentioned by Aubin Mahe in
	<http://mail.gnu.org/pipermail/help-bison/2002-December/001765.html>.
	* data/glr.c: Comment fix.
	* doc/bison.1: Remove references.  Also, mention "yacc".

	* src/getargs.c (getargs) [MSDOS]: Don't assume optarg != NULL
	with -g option.

	* src/parse-gram.y (declaration): Use enum "report_states" rather
	than its numeric value 1.

	* src/scan-skel.l ("@output ".*\n): Close any old yyout before
	opening a new one.  This fixes Debian bug 165349, reported by
	Bruce Stephens.

2002-12-24  Paul Eggert  <eggert@twinsun.com>

	Version 1.75e.

	* Makefile.maint (cvs-update): Don't assume that the shell
	supports $(...), as Solaris sh doesn't.

	* src/parse-gram.y (lloc_default): Remove test for empty
	nonterminals at the end, since it didn't change the result.

2002-12-24  Paul Eggert  <eggert@twinsun.com>

	If the user does not define YYSTYPE as a macro, Bison now declares it
	using typedef instead of defining it as a macro.  POSIX requires this.
	For consistency, YYLTYPE is also declared instead of defined.

	%union directives can now have a tag before the `{', e.g., the
	directive `%union foo {...}' now generates the C code
	`typedef union foo { ... } YYSTYPE;'; this is for Yacc compatibility.
	The default union tag is `YYSTYPE', for compatibility with Solaris 9
	Yacc.  For consistency, YYLTYPE's struct tag is now `YYLTYPE'
	instead of `yyltype'.

	`yystype' and `yyltype' are now obsolescent macros instead of being
	typedefs or tags; they are no longer documented and will be
	withdrawn in a future release.

	* data/glr.c (b4_location_type): Remove.
	(YYSTYPE): Renamed from yystype.
	(YYSTYPE_IS_DECLARED): New macro, used to prevent double-typedef.
	(struct YYLTYPE): Renamed from struct yyltype.
	(YYLTYPE): Renamed from yyltype.
	(yyltype, yystype): New (and obsolescent) macros,
	for backward compatibility.
	* data/yacc.c: Likewise.

	* data/yacc.c (YYSTYPE): Declare as union YYSTYPE if the user
	does not specify a union tag.  This is for compatibility with
	Solaris 9 yacc.

	* src/parse-gram.y (add_param): 2nd arg is now char * not char
	const *, since it is now modified by stripping surrounding { }.
	(current_braced_code): Remove.
	(PERCENT_DESTRUCTOR, PERCENT_PRINTER, PERCENT_UNION,
	PERCENT_LEX_PARAM, PERCENT_PARSE_PARAM): Change names to include
	trailing " {...}".  Now of type <chars>.
	(grammar_declaration): Adjust to bundled tokens.
	(code_content): Remove; stripping is now done by add_param.
	(print_token_value): Print contents of bundled tokens.
	(token_name): New function.

	* src/reader.h (braced_code, current_braced_code): Remove.
	(token_name): New decl.

	* src/scan-gram.l (handle_dollar, handle_at): Now takes int
	token_type, not braced_code code_kind.  All uses changed.
	(SC_PRE_CODE): New state, for scanning after a keyword that
	has (or usually has) an immediately-following braced code.
	(token_type): New local var, to keep track of which token type
	to return when scanning braced code.
	(<INITIAL>"%destructor", <INITIAL>"%lex-param",
	<INITIAL>"%parse-param", <INITIAL>"%printer",
	<INITIAL>"%union"): Set token type and BEGIN SC_PRE_CODE
	instead of returning a token type immediately.
	(<INITIAL>"{"): Set token type.
	(<SC_BRACED_CODE>"}"): Use it.
	(handle_action_dollar, handle_action_at): Now returns bool
	indicating success.  Fail if ! current_rule; this prevents a core dump.
	(handle_symbol_code_dollar, handle_symbol_code_at):
	Remove; merge body into caller.
	(handle_dollar, handle_at): Complain in invalid contexts.

	* NEWS, doc/bison.texinfo: Document the above.
	* NEWS: Fix years and program names in copyright notice.

2002-12-17  Paul Eggert  <eggert@twinsun.com>

	* NEWS, doc/bison.texinfo (Parser Function, Pure Calling, Error
	Reporting, Table of Symbols): Omit mentions of %lex-param and
	%parse-param from the documentation for now.

2002-12-15  Paul Eggert  <eggert@twinsun.com>

	Undo most of the 2002-11-12 yychar -> yytoken patch, as it broke
	GCC 3.2.1 (which depends on yychar == YYEMPTY when there is no
	lookahead symbol, and which sets yychar in parser actions) and it
	disagreed with the Bison documentation.  Bug
	reported by Andrew Walrond.
	
	* data/yacc.c (YYTRANSLATE): Don't check for negative argument,
	as the caller now does that.
	(yyclearin, YYBACKUP, yyparse): Use yychar, not yytoken.
	(YYEMPTY): Parenthesize right hand side, since others use it.
	(yyparse): Don't assume that our generated code is the only code
	that sets yychar.

2002-12-13  Paul Eggert  <eggert@twinsun.com>

	Version 1.75d.

	POSIX requires a "yacc" command.
	* src/Makefile.am (bin_SCRIPTS): New macro, for yacc.
	(MOSTLYCLEANFILES): Add yacc.
	(yacc): New rule.
	* doc/bison.texinfo (Invocation, Bison Options): Mention yacc
	as an alias for bison y.

	* po/LINGUAS: Add da.
	
	* src/getargs.c (__GNU_LIBRARY__) [lint]: Define to work around
	problem with latest <getopt.h>.
	(HACK_FOR___GNU_LIBRARY___PROTOTYPE): New macro.

	* doc/fdl.texi: Upgrade to 1.2.
	* lib/alloca.c, lib/error.c, lib/getopt.c, lib/getopt.h
	lib/getopt1.c, lib/gettext.h, lib/memrchr.c, lib/obstack.c,
	lib/obstack.h, lib/strnlen.c, lib/unlocked-io.h: Sync with
	gnulib.
	* config/install-sh: Sync with autotools.

	Fix a bad interaction with flex 2.5.23 reported by Bruce Lilly in
	<http://mail.gnu.org/pipermail/bug-bison/2002-November/001929.html>.
	* data/yacc.c (YYLTYPE, struct yyltype): Do not define unless
	locations are requested.
	(union yyalloc): Do not depend on YYLTYPE_IS_TRIVIAL unless
	locations are requested.

2002-12-12  Paul Eggert  <eggert@twinsun.com>

	Remove unportable casts and storage allocation tricks.
	While we're at it, remove almost all casts, since they
	usually aren't needed and are a sign of trouble.

	* configure.ac (AC_CHECK_TYPES): Check for uintptr_t.

	* src/derives.c (derives_compute): Do not subtract NTOKENS from
	the pointer DSET returned by malloc; this isn't portable.
	Instead, always use DSET[i - NTOKENS] rather than DSET[i].
	Similarly for DERIVES.
	* src/lalr.c (set_goto_map): Likewise, for GOTO_MAP and TEMP_MAP.
	* src/nullable.c (nullable_compute): Likewise, for RSETS and NULLABLE.
	* src/reduce.c (reduce_grammar_tables): Likewise, for nontermmap

	* src/derives.c (derives_compute): Do not bother invoking
	int_of_rule_number, since rule numbers are integers.

	* src/files.c (concat2, tr, compute_base_name): Use xmalloc (N)
	rather than XMALLOC (char, N).

	* src/files.c (filename_split): Rewrite to avoid cast.

	* src/gram.h (symbol_number_as_item_number,
	item_number_as_symbol_number, rule_number_as_item_number,
	item_number_as_rule_number):
	Now inline functions rather than macros, to avoid casts.
	* src/state.h (state_number_as_int): Likewise.
	* src/tables.c (state_number_to_vector_number,
	symbol_number_to_vector_number): Likewise.

	* src/gram.h (int_of_rule_number): Remove; no longer used.

	* src/lalr.c (add_lookback_edge): Use malloc rather than calloc,
	since the resulting storage is always stored into.

	* src/main.c (alloca) [C_ALLOCA]: Add decl here, the only place
	where it's needed.

	* src/muscle_tab.c (muscle_m4_output):
	Now inline.  Return bool, not int.
	* src/state.c (state_compare): Likewise.
	* src/symtab.c (symbol_check_defined,
	symbol_check_alias_consistency, symbol_pack, symbol_translation,
	hash_compare_symbol, hash_symbol):
	Likewise.
	* src/uniqstr.c (uniqstr_print): Likewise.
	* src/muscle_tab.c (muscle_m4_output_processor):
	New function, to avoid casts.
	* src/state.c (state_comparator, stage_hasher): Likewise.
	* src/symtab.c (symbol_check_defined_processor,
	symbol_check_alias_consistency_processor, symbol_pack_processor,
	symbol_translation_processor, hash_symbol_comparator,
	hash_symbol_hasher): Likewise.
	* src/uniqstr.c (uniqstr_print_processor): Likewise.
	* src/muscle_tab.c (muscles_m4_output):
	Use new functions instead of casting old functions unportably.
	* src/state.c (state_hash_new): Likewise.
	* src/symtab.c (symbols_new, symbols_do, symbols_check_defined,
	symbols_token_translations_init):
	Likewise.
	* src/uniqstr.c (uniqstrs_new, hash_initialize, uniqstrs_do): Likewise.

	* src/output.c (GENERATE_MUSCLE_INSERT_TABLE): Use long local
	var instead of casting to long, to avoid casts.
	(prepare_states): Use MALLOC rather than alloca, so that we don't
	have to worry about alloca.
	* src/state.c (state_hash_lookup): Likewise.

	* src/scan-gram.l (<SC_ESCAPED_CHARACTER>"'"): Use unsigned char
	local var instead of casting to unsigned char, to avoid casts.

	* src/state.c (TRANSITIONS_ALLOC, ERRS_ALLOC, REDUCTIONS_ALLOC,
	STATE_ALLOC): Remove.
	(transitions_new, errs_new, reductions_new, state_new): Use malloc
	rather than calloc, and use offsetof to avoid allocating slightly
	too much storage.
	(state_new): Initialize all members.

	* src/state.c (state_hash): Use unsigned accumulator, not signed.

	* src/symtab.c (symbol_free): Remove; unused.
	(symbol_get): Remove cast in lhs of assignment.
	(symbols_do): Now static.  Accept generic arguments, not
	hashing-related ones.

	* src/symtab.h: (NUMBER_UNDEFINED): Remove unnecessary cast.
	(symbol_processor): Remove.
	(symbols_do): Remove decl; now static.

	* src/system.h (alloca): Remove; decl no longer needed.
	(<stddef.h>): Include, for offsetof.
	(<inttypes.>, <stdint.h>): Include if available.
	(uintptr_t): New type, if system lacks it.
	(CALLOC, MALLOC, REALLOC): New macros.
	All uses of XCALLOC, XMALLOC, and XREALLOC changed to use these
	new macros.

	* src/tables.c (table_size): Now int, to pacify GCC.
	(table_grow, table_ninf_remap): Use signed table size.
	(save_row): Don't bother initializing locals when not needed.
	(default_goto, goto_actions, pack_vector): Remove unnecessary casts.
	* src/uniqstr.c (hash_compare_uniqstr):  Likewise.

	* src/vcg.h: Correct misspellings.

	* src/vcg_defaults.h (G_CMAX): Now INT_MAX.


	* src/getargs.c (getargs): Don't assume EOF == -1.

2002-12-09  Paul Eggert  <eggert@twinsun.com>

	Change identifier spellings to avoid collisions with names
	that are reserved by POSIX.

	Don't use names ending in _t, since POSIX reserves them.
	For consistency, remove _e and _s endings -- they're weren't
	needed to remove ambiguity.  All uses changed.
	* src/uniqstr.h (uniqstr): Renamed from uniqstr_t, which in
	turn was just renamed from struniq_t.
	* src/uniqstr.c (uniqstr_processor): Renamed from struniq_processor,
	which in turn was just renamed from struniq_processor_t.
	(hash_compare_uniqstr): Renamed from hash_compare_struniq, which
	in turn was renamed from hash_compare_struniq_t.
	* src/LR0.c (struct state_list): Renamed from struct state_list_s.
	(state_list): Renamed from state_list_t.
	* src/assoc.h (assoc): Renamed from assoc_t.
	* src/conflicts.c (enum conflict_resolution): Renamed from
	enum conflict_resolution_e.
	* src/derives.c (struct rule_list): Renamed from struct rule_list_s.
	(rule_list): Renamed from rule_list_t.
	* src/getargs.h (enum trace): Renamed from enum trace_e.
	(enum report): Renamed from enum report_e.
	* src/gram.h (item_number): Renamed from item_number_t.
	(rule_number): Renamed from rule_number_t.
	(struct rule_s): Remove the "rule_s" part; not used.
	(rule): Renamed from rule_t.
	(rule_filter): Renamed from rule_filter_t.
	* src/lalr.c (struct goto_list): Renamed from struct goto_list_s.
	(goto_list): Renamed from goto_list_t.
	* src/lalr.h (goto_number): Renamed from goto_number_t.
	* src/location.h (location): Renamed from location_t.
	* src/muscle_tab.c (muscle_entry): Renamed from muscle_entry_t,
	and moved here from:
	* src/muscle_tab.h (muscle_entry_t): here.
	* src/nullable.c (struct rule_list): Renamed from struct rule_list_s.
	(rule_list): Renamed from rule_list_t.
	* src/print_graph.c (static_graph): Renamed from graph.
	* src/reader.h (braced_code): Renamed from braced_code_t.
	Remove brace_code_e tag.
	* src/relation.h (relation_node): Renamed from relation_node_t.
	(relation_nodes): Renamed from relation_nodes_t.
	(relation): Renamed from relation_t.
	* src/state.h (state_number): Renamed from state_number_t.
	(struct state): Renamed from struct state_s.
	(state): Renamed from state_t.
	(transitions): Renamed from transitions_t.  Unused (and
	misspelled) transtion_s tag removed.
	(errs): Renamed from errs_t.  Unused errs_s tag removed.
	(reductions): Renamed from reductions_t.  Unused tag
	reductions_s removed.
	* src/symlist.h (symbol_list): Renamed from symbol_list_t.
	(struct symbol_list): Renamed from struct symbol_list_s.
	* src/symtab.h (symbol_number): Renamed from symbol_number_t.
	(struct symbol): Renamed from struct symbol_s.
	(symbol): Renamed from symbol_t.
	* src/tables.c (vector_number): Renamed from vector_number_t.
	(action_number): Renamed from action_t.
	* src/tables.h (base_number): Renamed from base_t.
	* src/vcg.h (enum color): Renamed from enum color_e.
	(enum textmode): Renamed from enum textmode_e.
	(enum shape): Renamed from enum shape_e.
	(struct colorentry): Renamed from struct colorentry_s.
	(struct classname): Renamed from struct classname_s.
	(struct infoname): Renamed from struct infoname_s.
	(enum layoutalgorithm): Renamed from enum layoutalgorithm_e.
	(enum decision): Renamed from enum decision_e.
	(enum orientation): Renamed from enum orientation_e.
	(enum alignment): Renamed from enum alignment_e.
	(enum arrow_mode): Renamed from enum arrow_mode_e.
	(enum crossing_type): Renamed from enum crossing_type_e.
	(enum view): Renamed from enum view_e.
	(struct node): Renamed from struct node_s.
	(node): Renamed from node_t.
	(enum linestyle): Renamed from enum linestyle_e.
	(enum arrowstyle): Renamed from enum arrowstyle_e.
	(struct edge): Renamed from struct edge.
	(edge): Renamed from edge_t.
	(struct graph): Renamed from struct graph_s.
	(graph): Renamed from graph_t.
	* tests/calc.at (_AT_DATA_CALC_Y, Simple LALR Calculator):
	Rename value_t -> value.
	* tests/input.at (Torturing the Scanner): Rename value_t -> value,
	value_t_as_yystype -> value_as_yystype.

	Don't include <errno.h> in the mainstream code, since it
	reserves E[A-Z0-9]* and we want to use symbols like 'EQUALS'.
	* lib/get-errno.c, lib/get-errno.h: New files.
	* lib/Makefile.am (libbison_a_SOURCES): Add get-errno.h,
	get-errno.c.
	* src/files.c (xfopen, xfclose): Use get_errno instead of errno.
	* src/output.c (output_skeleton): Likewise.
	* src/scan-gram.l (<INITIAL>{int}): Use set_errno and get_errno
	instead of errno.
	(<SC_ESCAPED_STRING,SC_ESCAPED_CHARACTER>\\x[0-9abcdefABCDEF]+):
	Likewise.
	(handle_action_dollar, handle_action_at): Likewise.
	* src/system.h: Do not include <errno.h>.
	(TAB_EXT): Renamed from EXT_TAB.
	(OUTPUT_EXT): Renamed from EXT_OUTPUT.

	Avoid str[a-z]*, since <string.h> reserves that name space.
	Change all instances of "struniq" in names to "uniqstr", and
	likewise for "STRUNIQ" and "UNIQSTR".
	* src/uniqstr.c: Renamed from src/struniq.c.
	* src/uniqstr.h: Renamed from src/struniq.h.
	* src/Makefile.am (bison_SOURCES): Adjust to these renamings.
	* src/files.c (strsuffix): Remove; unused.
	(concat2): Renamed from stringappend.  Now static.
	* src/files.h (strsuffix, stringappend): Remove; unused.
	* src/parse-gram.y (<chars>): Renamed from <string>.
	(<uniqstr>): Renamed from <struniq>.
	* src/scan-gram.l (obstack_for_string): Renamed from string_obstack.
	* src/vcg.h (struct node_s.expand): Renamed from struct node_s.stretch.
	(struct graph_s.expand): Renamed from struct graph_s.stretch.
	* src/vcg_defaults.h (G_EXPAND): Renamed from G_STRETCH.
	(G_LONG_STRAIGHT_PHASE): Renamed from G_STRAIGHT_PHASE.
	(N_EXPAND): Renamed from N_STRETCH.

	Avoid *_MAX and *_MIN, since <limits.h> reserves that name space.
	* data/yacc.c (YYSTACK_GAP_MAXIMUM): Renamed from YYSTACK_GAP_MAX.
	* src/gram.h (ITEM_NUMBER_MAX, ITEM_NUMBER_MIN, RULE_NUMBER_MAX):
	Remove; unused.
	* src/lalr.h (GOTO_NUMBER_MAXIMUM): Renamed from GOTO_NUMBER_MAX.
	* src/state.h (STATE_NUMBER_MAXIMUM): Renamed from STATE_NUMBER_MAX.
	* src/symtab.h (SYMBOL_NUMBER_MAXIMUM): Renamed from SYMBOL_NUMBER_MAX.
	* src/tables.c (VECTOR_NUMBER_MAX, VECTOR_NUMBER_MIN): Remove; unused.
	(BASE_MAXIMUM): Renamed from BASE_MAX.
	(BASE_MINIMUM): Renamed from BASE_MIN.
	(ACTION_MAX): Remove; unused.
	(ACTION_NUMBER_MINIMUM): Renamed from ACTION_MIN.
	Unnecessary casts removed from above defines.


	Fix misspelling in names.
	* src/vcg.h (enum_alignment_e): Renamed from enum_alignement_e.
	* src/vcg_defaults.h (G_NODE_ALIGNMENT): Renamed from
	G_NODE_ALIGNEMENT.


	* lib/timevar.c (timevar_report): Renamed from time_report,
	for consistency with other names.
	* lib/timevar.h (timevar_report): New decl.
	* src/system.h (time_report): Remove; decl is now in lib/timevar.h.


	Sort include-file uses.

	Reorder all include files under src to be in the order "system.h".
	then the ../lib include files in angle brackets (alphabetized),
	then the . include files in double-quotes (alphabetized).  Fix
	dependency breakages encountered in this process, as follows:
	* src/closure.h, src/derives.h, src/state.h: Include "gram.h".
	* src/complain.c: Don't include stdlib.h, string.h _LIBC stuff.
	* src/state.h: Include "symtab.h".

2002-12-08  Paul Eggert  <eggert@twinsun.com>

	* data/glr.c, data/lalr1.cc, data/yacc.c: Do not use __file__,
	since this causes problems when __file__ contains character
	sequences like "@" that are treated specially by src/scan-skel.l.
	Instead, just use the file's basename.  This fixes the bug
	reported by Martin Mokrejs in
	<http://mail.gnu.org/pipermail/bug-bison/2002-December/001945.html>.

2002-12-06  Paul Eggert  <eggert@twinsun.com>

	Add support for rules that do not have trailing semicolons, as
	POSIX requires.  Improve the quality of locations in Bison
	diagnostics.

	* src/location.c: Include <quotearg.h>.
	(empty_location): Now const.
	(location_print): New function.  Follow the recommendation of the
	GNU Coding Standards for locations that span file boundaries.
	* src/location.h: Do not include <quotearg.h>; no longer needed.
	(boundary): New type.
	(location_t): Use it.  This allows locations to span file boundaries.
	All member uses changed: file -> start.file or end.file (as needed),
	first_line -> start.line, first_column -> start.column,
	last_line -> end.line, last_column -> end.column.
	(equal_boundaries): New function.
	(LOCATION_RESET, LOCATION_STEP): Remove.
	(LOCATION_PRINT): Remove.  All callers changed to use location_print.
	(empty_location): Now const.
	(location_print): New decl.
	* src/parse-gram.y (lloc_default): New function, which handles
	empty locations more accurately.
	(YYLLOC_DEFAULT): Use it.
	(%token COLON): Remove.
	(%token ID_COLON): New token.
	(rules): Use it.
	(declarations, rules): Remove trailing semicolon.
	(declaration, rules_or_grammar_declaration):
	Allow empty (";") declaration.
	(symbol_def): Remove empty actions; no longer needed.
	(rules_or_grammar_declaration): Remove trailing semicolon.
	(semi_colon.opt): Remove.
	* src/reader.h: Include location.h.
	(scanner_cursor): New decl.
	* src/reduce.c (nonterminals_reduce): Use warn_at rather than
	rolling our own.
	* src/scan-gram.l (YY_USER_INIT): Initialize scanner_cursor instead
	of *loc.
	(STEP): Remove.  No longer needed, now that adjust_location does
	the work.  All uses removed.
	(scanner_cursor): New var.
	(adjust_location): Renamed from extend_location.  It now sets
	*loc and adjusts the scanner cursor.  All uses changed.
	Don't bother testing for CR.
	(handle_syncline): Remove location arg; now updates scanner cursor.
	All callers changed.
	(unexpected_end_of_file): Now accepts start boundary of token or
	comment, not location.  All callers changed.  Update scanner cursor,
	not the location.
	(SC_AFTER_IDENTIFIER): New state.
	(context_state): Renamed from c_context.  All uses changed.
	(id_loc, code_start, token_start): New local vars.
	(<INITIAL,SC_AFTER_IDENTIFIER>): New initial context.  Move all
	processing of Yacc white space and equivalents here.
	(<INITIAL>{id}): Save id_loc.  Begin state SC_AFTER_IDENTIFIER
	instead of returning ID immediately, since we need to search for
	a subsequent colon.
	(<INITIAL>"'", "\""): Save token_start.
	(<INITIAL>"%{", "{", "%%"): Save code_start.
	(<SC_AFTER_IDENTIFIER>): New state, looking for a colon.
	(<SC_YACC_COMMENT>, <SC_COMMENT>, <SC_LINE_COMMENT>):
	BEGIN context_state at end, not INITIAL.
	(<SC_ESCAPED_STRING>"\"", <SC_ESCAPED_CHARACTER>"'",
	<SC_BRACED_CODE>"}", <SC_PROLOGUE>"%}", <SC_EPILOGUE><<EOF>>):
	Return correct token start.
	(<SC_BRACED_CODE,SC_PROLOGUE,SC_EPILOGUE>): Save start boundary when
	the start of a character, string or multiline comment is found.
	* tests/conflicts.at (S/R in initial, Defaulted Conflicted
	Reduction): Adjust reported locations to match the more-precise
	results now expected.
	* tests/input.at (Invalid $n, Invalid @n, Type Clashes): Likewise.
	* tests/reduce.at (Useless Rules, Reduced Automaton,
	Underivable Rules): Likewise.
	* tests/regression.at (Invalid inputs): No longer `expecting ";"
	or "|"' now that so many other tokens are allowed by the new grammar.

	* src/complain.h (current_file): Remove duplicate decl;
	current_file is now owned by files.h.
	* src/complain.c, src/scan-gram.l: Include files.h.

2002-12-06  Paul Eggert  <eggert@twinsun.com>

	* data/glr.c (yy_reduce_print): Don't assume that yyrline[yyrule]
	promotes to int; it might be unsigned int.
	* data/yacc.c (yy_reduce_print): Likewise.

	* doc/bison.texinfo (Table of Symbols): YYERROR_VERBOSE should
	be #defined in the prologue, not in the Bison declarations.
	This fixes Debian Bug 102878, reported by Shaul Karl.

2002-12-02  Paul Eggert  <eggert@twinsun.com>

	* configure.ac (AC_REPLACE_FUNCS): Add strtoul.
	* lib/strtoul.c: New file, from gnulib.
	This fixes a porting bug reported by Peter Klein in
	<http://mail.gnu.org/pipermail/bug-bison/2002-December/001944.html>.

2002-11-30  Paul Eggert  <eggert@twinsun.com>

	* src/scan-gram.l (no_cr_read, extend_location): Move to epilogue,
	and put only a forward declaration in the prologue.  This is for
	consistency with the other scanner helper functions.

	Type clashes now generate warnings, not errors, since it
	appears that POSIX may allow some grammars with type clashes.
	* src/reader.c (grammar_current_rule_check): Warn about
	type clashes instead of complaining.
	* tests/input.at (Type Clashes): Expect warnings, not complaints.

	Add Yacc library, since POSIX requires it.
	* doc/bison.texinfo (Yacc Library): New node.  Regenerate top menu.
	* lib/Makefile.am (lib_LIBRARIES, liby_a_SOURCES): New macros.
	* lib/main.c, lib/yyerror.c: New files.

	gram_error can be static; it need not be extern.
	* src/reader.h (gram_error): Remove decl.
	* src/parse-gram.y (gram_error): Now static.  Add static decl.
	(print_token_value): Omit parameter names from forward decl,
	for consistency.

2002-11-29  Paul Eggert  <eggert@twinsun.com>

	* doc/bison.texinfo: Emphasize that yylex and yyerror must
	be declared before being used.  E.g., one should typically
	declare them in the prologue.  Use GNU coding style in examples.
	Put "const" consistently after the type it modifies.  Mention
	that C99 supports "inline".  Mention that yyerror traditionally
	returns "int".

	%parse-param and %lex-param now take just one argument, the
	declaration; the argument name is deduced from the declaration.

	* doc/bison.texinfo (Parser Function, Pure Calling, Error
	Reporting, Table of Symbols): Document this.
	* src/parse-gram.y (add_param): New function.
	(COMMA): Remove.
	(declaration): Implement new rule for %parse-param and %lex-param.
	* src/scan-gram.l: "," now elicits a warning, rather than being
	a token; this is more compatible with byacc.
	* tests/calc.at (Simple LALR Calculator): Adopt new convention.

2002-11-27  Paul Eggert  <eggert@twinsun.com>

	Rename identifiers to avoid real and potential collisions.

	* data/c.m4 (b4_yysymprint_generate): yyout -> yyoutput,
	to avoid collision with lex macro described by Bruce Lilly in
	<http://mail.gnu.org/pipermail/bug-bison/2002-November/001929.html>.
	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR): Likewise.
	* doc/bison.texinfo (Prologue, Tracing): yyprint -> print_token_value.
	* src/parse-gram.y (print_token_value): Renamed from yyprint.
	All uses changed.
	(YYPARSE_PARAM, YYLEX_PARAM, yycontrol): Remove.  All uses changed.
	The name "yycontrol" violates the name space rules, and this stuff
	wasn't being used anyway.
	(input): Remove action; this stuff wasn't being used.
	(gram_error): Rename local variable yylloc -> loc.
	* src/reader.h (struct gram_control_s, gram_control_t): Remove.
	(YY_DECL): Don't use "yy" at start of local variables.
	All uses changed, e.g., yylloc -> loc.
	* src/scan-gram.l (STEP): Renamed from YY_STEP.  All uses changed.
	(STRING_GROW): Renamed from YY_OBS_GROW.  All uses changed.
	(STRING_FINISH): Renamed from YY_OBS_FINISH.  All uses changed.
	(STRING_FREE): Renamed from YY_OBS_FREE.  All uses changed.

	* src/parse-gram.y (gram_error): loc is now const *.
	* src/reader.h (gram_error): Likewise.

2002-11-24  Paul Eggert  <eggert@twinsun.com>

	Version 1.75c.

	* tests/actions.at (Actions after errors): Use an output format
	more similar to that of the Printers and Destructors test.
	Test the position of the ';' token too.
	(Printers and Destructors): Likewise.
	(Printers and Destructors: %glr-parser): Remove for now, to avoid
	unnecessarily alarming people when the test fails.

	* data/yacc.c (yyerrlab1): Move this label down, so that the
	parser does not discard the lookahead token if the user code
	invokes YYERROR.  This change is required for POSIX conformance.

	* lib/error.c: Sync with gnulib.

2002-11-22  Paul Eggert  <eggert@twinsun.com>

	* lib/quotearg.c, lib/quotearg.h: Sync with gnulib.
	* lib/mbswidth.c, lib/mbswidth.h: Likewise.
	* lib/xmalloc.c: Likewise.

2002-11-20  Paul Eggert  <eggert@twinsun.com>

	* lib/argmatch.c, lib/argmatch.h: Sync with gnulib.

2002-11-20  Paul Eggert  <eggert@twinsun.com>

	Avoid use of <assert.h>, as the GNU Coding Standards hint that one
	should use `if (! x) abort ();' rather than `assert (x);', and
	anyway it's one less thing to worry about configuring.

	* data/glr.c, lib/hash.c, src/system.h: Do not include <assert.h>.
	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR): Likewise,
	and replace all instances of assert with abort.
	* tests/calc.at (_AT_DATA_CALC_Y): Likewise.
	* tests/cxx-type.at (_AT_TEST_GLR_CXXTYPES): Likewise.

	* data/glr.c (yydoAction, yyglrReduce, yysplitStack, yyresolveStates,
	yyresolveAction, yyprocessOneStack): Use abort rather than assert.
	* lib/hash.c (hash_lookup, hash_get_first, hash_get_next,
	hash_find_entry, hash_rehash, hash_insert): Likewise.
	* src/conflicts.c (resolve_sr_conflict): Likewise.
	* src/lalr.c (set_goto_map, map_goto): Likewise.
	* src/nullable.c (nullable_compute): Likewise.
	* src/output.c (prepare_rules, token_definitions_output): Likewise.
	* src/reader.c (packgram, reader): Likewise.
	* src/state.c (state_new, state_free, state_transitions_set,
	state_reduction_find): Likewise.
	* src/symtab.c (symbol_user_token_number_set, symbol_make_alias,
	symbol_pack): Likewise.
	* src/tables.c (conflict_row, pack_vector): Likewise.
	* src/vcg.c (get_color_str, get_textmode_str, get_shape_str,
	get_layoutalgorithm_str, get_decision_str, get_orientation_str,
	get_node_alignement_str, get_arrow_mode_str, get_crossing_type_str,
	get_view_str, get_linestyle_str, get_arrowstyle_str): Likewise.

	* lib/argmatch.h (ARRAY_CARDINALITY): Do not bother to #undef.
	(ARGMATCH_CONSTRAINT): New macro.
	(ARGMATCH_ASSERT): Use it.

	* src/system.h (verify): New macro.
	* src/getargs.c (trace_argmatch, report_argmatch): Use verify
	rather than assert.
	* src/tables.c (tables_generate): Likewise.

	* src/struniq.c (struniq_assert): Now returns void, and aborts
	if the assertion is false.
	(struniq_assert_p): Remove.
	* src/struniq.h: Likewise.

2002-11-18  Paul Eggert  <eggert@twinsun.com>

	* data/glr.c (yygetLRActions): Replace `yyindex' with
	`yytable[yyindex]' to fix typo introduced in my 2002-11-09 patch.
	This fixes the regression with Sun ONE Studio 7 cc that I reported in
	<http://mail.gnu.org/pipermail/bug-bison/2002-November/001892.html>.

2002-11-18  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo (Tracing): `yyprint' shouldn't prepend a
	space.
	From Tim Van Holder.

2002-11-17  Paul Eggert  <eggert@twinsun.com>

	Pacify Sun ONE Studio 7 lint.  Also, rename "ParseError"
	to "SyntaxError" for consistency with my 2002-11-15 change.

	* data/glr.c (YYDPRINTF, YYDSYMPRINT, YYDSYMPRINTF) [!YYDEBUG]: Do
	not define to {}, since this breaks the common use of `YYDPRINTF
	((...));' if a single statement is desired (e.g. before `else').
	Work around GCC warnings by surrounding corresponding calls with
	{} if needed.
	(yyhasResolvedValue): Remove unused function.
	(yymergeOptionSets, yyresolvStack): Use `continue;' for empty
	loop body.
	(yyreportSyntaxError): Renamed from yyreportParseError.
	(yyrecoverSyntaxError): Renamed from yyrecoverParseError.
	All uses changed.
	* tests/calc.at (_AT_DATA_CALC_Y): Make vars static instead of
	extern when possible.  Remove unused initializations.

2002-11-16  Akim Demaille  <akim@epita.fr>

	Augment the similarity between GLR and LALR traces.

	* data/yacc.c (yy_stack_print, YY_STACK_PRINT, yy_reduce_print)
	(YY_REDUCE_PRINT): New.
	(yyparse): Use them.
	* data/glr.c (yy_reduce_print): Use YYFPRINTF, no need for
	YYDPRINT here.
	(yyglrReduce, yyrecoverParseError, yyparse): Don't report the
	state reached after the reduction/recovery, since...
	(yyparse, yyprocessOneStack): Report the state we are entering in.

2002-11-16  Akim Demaille  <akim@epita.fr>

	* src/getargs.h, src/getargs.c (trace_e, trace_args, trace_types):
	Add support for --trace=skeleton.
	* src/scan-skel.l: %option debug.
	Scan strings of non-@ or \n instead of character by character.
	(scan_skel): Handle trace_skeleton.
	(QPUTS): New.
	(@output_parser_name@, @output_header_name@): ``Restore'' their
	support (used to be M4 macros).
	* data/yacc.c: Quote larger chunks, a la glr.c.
	* data/lalr1.cc: Likewise.
	The header guards are no longer available, so use some other
	string than `YYLSP_NEEDED'.

2002-11-16  Akim Demaille  <akim@epita.fr>

	Make the ``Printers and Destructors'' test more verbose, taking
	`yacc.c''s behavior as (possibly wrong) reference.

	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR): Use printf
	instead of fprint on stdout.
	Set and report the last_line of the symbols.
	Consistently display values and locations.

2002-11-16  Paul Eggert  <eggert@twinsun.com>

	* data/yacc.c: Avoid over-quoting of __line__ and __file__.

2002-11-15  Paul Eggert  <eggert@twinsun.com>

	* tests/actions.at (Actions after errors): New test case.

	* data/glr.c, data/lalr1.cc, data/yacc.cc, doc/bison.texinfo,
	src/conflicts.c, src/parse-gram.y, src/tables.c, src/tables.h,
	tests/action.at, tests/calc.at, tests/conflicts.at,
	tests/cxx-type.at, tests/regression.at:
	"parse error" -> "syntax error" for POSIX compatibility.
	"parsing stack overflow..." -> "parser stack overflow" so
	that code matches Bison documentation.

2002-11-15  Akim Demaille  <akim@epita.fr>

	* src/parse-gram.y (declaration): Have %parse-param and %lex-param
	take two BRACED_CODE, not two string_content.
	Free the scanner's obstack when we are done.
	(code_content): New.
	* tests/calc.at: Adjust.
	* doc/bison.texinfo: Adjust.
	Also, make sure to include the `,' for these declarations.

2002-11-15  Tim Van Holder  <tim.van.holder@pandora.be>

	* m4/prereq.m4: Removed the commented jm_PREREQ_HASH
	definition; avoids potential autoreconf problems.

2002-11-15  Akim Demaille  <akim@epita.fr>

	Always check the value returned by yyparse.

	* tests/calc.at (_AT_DATA_CALC_Y): Have `main' exit with the value
	returned by yyparse.
	(_AT_CHECK_CALC_ERROR): Take the expected exit value as argument.
	Adjust calls.
	* tests/glr-regr1.at (glr-regr1.y): Have `main' exit with the value
	returned by yyparse.

2002-11-14  Paul Hilfinger  <Hilfinger@CS.Berkeley.EDU>

	* data/glr.c (yyFail): Always set yyerrflag.  Corrects regression
	on input.at test.

2002-11-14  Paul Eggert  <eggert@twinsun.com>

	* src/output.c (output_skeleton): Call xfopen instead of
	duplicating xfopen's body.

	Fix bugs reported by Nelson H. F. Beebe in
	<http://mail.gnu.org/pipermail/bug-bison/2002-November/001893.html>.

	* tests/headers.at (AT_TEST_CPP_GUARD_H): Don't assume that
	"$CC -E foo.h" is allowed, as this doesn't work with the Portland
	Group compiler.  Instead, use "$CC -E bar.c".  Include the .h
	file twice in the grammar, as an extra check.

	* tests/input.at (Torturing the Scanner): Surround the
	backslash-newline tests with "#if 0", to make it less likely that
	we'll run into compiler bugs.  Bring back solitary \ inside
	comment, but add a closing comment to work around HP C bug.  Don't
	test backslash-newline in C character constant.  This should fix
	the input.at bug reported by Nelson H. F. Beebe in
	<http://mail.gnu.org/pipermail/bug-bison/2002-November/001893.html>.

2002-11-14  Akim Demaille  <akim@epita.fr>

	* tests/synclines.at (AT_SYNCLINES_COMPILE): Ignore the exit
	status of the compiler.
	Calling `exit 1' is no longer needed.
	Reported by Nelson H. F. Beebe.

2002-11-14  Akim Demaille  <akim@epita.fr>

	* tests/atlocal.in (CPPFLAGS): We have config.h.
	* tests/testsuite.at (AT_DATA_GRAMMAR_PROLOGUE, AT_DATA_GRAMMAR):
	New.
	* tests/actions.at, tests/calc.at, tests/conflicts.at,
	* tests/cxx-type.at, tests/glr-regr1.at, tests/headers.at,
	* tests/regression.at, tests/torture.at: Use them for all the
	grammars that are to be compiled.
	* tests/cxx-type.at (_AT_TEST_GLR_CALC): Rename as...
	* tests/cxx-type.at (_AT_TEST_GLR_CXXTYPES): this.
	* doc/bison.texinfo (GLR Parsers): Document `inline'.

2002-11-14  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo: Various formatting changes (alignments in
	samples, additional @group/@end group, GCS in samples.
	Use @deffn instead of simple @table to define the directives,
	macros, variables etc.

2002-11-13  Paul Eggert  <eggert@twinsun.com>

	Fix some bugs reported by Albert Chin-A-Young in
	<http://mail.gnu.org/pipermail/bug-bison/2002-November/001881.html>.

	* tests/input.at (Torturing the Scanner): Don't invoke "cc a.c b.c
	-o c"; the HP C compiler chatters during compilation.
	Instead, invoke "cc -c a.c -o a.o; cc -c b.c -o b.o; cc a.o b.o -o c".
	* tests/headers.at (export YYLTYPE): Likewise.

	* tests/input.at (Torturing the Scanner): Remove lines containing
	solitary backslashes, as they tickle a bug in the HP C compiler.

	* tests/glr-regr1.at (Badly Collapsed GLR States): Avoid //
	comments, since they're not portable.  Use GNU coding style.

2002-11-13  Akim Demaille  <akim@epita.fr>

	* data/yacc.c: Leave bigger chunks of quoted text.
	(YYDSYMPRINTF): New.
	Use it to report symbol activities.
	* data/glr.c (YYDSYMPRINTF): New.
	Use it.

2002-11-12  Paul Eggert  <eggert@twinsun.com>

	Version 1.75b.

	* data/glr.c (yydoAction): Return YYRESULTTAG, not int.
	(yyglrReduce): Return yyok, not 0.
	This should avoid the enumerated-type warnings reported
	by Nelson H.F. Beebe in
	<http://mail.gnu.org/pipermail/bug-bison/2002-November/001872.html>.

	* lib/bbitset.h (BITSET_INLINE): Remove.
	* lib/bitset.h [! BITSET_INLINE]: Remove.
	(bitset_set, bitset_reset, bitset_test): Rename local vars
	to avoid shadowing warnings by GCC.

	* data/glr.c (inline): Remove #define.  It's the user's
	responsibility to #define it away, just like 'const'.
	This fixes one of the bugs reported by Nelson H.F. Beebe in
	<http://mail.gnu.org/pipermail/bug-bison/2002-November/001873.html>.

	* Makefile.maint (po-check): Scan .l and .y files instead of the
	.c and the .h files that they generate.  This fixes the bug
	reported by Tim Van Holder in:
	<http://mail.gnu.org/pipermail/bison-patches/2002-November/001352.html>
	Look for N_ as well as for _.  Try to avoid matching #define for
	N_ and _.
	* po/POTFILES.in: Remove src/parse-gram.c, src/scan-gram.c,
	src/system.h.  Add src/parse-gram.y, src/scan-gram.l.
	* src/scan-gram.l: Revamp regular expressions so that " and '
	do not confuse xgettext.

	* src/struniq.h (struniq_new): Do not declare the return type
	to be 'const'; this violates the C standard.
	* src/struniq.c (struniq_new): Likewise.

2002-11-12  Albert Chin-A-Young <china@thewrittenword.com>

	* src/Makefile.am (LDADD): Link $(LIBINTL) last to avoid the
	duplicate definition of optind on Tru64 UNIX 4.0D with the Compaq
	linker.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* Makefile.maint: Sync with Autoconf:
	(local_updates): New.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* po/POTFILES.in (src/lalr.c, src/state.c): Remove

2002-11-12  Akim Demaille  <akim@epita.fr>

	* tests/actions.at (_AT_CHECK_PRINTER_AND_DESTRUCTOR): Display the
	locations.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* data/c.m4 (b4_yysymprint_generate): Pass *yyvaluep to YYPRINT,
	not yyvalue.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* tests/actions.at (AT_CHECK_PRINTER_AND_DESTRUCTOR): New.
	Use it to test the GLR parser.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* tests/regression.at (input.y): s/YYEOF/MYEOF/, as the skeleton
	defines it.
	* data/glr.c (yystos): New.
	(b4_yysymprint_generate, b4_yydestruct_generate): Invoke.
	(YYDSYMPRINT): New.
	(yyval): Don't define it, it is handled via M4.
	(yyrecoverParseError): Free verbosely the discarded symbols.
	* data/yacc.c (yysymprint): Remove, rather...
	(b4_yysymprint_generate): invoke.
	* data/c.m4 (b4_yysymprint_generate): New.
	Accept pointers as arguments, as opposed to the version from
	yacc.c.
	(b4_yydestruct_generate): Likewise.
	* tests/cations.at (Printers and Destructors): Use Bison directives
	instead of CPP macros.
	Don't rely on internal details.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* data/c.m4 (b4_yydestruct_generate, b4_symbol_actions): New.
	* data/yacc.c: Rename yychar1 as yytoken, as in glr.c.
	Don't work on yychar (i.e., do set it to YYEMPTY, don't match
	it against YYEMPTY and so forth), work on yytoken (i.e., set
	it to YYEMPTY etc.).
	(yydestruct): Replace with a b4_yydestruct_generate invocation.
	(b4_symbol_actions): Remove.
	* data/glr.c (YYTRANSLATE): As for yacc.c, if negative, it stands
	for 0, end-of-input.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo (Destructor Decl): New.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* src/tables.c (tables_generate): Use free for pointers that
	cannot be NULL, not XFREE.
	(pack_vector): Use assert, not fatal, for bound violations.
	* src/state.c (state_new): Likewise.
	* src/reader.c (reader): Likewise.
	* src/lalr.c (set_goto_map): Likewise.
	* src/location.h (LOCATION_PRINT): If first_line is 0, just issue
	the file name.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* src/scan-gram.l, src/reader.h (scanner_last_string_free):
	Restore.
	* src/scan-gram.l (last_string): Is global to the file, not to
	yylex.
	* src/parse-gram.y (input): Don't append the epilogue here,
	(epilogue.opt): do it here, and free the scanner's obstack.
	* src/reader.c (epilogue_set): Rename as...
	(epilogue_augment): this.
	* data/c.m4 (b4_epilogue): Defaults to empty.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* src/getargs.c (long_options): Remove duplicates.
	* src/vmsgetargs.c, src/build.com, src/bison.cld, src/vmshlp.mar:
	Remove.
	* doc/bison.rnh: Remove.
	* doc/bison.texinfo (VMS Invocation): Remove.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* src/struniq.h, src/struniq.c (struniq_t): Is const.
	(STRUNIQ_EQ, struniq_assert, struniq_assert_p): New.

	Use struniq for symbols.

	* src/symtab.h (symbol_t): The tag member is a struniq.
	(symbol_type_set): Adjust.
	* src/symtab.c (symbol_new): Takes a struniq.
	(symbol_free): Don't free the tag member.
	(hash_compare_symbol_t, hash_symbol_t): Rename as...
	(hash_compare_symbol, hash_symbol): these.
	Use the fact that tags as struniqs.
	(symbol_get): Use struniq_new.
	* src/symlist.h, src/symlist.c (symbol_list_n_type_name_get):
	Returns a strniq.
	* src/reader.h (merger_list, grammar_currentmerge_set): The name
	and type members are struniqs.
	* src/reader.c (get_merge_function)
	(grammar_current_rule_merge_set): Adjust.
	(TYPE, current_type): Are struniq.

	Use struniq for file names.

	* src/files.h, src/files.c (infile): Split into...
	(grammar_file, current_file): these.
	* src/scan-gram.c (YY_USER_INIT, handle_syncline): Adjust.
	* src/reduce.c (reduce_print): Likewise.
	* src/getargs.c (getargs): Likewise.
	* src/complain.h, src/complain.c: Likewise.
	* src/main.c (main): Call struniqs_new early enough to use it for
	file names.
	Don't free the input file name.

2002-11-12  Akim Demaille  <akim@epita.fr>

	* src/symtab.c (symbol_free): Remove dead deactivated code:
	type_name are properly removed.
	Don't use XFREE to free items that cannot be NULL.
	* src/struniq.h, src/struniq.c: New.
	* src/main.c (main): Initialize/free struniqs.
	* src/parse-gram.y (%union): Add astruniq member.
	(yyprint): Adjust.
	* src/scan-gram.l (<{tag}>): Return a struniq.
	Free the obstack bit that used to store it.
	* src/symtab.h (symbol_t): The 'type_name' member is a struniq.

2002-11-11  Paul Eggert  <eggert@twinsun.com>

	Revamp to fix many (but not all) of the C- and M4-related quoting
	problems.  Among other things, this fixes the Bison bug reported
	by Jan Hubicka when processing the Bash grammar; see:
	<http://mail.gnu.org/pipermail/bison-patches/2002-November/001329.html>

	Use new @ escapes consistently.  Represent brackets with @{ and @}
	rather than @<:@ and @:>@, since this works a bit better with dumb
	editors like vi.  Represent @ with @@, since @ is now consistently
	an escape.  Use @oline@ and @ofile@ rather than __oline__ and
	__ofile__, to avoid unexpected expansions.  Similarly, use @output
	rather than #output.

	* data/c.m4 (b4_copyright): Omit file name from comment, since
	the file name could contain "*/".
	(b4_synclines_flag): Don't quote the 2nd argument; it should already
	be quoted.  All uses changed.

	* data/glr.c: Use new @ escapes consistently.
	(b4_input_suffix, b4_output_parser_suffix, b4_output_parser_name,
	b4_output_header_suffix, b4_output_header_name, b4_header_guard):
	Remove, since they couldn't handle arbitrary characters in file
	names.
	* data/lalr1.cc: Likewise.
	* data/yacc.c: Likewise.

	* src/files.c (output_infix): Remove; all uses removed.
	* src/files.h: Likewise.

	* data/glr.c: Remove use of "#ifdef b4_header_guard", since it
	mishandled funny characters in file names, and anyway it isn't
	needed any more.
	* data/yacc.c: Likewise.
	* data/lalr1.cc: Use YYSLP_NEEDED instead of b4_header_guard.

	* data/glr.c (YYSTYPE_IS_TRIVIAL): Define when the .h file would.
	* data/yacc.c: Likewise.

	* src/muscle_tab.c: Include quotearg.h, since we need to quote C
	strings now.
	(muscle_init): Quote filename as a C string.
	* src/muscle_tab.h (MUSCLE_GROW_STRING_PAIR): Remove; unused.
	(MUSCLE_OBSTACK_SGROW, MUSCLE_INSERT_C_STRING): New macros.
	* src/output.c (escaped_file_name_output): New function.
	(prepare_symbols): Quote tokens for M4.
	(prepare): Don't insert output_infix, output_prefix,
	output_parser_name, output_header_name; this is now down by scan-skel.
	Insert skeleton as a C string.

	* src/output.c (user_actions_output, symbol_destructors_output,
	symbol_printers_output): Quote filenames for C and M4.
	* src/reader.c (prologue_augment, epilogue_set): Likewise.

	* src/scan-gram.l (<SC_CHARACTER>): Don't worry about any backslash
	escapes other than \\ and \'; this simplifies the code.
	(<SC_STRING>): Likewise, for \\ and \".
	(<SC_COMMENT,SC_LINE_COMMENT,SC_STRING,SC_CHARACTER,SC_BRACED_CODE,
	SC_PROLOGUE,SC_EPILOGUE>): Escape $ and @, too.
	Use new escapes @{ and @} for [ and ].

	* src/scan-skel.l (yylineno, yyoutname): Remove static vars, replacing
	them with auto vars.
	Switch to new escape scheme, where @ is the escape character uniformly.
	Abort if a stray escape character is found.  Avoid unbounded input
	buffer when parsing non-escaped text.

	* tests/input.at (Torturing the Scanner): Add tests that @oline@,
	__oline__, #output, $@, and @{ do not have unintended meanings.

2002-11-09  Paul Eggert  <eggert@twinsun.com>

	Fix the test failure due to GCC warnings described in
	<http://mail.gnu.org/pipermail/bug-bison/2002-November/001815.html>.
	* data/glr.c (yyis_pact_ninf, yyis_table_ninf): New macros, which
	evaluate to 0 if it's impossible for NINF to be in the respective
	table.
	(yygetLRActions, yyrecoverParseError): Use them.

	* src/scan-gram.l (unexpected_end_of_file): Fix bug: columns were
	counted in the token inserted at end of file.  Now takes
	location_t *, not location_t, so that the location can be
	adjusted.  All uses changed.

	* tests/regression.at (Invalid inputs): Adjust wording in
	diagnostic to match the new behavior.

	* tests/torture.at (AT_DATA_TRIANGULAR_GRAMMAR,
	AT_DATA_HORIZONTAL_GRAMMAR, AT_DATA_LOOKAHEADS_GRAMMAR,
	AT_DATA_STACK_TORTURE): Replace `assert (x);' with `if (! (x))
	abort ();'.  This reduces the runtime of the "Many lookaheads"
	test from 27.6 to 2.7 minutes on a 440 MHz Ultrasparc III running
	GCC 3.2.

2002-11-07  Paul Eggert  <eggert@twinsun.com>

	* src/parse-gram.y (CHARACTER): Remove unused token.
	All uses removed.

	* src/scan-gram.l: Remove stack option.  We no longer use the
	stack, since the stack was never deeper than 1; instead, use the
	new auto var c_context to record the stacked value.

	Remove nounput option.  At an unexpected end of file, we now unput
	the minimal input necessary to end cleanly; this simplifies the
	code.

	Avoid unbounded token sizes where this is easy.

	(unexpected_end_of_file): New function.
	Use it to systematize the error message on unexpected EOF.
	(last-string): Now auto, not static.
	(YY_OBS_FREE): Remove unnecessary do while (0) wrapper.
	(scanner_last_string_free): Remove; not used.
	(percent_percent_count): Move decl to just before use.
	(SC_ESCAPED_CHARACTER): Return ID at unexpected end of file,
	not the (never otherwised-used) CHARACTER.

2002-11-07  Akim Demaille  <akim@epita.fr>

	Let yyerror always receive the msg as last argument, so that
	yyerror can be variadic.

	* data/yacc.c (b4_yyerror_args): New.
	Use it when calling yyerror.
	* data/glr.c (b4_yyerror_args, b4_lyyerror_args): New.
	Use it when calling yyerror.
	* doc/bison.texinfo (Error Reporting): Adjust.
	* tests/calc.at (_AT_DATA_CALC_Y): Adjust.
	* tests/cxx-type.at (_AT_TEST_GLR_CALC): Adjust.

2002-11-06  Akim Demaille  <akim@epita.fr>

	#line should have quoted strings.
	Ideally, this should be done by m4_quotearg.

	* src/scan-skel.l: Include quotearg.h.
	Quote __ofile__.
	* src/output.c (symbol_printers_output)
	(symbol_destructors_output): Quote the file name.

2002-11-06  Akim Demaille  <akim@epita.fr>

	* tests/regression.at (Invalid inputs): Adjust to the recent
	messages.

2002-11-06  Akim Demaille  <akim@epita.fr>

	Restore --no-lines.
	Reported by Jim Kent.

	* data/c.m4 (b4_syncline): New.
	* data/glr.c, data/yacc.c, data/lalr1.cc: Use it.
	* src/reader.c (prologue_augment, epilogue_set): Use b4_syncline.
	* src/output.c (user_actions_output): Likewise.
	(prepare): Define 'b4_synclines_flag'.
	* src/muscle_tab.c (muscle_init): Don't define b4_linef.

2002-11-06  Akim Demaille  <akim@epita.fr>

	* src/main.c (main): Free `infile'.
	* src/scan-gram.l (handle_syncline): New.
	Recognize `#line'.
	* src/output.c (user_actions_output, symbol_destructors_output)
	(symbol_printers_output): Use the location's file name, not
	infile.
	* src/reader.c (prologue_augment, epilogue_set): Likewise.

2002-11-05  Paul Hilfinger  <Hilfinger@CS.Berkeley.EDU>

	* src/tables.c (matching_state): Don't allow states to match if
	either has GLR conflict entries.

2002-11-05  Paul Eggert  <eggert@twinsun.com>

	* src/scan-gram.l: Use more accurate diagnostics, e.g.
	"integer out of range" rather than "invalid value".
	* tests/input.at (Invalid $n, Invalid @n): Change expected wording
	accordingly.

	Scan <% and %> digraphs in C code as POSIX 1003.1-2001 requires.
	Also, remove one static variable in the scanner.

	* src/scan-gram.l (braces_level): Now auto, not static.
	Initialize to zero if the compiler is being picky.
	(INITIAL): Clear braces_level instead of incrementing it.
	(SC_BRACED_CODE): Treat <% and %> as { and } when inside C code,
	as POSIX 1003.1-2001 requires.
	* src/system.h (IF_LINT): New macro, taken from coreutils.
	* configure.ac: Define "lint" if --enable-gcc-warnings.

2002-11-05  Akim Demaille  <akim@epita.fr>

	* src/scan-gram.l: When it starts with `%', complain about the
	whole directive, not just that `invalid character: %'.

2002-11-04  Akim Demaille  <akim@epita.fr>

	* Makefile.maint: Update from Autoconf.
	(update, cvs-update, po-update, do-po-update): New.

2002-11-04  Akim Demaille  <akim@epita.fr>

	* tests/glr-regr1.at (Badly Collapsed GLR States): Prototype yylex
	and yyerror.
	Have yyerror `use' its arguments.
	* tests/calc.at (AT_CHECK_PUSHDEFS): AT_YYERROR_SEES_LOC_IF
	returns true when location & yacc & pure & parse-param.
	(_AT_DATA_CALC_Y): Let yyerror ``use'' its arguments.

2002-11-04  Akim Demaille  <akim@epita.fr>

	* src/location.h (LOCATION_PRINT): Use quotearg slot 3 to avoid
	clashes.
	* src/scan-gram.l: Use [\'] instead of ['] to pacify
	font-lock-mode.
	Use complain_at.
	Use quote, not quote_n since LOCATION_PRINT no longer uses the
	slot 0.

2002-11-03  Paul Eggert  <eggert@twinsun.com>

	* src/reader.c (get_merge_function, grammar_current_rule_check):
	Use consistent diagnostics for reporting type name clashes.
	Quote the types with <>, for consistency with Yacc.
	* tests/input.at (Type Clashes): Adjust to diagnostic changes.

2002-11-03  Akim Demaille  <akim@epita.fr>

	* data/c.m4 (b4_identification, b4_user_args, b4_parse_param):
	New.
	* data/yacc.m4 (b4_pure_args, b4_Pure_args): New.
	(b4_parse_param): Remove.
	Use b4_identification.
	Propagate b4_pure_args where needed to pass them to yyerror.
	* data/glr.m4 (b4_parse_param): Remove.
	(b4_user_formals, b4_pure_args, b4_pure_formals, b4_lpure_args)
	(b4_lpure_formals): New.
	Use b4_identification.
	(YY_USER_FORMALS, YY_USER_ARGS): Remove, replaced by
	b4_user_formals and b4_user_args.
	(yyexpandGLRStack, yyFail, yyaddDeferredAction, yyglrShiftDefer)
	(yyreportAmbiguity): When using a pure parser, also need
	the location, and the parse-params.
	Adjust callers.
	(yyuserAction, yyglrShift, yyreportParseError, yyrecoverParseError):
	When using a pure parser, also need the parse-params.
	Adjust callers.
	* tests/calc.at: Test pure (%pure-parser) and absolutely pure
	(%pure-parser + %parse-param) LALR and GLR parsers.
	(AT_CHECK_PUSHDEFS, AT_CHECK_POPDEFS): New, define AT_PARAM_IF,
	AT_LOCATION_IF, AT_PURE_IF, AT_GLR_IF, AAT_PURE_AND_LOC_IF,
	AT_GLR_OR_PARAM_IF, AT_YYERROR_ARG_LOC_IF, AT_YYERROR_SEES_LOC_IF.
	(_AT_DATA_CALC_Y): Equip for purity of yyerror.
	(_AT_CHECK_CALC_ERROR): Use AT_YYERROR_SEES_LOC_IF.
	* tests/cxx-type.at (_AT_TEST_GLR_CALC): Equip for yyerror purity.
	* doc/bison.texinfo: Untabify the whole file.
	(Parser Function): Document %parse-param, deprecate YYPARSE_PARAM.
	(Pure Calling): Document %lex-param, deprecate YYLEX_PARAM.
	(Error Reporting): Adjust to these new directives.
	Document %error-verbose, deprecate YYERROR_VERBOSE.

2002-11-03  Akim Demaille  <akim@epita.fr>

	* tests/calc.at: Change all the AT_CHECK_CALC_LALR and
	AT_CHECK_CALC_GLR invocations to use % directives, instead of
	command line options.
	* tests/cxx-type.at: Formatting changes.

2002-11-03  Paul Eggert  <eggert@twinsun.com>

	* src/scan-gram.l: Revamp to fix POSIX incompatibilities,
	to count columns correctly, and to check for invalid inputs.

	Use mbsnwidth to count columns correctly.  Account for tabs, too.
	Include mbswidth.h.
	(YY_USER_ACTION): Invoke extend_location rather than LOCATION_COLUMNS.
	(extend_location): New function.
	(YY_LINES): Remove.

	Handle CRLF in C code rather than in Lex code.
	(YY_INPUT): New macro.
	(no_cr_read): New function.

	Scan UCNs, even though we don't fully handle them yet.
	(convert_ucn_to_byte): New function.

	Handle backslash-newline correctly in C code.
	(SC_LINE_COMMENT, SC_YACC_COMMENT): New states.
	(eols, blanks): Remove.  YY_USER_ACTION now counts newlines etc.;
	all uses changed.
	(tag, splice): New EREs.  Do not allow NUL or newline in tags.
	Use {splice} wherever C allows backslash-newline.
	YY_STEP after space, newline, vertical-tab.
	("/*"): BEGIN SC_YACC_COMMENT, not yy_push_state (SC_COMMENT).

	(letter, id): Don't assume ASCII; e.g., spell out a-z.

	({int}, handle_action_dollar, handle_action_at): Check for integer
	overflow.

	(YY_STEP): Omit trailing semicolon, so that it's more like C.

	(<SC_ESCAPED_STRING,SC_ESCAPED_CHARACTER>): Allow \0 and \00
	as well as \000.  Check for UCHAR_MAX, not 255.
	Allow \x with an arbitrary positive number of digits, as in C.
	Check for overflow here.
	Allow \? and UCNs, for compatibility with C.

	(handle_symbol_code_dollar): Use quote_n slot 1 to avoid collision
	with quote slot used by complain_at.

	* tests/input.at: Add tests for backslash-newline, m4 quotes
	in symbols, long literals, and funny escapes in strings.

	* configure.ac (jm_PREREQ_MBSWIDTH): Add.
	* lib/Makefile.am (libbison_a_SOURCES): Add mbswidth.h, mbswidth.c.
	* lib/mbswidth.h, lib/mbswidth.c: New files, from GNU gettext.
	* m4/Makefile.am (EXTRA_DIST): Add mbswidth.m4.
	* m4/mbswidth.m4: New file, from GNU coreutils.

	* doc/bison.texinfo (Grammar Outline): Document // comments.
	(Symbols): Document that trigraphs have no special meaning in Bison,
	nor is backslash-newline allowed.
	(Actions): Document that trigraphs have no special meaning.

	* src/location.h (LOCATION_COLUMNS, LOCATION_LINES): Remove;
	no longer used.

2002-11-02  Paul Eggert  <eggert@twinsun.com>

	* src/reader.c: Don't include quote.h; not needed.
	(get_merge_function): Reword warning to be consistent with
	type clash diagnostic in grammar_current_rule_check.

	* lib/quotearg.c (quotearg_buffer_restyled): Fix off-by-two
	bug in trigraph handling.

	* src/output.c (prepare_symbols): When printing token names,
	escape "[" as "@<:@" and likewise for "]".

	* src/system.h (errno): Remove declaration, as we are now
	assuming C89 or better, and C89 guarantees errno.

2002-10-30  Paul Eggert  <eggert@twinsun.com>

	* lib/bitset_stats.c (bitset_stats_read, bitset_stats_write):
	Check for close failures.
	* src/files.h (xfclose): Return void, not int, since it always
	returned zero.
	* src/files.c (xfclose): Likewise.  Report I/O error if ferror
	indicates one.
	* src/output.c (output_skeleton): Use xfclose rather than fclose
	and ferror.  xfclose now checks ferror.

	* data/glr.c (YYLEFTMOST_STATE): Remove.
	(yyreportTree): Use a stack-based leftmost state.  This avoids
	our continuing battles with bogus warnings about initializers.

2002-10-30  Akim Demaille  <akim@epita.fr>

	* src/system.h: Don't use #ifdef/#ifndef on HAVE_ values, only
	#if.

2002-10-29  Paul Hilfinger  <Hilfinger@CS.Berkeley.EDU>

	* tests/glr-regr1.at: New test for reported regressions.
	* tests/testsuite.at: Add glr-regr1.at test.
	* tests/Makefile.am: Add glr-regr1.at test.

2002-10-24  Paul Eggert  <eggert@twinsun.com>

	Version 1.75a.

	* tests/calc.at (_AT_DATA_CALC_Y): Remove unused strcat declaration.
	* tests/cxx-type.at (_AT_TEST_GLR_CALC): Include stdlib.h, since
	we use malloc.  Don't assume 'A' through 'Z' are contiguous.
	Don't assume strdup exists; POSIX says its an XSI extension.
	Check for buffer overflow on input.

2002-10-24  Akim Demaille  <akim@epita.fr>

	* src/output.c (output_skeleton): Don't disable M4sugar comments
	too soon: it results in comments being expanded.
	* data/yacc.c, data/glr.c, data/lalr1.cc: Do it right before the
	first output.

2002-10-24  Akim Demaille  <akim@epita.fr>

	* data/yacc.c (m4_int_type): New.
	* data/c.m4 (m4_int_type): Don't use yysigned_char, but `signed
	char' as only yacc.c wants K&R portability.
	* data/glr.c (yysigned_char): Remove.
	* data/lalr1.cc: Rename the trailing b4_name as b4_parser_class_name.
	Reported by Quoc Peyrot.

2002-10-23  Paul Eggert  <eggert@twinsun.com>

	* src/main.c (main): With --trace=time, report times even if a
	non-fatal error occurs.  Formerly, the times were reported in some
	such cases but not in others.
	* src/reader.c (reader): Just return if a complaint has been issued,
	instead of exiting, so that 'main' can report times.

2002-10-22  Akim Demaille  <akim@epita.fr>

	* src/system.h: Include sys/types.
	Reported by Bert Deknuydt.

2002-10-23  Paul Eggert  <eggert@twinsun.com>

	* configure.ac (AC_PROG_LEX): Use instead of AM_PROG_LEX.
	Suggested by Art Haas.

2002-10-22  Paul Eggert  <eggert@twinsun.com>

	* src/complain.c (exit) [! (STDC_HEADERS || _LIBC)]: Remove exit
	decl; not needed any more.
	* src/main.c (main): Use return to exit, undoing yesterday's change.
	The last OS that we could find where this wouldn't work is
	SunOS 3.5, and that's too old to worry about now.

	* data/glr.c (struct yyltype): Define members even when not
	doing locations.  This is more consistent with yacc.c, and it
	works around the following bug reports:
	http://mail.gnu.org/pipermail/bug-bison/2002-October/001764.html
	http://mail.gnu.org/pipermail/bug-bison/2002-October/001769.html
	and I hope it also fixes this bug report:
	http://mail.gnu.org/pipermail/bug-bison/2002-October/001748.html

	* doc/bison.texinfo: Minor spelling and typographical fixes.  Use
	@acronym consistently.  Standardize on "Yacc" instead of "YACC",
	"Algol" instead of "ALGOL".  Give a bit more history about BNF.

2002-10-22  Akim Demaille  <akim@epita.fr>

	* data/README: New.

2002-10-21  Paul Eggert  <eggert@twinsun.com>

	Be consistent about 'bool'; the old code used an enum in one
	module and an int in another, and this violates the C standard.
	* m4/stdbool.m4: New file, from coreutils 4.5.3.
	* configure.ac (AC_HEADER_STDBOOL): Add.
	* m4/Makefile.am (EXTRA_DIST): Add stdbool.m4.
	* src/muscle_tab.c (hash_compare_muscles): (a ? FALSE : TRUE) -> (! a)
	* src/symtab.c (hash_compare_symbol_t): Likewise.
	* src/system.h (bool, false, true): Use a definition consistent
	with ../lib/hash.c.  All uses changed.

	* src/complain.c (warning_issued): Renamed from warn_message_count,
	so that we needn't worry about integer overflow (!).
	Now of type bool.  All uses changed.
	(complaint_issued): Renamed from complain_message_count; likewise.

	* src/main.c (main): Use exit to exit with failure.

	* src/complain.c (fatal_at, fatal): Use EXIT_FAILURE and EXIT_SUCCESS
	rather than 1 and 0.
	* src/main.c (main): Likewise.
	* src/getargs.c (getargs): Likewise.
	* src/reader.c (reader): Likewise.

	* src/getarg.c (getargs): Remove duplicate code for
	"Try `bison --help'".

	* src/files.c (xfopen, xfclose): Use EXIT_FAILURE rather than 2.
	What was that "2" for?

	* src/complain.h (fatal, fatal_at): Add __attribute__((__noreturn__)).
	* src/getargs.c (usage): Likewise.

	* src/getargs.c (getargs): When there are too few operands, report
	the last one.  When there are too many, report the first extra
	one.  This is how diffutils does it.

2002-10-20  Paul Eggert  <eggert@twinsun.com>

	Remove K&R vestiges.
	* configure.ac (AC_C_CONST, AM_C_PROTOTYPES): Remove.
	* src/complain.c (VA_START): Remove.  Assume prototypes.
	(vfprintf) [! (HAVE_VPRINTF || defined vfprintf)]: New macro.
	(private_strerror, warn_at, warn, complain_at, complain, fatal_at,
	fatal): Assume prototypes.
	* src/complain.h: Assume prototypes.
	* src/system.h (PARAMS): Remove.
	Include <limits.h> unconditionally, since it's guaranteeed even
	for a freestanding C89 compiler.
	(SHRT_MIN, SHRT_MAX): Remove, since C89 guarantees them.
	* src/vmsgetargs.c (getargs, cli_present, cli_get_value): Prototype.

2002-10-20  Akim Demaille  <akim@epita.fr>

	* src/muscle_tab.c (muscle_grow): Remove trailing debugging code.
	* data/glr.c (YY_USER_FORMALS, YY_USER_ARGS): New.
	(yyuserAction, yydoAction, yyglrReduce, yyresolveValue)
	(yyresolveStates, yyresolveAction, yyresolveStack)
	(yyprocessOneStack): Use them.
	(yy_reduce_print): New.
	* tests/calc.at (_AT_DATA_CALC_Y): Exercise %parse-param.

2002-10-20  Akim Demaille  <akim@epita.fr>

	* data/c.m4 (b4_c_ansi_args): Recognize functions with no
	arguments and output `void'.
	(b4_c_function): Rename as...
	(b4_c_function_def): this.
	(b4_c_function_decl, b4_c_ansi_function_def)
	(b4_c_ansi_function_decl): New.
	Change the interpretation of the arguments: before `int, foo', now
	`int foo, foo'.
	* data/yacc.c (yyparse): Prototype and define thanks to these.
	Adjust b4_c_function_def uses.
	* data/glr.c (yyparse): Likewise, but ANSI only.

2002-10-20  Akim Demaille  <akim@epita.fr>

	* src/output.c (prepare): Move the definition of `tokens_number',
	`nterms_number', `undef_token_number', `user_token_number_max'
	to...
	(prepare_tokens): Here.
	(prepare_tokens): Rename as...
	(prepare_symbols): this.
	(prepare): Move the definition of `rules_number' to...
	(prepare_rules): here.
	(prepare): Move the definition of `last', `final_state_number',
	`states_number' to...
	(prepare_states): here.
	* data/yacc.c, data/lalr1.cc, data/glr.c: Normalize `>' into `<'.

2002-10-20  Akim Demaille  <akim@epita.fr>

	* src/tables.h, src/tables.c, src/output.c: Comment changes.

2002-10-20  Akim Demaille  <akim@epita.fr>

	* data/yacc.c, data/yacc.c (b4_location_if, b4_pure_if): Move to...
	* data/c.m4: here.

2002-10-20  Akim Demaille  <akim@epita.fr>

	* src/output.c (prepare): Use MUSCLE_INSERT_STRING.
	* src/muscle_tab.c (muscle_pair_list_grow): Rename `val as
	`pair'.
	(muscle_init): Move the `b4_ltype', `b4_maxdepth', `b4_initdepth',
	`name' to...
	* data/glr.c, data/lalr1.cc, data/yacc.c (b4_location_type)
	(b4_stack_depth_init, b4_stack_depth_max, b4_parser_class_name):
	These.

2002-10-19  Paul Eggert  <eggert@twinsun.com>

	Do not create a temporary file, as that involves security and
	cleanup headaches.  Instead, use a pair of pipes.
	Derived from a suggestion by Florian Krohm.
	* lib/subpipe.c, lib/subpipe.h, m4/subpipe.m4: New files.
	* lib/mkstemp.c, lib/readpipe.c, lib/tempname.c, m4/mkstemp.m4: Remove.
	* configure.ac (UTILS_FUNC_MKSTEMP, jm_PREREQ_TEMPNAME): Remove.
	(BISON_PREREQ_SUBPIPE): Add.
	* lib/Makefile.am (libbison_a_SOURCES): Remove readpipe.c.
	Add subpipe.h, subpipe.c.
	* m4/Makefile.am (EXTRA_DIST): Remove mkstemp.m4.  Add subpipe.m4.
	* po/POTFILES.in: Add lib/subpipe.c.
	* src/output.c: Include "subpipe.h".
	(m4_invoke): Remove decl.
	(scan_skel): New decl.
	(output_skeleton): Use pipe rather than temporary file for m4 input.
	Check that m4sugar.m4 is readable, to avoid deadlock.
	Check for pipe I/O error.
	* src/scan-skel.l (readpipe): Remove decl.
	(scan_skel): New function, to be used in place of m4_invoke.
	Read from stream rather than file.

	* lib/timevar.c (TICKS_TO_MSEC, CLOCKS_TO_MSEC): Do not cast to
	float, as this generates a warning on Solaris 8 + GCC 3.2 with
	--enable-gcc-warnings.  Instead, divide into 1.0 rather than 1;
	this generates a more-accurate value anyway.

	* lib/timevar.c (timervar_accumulate): Rename locals to
	avoid confusion with similarly-named more-global.
	* src/muscle_tab.c (muscle_pair_list_grow): Likewise.

	* src/output.c (prepare): Use xstrdup to convert char const *
	to char *, to avoid GCC warning.

2002-10-19  Akim Demaille  <akim@epita.fr>

	* tests/calc.at (_AT_DATA_CALC_Y): Define VAL, LOC, LEX_FORMALS,
	LEX_PRE_FORMALS, LEX_ARGS, LEX_PRE_ARGS, USE_LEX_ARGS.
	Use them to have `calc.y' ready for %pure-parser.
	* data/yacc.c (YYLEX): Pass a yylex return type to
	b4_c_function_call.

2002-10-19  Akim Demaille  <akim@epita.fr>

	Prototype support of %lex-param and %parse-param.

	* src/parse-gram.y: Add the definition of the %lex-param and
	%parse-param tokens, plus their rules.
	Drop the `_' version of %glr-parser.
	Add the "," token.
	* src/scan-gram.l (INITIAL): Scan them.
	* src/muscle_tab.c: Comment changes.
	(muscle_insert, muscle_find): Rename `pair' as `probe'.
	* src/muscle_tab.h (MUSCLE_INSERT_PREFIX): Remove unused.
	(muscle_entry_s): The `value' member is no longer const.
	Adjust all dependencies.
	* src/muscle_tab.c (muscle_init): Adjust: use
	MUSCLE_INSERT_STRING.
	Initialize the obstack earlier.
	* src/muscle_tab.h, src/muscle_tab.c (muscle_grow)
	(muscle_pair_list_grow): New.
	* data/c.m4 (b4_c_function_call, b4_c_args): New.
	* data/yacc.c (YYLEX): Use b4_c_function_call to honor %lex-param.
	* tests/calc.at: Use %locations, not --locations.
	(AT_CHECK_CALC_GLR): Use %glr-parser, not %glr_parser.

2002-10-19  Akim Demaille  <akim@epita.fr>

	* src/getargs.c (usage): Take status as argument and exit
	accordingly.
	Report the traditional `Try ... --help' message when status != 0.
	(usage, version): Don't take a FILE * as arg, it is pointless.
	(getargs): When there is an incorrect number of arguments, make it
	an error, and report it GNUlically thanks to `usage ()'.

2002-10-18  Paul Eggert  <eggert@twinsun.com>

	* data/glr.c (yyreportParseError): Don't assume that sprintf
	yields the length of the printed string, as this is not true
	on SunOS 4.1.4.  Reported by Peter Klein.

	* tests/calc.at (_AT_DATA_CALC_Y): #undef memcmp and realloc.
	* tests/conflicts.at (%nonassoc and eof): Likewise.
	Fixes SunOS 4.1.4 test failure reported by Peter Klein.

2002-10-17  Akim Demaille  <akim@epita.fr>

	* src/getargs.h (trace_e): Add trace_scan, and trace_parse.
	* src/getargs.c (trace_types, trace_args): Adjust.
	* src/reader.c (grammar_current_rule_prec_set)
	(grammar_current_rule_dprec_set, grammar_current_rule_merge_set):
	Standardize error messages.
	And s/@prec/%prec/!
	(reader): Use trace_flag to enable scanner/parser debugging,
	instead of an adhoc scheme.
	* src/scan-gram.l: Remove trailing debugging code.

2002-10-16  Paul Eggert  <eggert@twinsun.com>

	* src/muscle_tab.h (MUSCLE_TAB_H_): Was misspelled as
	MUSCLE_TAB_H.

	* NEWS: Officially drop support for building Bison with K&R C,
	since it didn't work anyway and it's not worth worrying about.
	* Makefile.maint (wget_files): Remove ansi2knr.c.
	(ansi2knr.c-url_prefix): Remove.
	* lib/.cvsignore: Remove ansi2knr, ansi2knr.*.
	* lib/Makefile.am (AUTOMAKE_OPTIONS): Remove.
	* src/Makefile.am (AUTOMAKE_OPTIONS): Remove.

2002-10-15  Paul Eggert  <eggert@twinsun.com>

	Stop using the "enum_" trick for K&R-style function definitions;
	it confused me, and I was the author!  Instead, assume that people
	who want to use K&R C compilers (when using these modules in GCC,
	perhaps?) will run ansi2knr.

	* lib/bbitset.h: (enum_bitset_ops, enum_bitset_type): Remove.
	All uses of "enum_" changed to "enum ".
	* lib/ebitset.c (enum_ebitset_find_mode): Likewise.
	* lib/lbitset.c (enum_lbitset_find_mode): Likewise.

	* lib/abitset.c (abitset_and, abitset_and_cmp, abitset_and_or,
	abitset_and_or_cmp, abitset_andn, abitset_andn_cmp,
	abitset_andn_or, abitset_andn_or_cmp, abitset_bytes, abitset_copy,
	abitset_copy1, abitset_disjoint_p, abitset_empty_p,
	abitset_equal_p, abitset_init, abitset_list, abitset_list_reverse,
	abitset_not, abitset_ones, abitset_or, abitset_or_and,
	abitset_or_and_cmp, abitset_or_cmp, abitset_reset, abitset_set,
	abitset_size, abitset_small_list, abitset_subset_p, abitset_test,
	abitset_unused_clear, abitset_xor, abitset_xor_cmp, abitset_zero):
	Use function prototypes; this removes the need for declaring
	static functions simply to provide their prototypes.
	* lib/bitset.c (bitset_alloc, bitset_and_or_, bitset_and_or_cmp_,
	bitset_andn_or_, bitset_andn_or_cmp_, bitset_bytes, bitset_copy_,
	bitset_count_, bitset_create, bitset_dump, bitset_first,
	bitset_free, bitset_init, bitset_last, bitset_next,
	bitset_obstack_alloc, bitset_obstack_free, bitset_only_set_p,
	bitset_op4_cmp, bitset_or_and_, bitset_or_and_cmp_, bitset_prev,
	bitset_print, bitset_release_memory, bitset_toggle_,
	bitset_type_choose, bitset_type_get, bitset_type_name_get,
	debug_bitset): Likewise.
	* lib/bitset.h (bitset_set, bitset_reset, bitset_test): Likewise.
	* lib/bitset_stats.c (bitset_log_histogram_print,
	bitset_percent_histogram_print, bitset_stats_and,
	bitset_stats_and_cmp, bitset_stats_and_or,
	bitset_stats_and_or_cmp, bitset_stats_andn, bitset_stats_andn_cmp,
	bitset_stats_andn_or, bitset_stats_andn_or_cmp, bitset_stats_copy,
	bitset_stats_count, bitset_stats_disable, bitset_stats_disjoint_p,
	bitset_stats_dump, bitset_stats_empty_p, bitset_stats_enable,
	bitset_stats_equal_p, bitset_stats_free, bitset_stats_init,
	bitset_stats_list, bitset_stats_list_reverse, bitset_stats_not,
	bitset_stats_ones, bitset_stats_or, bitset_stats_or_and,
	bitset_stats_or_and_cmp, bitset_stats_or_cmp, bitset_stats_print,
	bitset_stats_print_1, bitset_stats_read, bitset_stats_reset,
	bitset_stats_set, bitset_stats_size, bitset_stats_subset_p,
	bitset_stats_test, bitset_stats_toggle, bitset_stats_type_get,
	bitset_stats_write, bitset_stats_xor, bitset_stats_xor_cmp,
	bitset_stats_zero): Likewise.
	* lib/bitsetv.c (bitsetv_alloc, bitsetv_create, bitsetv_free,
	bitsetv_zero, bitsetv_ones, bitsetv_transitive_closure,
	bitsetv_dump, debug_bitsetv): Likewise.
	* lib/ebitset.c (ebitset_and, ebitset_and_cmp, ebitset_andn,
	ebitset_andn_cmp, ebitset_bytes, ebitset_copy, ebitset_copy_,
	ebitset_copy_cmp, ebitset_disjoint_p, ebitset_elt_add,
	ebitset_elt_alloc, ebitset_elt_calloc, ebitset_elt_find,
	ebitset_elt_free, ebitset_elt_last, ebitset_elt_remove,
	ebitset_elt_zero_p, ebitset_elts_grow, ebitset_empty_p,
	ebitset_equal_p, ebitset_free, ebitset_init, ebitset_list,
	ebitset_list_reverse, ebitset_not, ebitset_ones, ebitset_op3_cmp,
	ebitset_or, ebitset_or_cmp, ebitset_release_memory, ebitset_reset,
	ebitset_set, ebitset_size, ebitset_subset_p, ebitset_test,
	ebitset_weed, ebitset_xor, ebitset_xor_cmp, ebitset_zero):
	Likewise.
	* lib/lbitset.c (debug_lbitset, lbitset_and, lbitset_and_cmp,
	lbitset_andn, lbitset_andn_cmp, lbitset_bytes, lbitset_copy,
	lbitset_copy_cmp, lbitset_disjoint_p, lbitset_elt_alloc,
	lbitset_elt_calloc, lbitset_elt_find, lbitset_elt_free,
	lbitset_elt_link, lbitset_elt_unlink, lbitset_elt_zero_p,
	lbitset_empty_p, lbitset_equal_p, lbitset_free, lbitset_init,
	lbitset_list, lbitset_list_reverse, lbitset_not, lbitset_ones,
	lbitset_op3_cmp, lbitset_or, lbitset_or_cmp, lbitset_prune,
	lbitset_release_memory, lbitset_reset, lbitset_set, lbitset_size,
	lbitset_subset_p, lbitset_test, lbitset_weed, lbitset_xor,
	lbitset_xor_cmp, lbitset_zero): Likewise.

2002-10-14  Akim Demaille  <akim@epita.fr>

	Version 1.75.

2002-10-14  Akim Demaille  <akim@epita.fr>

	* tests/Makefile.am (maintainer-check-posix): New.

2002-10-14  Akim Demaille  <akim@epita.fr>

	* data/glr.c [YYDEBUG] (YYLEFTMOST_STATE): Initialize the yyloc
	member.

2002-10-14  Akim Demaille  <akim@epita.fr>

	* src/tables.c (table_ninf_remap): base -> tab.
	Reported by Matt Rosing.

2002-10-14  Paul Eggert  <eggert@twinsun.com>

	* tests/action.at, tests/calc.at, tests/conflicts.at,
	tests/cxx-type.at, tests/headers.at, tests/input.at,
	tests/regression.at, tests/synclines.at, tests/torture.at:
	Say "bison -o foo.c foo.y", not "bison foo.y -o foo.c",
	so that the tests still work even if POSIXLY_CORRECT is set.
	* doc/bison.texinfo (Rpcalc Compile, Invocation): Likewise.

	* data/c.m4 (b4_int_type): Use yysigned_char instead of signed char,
	for portability to K&R hosts.  Fix typo: signed char is guaranteed
	only to 127, not to 128.
	* data/glr.c (yysigned_char): New type.
	* data/yacc.c (yysigned_char): Likewise.
	* tests/regression.at (Web2c Actions): signed char -> yysigned_char.

2002-10-13  Paul Eggert  <eggert@twinsun.com>

	* data/yacc.c (yyparse): Rewrite to avoid "comparison is always
	true due to limited range of data type" warning from GCC.

	* data/c.m4 (b4_token_defines): Protect against double-inclusion
	by wrapping enum yytokentype's definition inside #ifndef
	YYTOKENTYPE.  This undoes a bug I introduced on 2002-10-12.

2002-10-13  Akim Demaille  <akim@epita.fr>

	* data/glr.c (yyglrShiftDefer, yyaddDeferredAction, yydoAction):
	Un yy- yyrhs to avoid the name clash with the global YYRHS.

2002-10-13  Akim Demaille  <akim@epita.fr>

	* Makefile.maint: Update from Autoconf 2.54.
	* m4/strerror_r.m4 (AC_FUNC_STRERROR_R): Remove, shipped with 2.54.

2002-10-13  Akim Demaille  <akim@epita.fr>

	* src/print.c (print_state): Separate the list of solved conflicts
	from the other items.
	* tests/conflicts.at (Resolved SR Conflicts): Adjust.

2002-10-13  Akim Demaille  <akim@epita.fr>

	Let nondeterministic skeletons be usable with deterministic
	tables.

	With the patch, GAWK compiled by GCC without -O2 passes its test
	suite using a GLR parser driven by LALR tables.  It fails with -O2
	because `struct stat' gives two different answers on my machine:
	88 (definition of an auto var) and later 96 (memset on this var).
	Hence the stack is badly corrumpted.  The headers inclusion is to
	blame: if I move the awk.h inclusion before GLR's system header
	inclusion, the two struct stat have the same size.

	* src/tables.c (pack_table): Always create conflict_table.
	(token_actions): Always create conflict_list.
	* data/glr.c (YYFLAG): Remove, unused.

2002-10-13  Akim Demaille  <akim@epita.fr>

	* configure.ac (AC_GNU_SOURCE): Use it instead of hand written code.
	(O0FLAGS): New.
	(VALGRIND, GXX): New.
	* tests/atlocal.in (CFLAGS): Use O0FLAGS.
	* tests/bison.in: Run $PREBISON a pre-command.
	* tests/Makefile.am (maintainer-check, maintainer-check-valgrind)
	(maintainer-check-g++): New.
	* Makefile.am (maintainer-check): New.

2002-10-13  Akim Demaille  <akim@epita.fr>

	* data/glr.c: Formatting changes.
	Tweak some trace messages to match yacc.c's.

2002-10-13  Akim Demaille  <akim@epita.fr>

	GLR parsers sometimes raise parse errors instead of performing the
	default reduction.
	Reported by Charles-Henry de Boysson.

	* tests/calc.at (_AT_CHECK_CALC, _AT_CHECK_CALC_ERROR): Don't
	check the length of the	traces when %glr.
	(_AT_CHECK_CALC_ERROR): Also skip `^Stack' lines, coming from
	GLR's traces.
	(AT_CHECK_CALC_LALR, AT_CHECK_CALC_GLR): New.
	Test GLR parsers.
	* data/glr.c (YYLEFTMOST_STATE): Fix its value.
	(yyltype): Remove the yy prefix from the member names.
	(yytable): Complete its comment.
	(yygetLRActions): Map error action number from YYTABLE from
	YYTABLE_NINF to 0.
	(yyisErrorAction): No longer compare YYACTION to YYPACT_NINF
	(which was a bug: it should have been YYTABEL_NINF, and yet it was
	not satisfying as we could compare an YYACTION computed from
	YYDEFACT to YYTABLE_NINF although they are unrelated): 0 is the
	only value for error actions.
	(yyreportParseError): In verbose parse error messages, don't issue
	`error' in the list of expected tokens.
	* data/yacc.c (yyparse) <yybackup>: Rewrite the decoding of the
	next action to perform to match glr.c's decoding.
	(yytable): Complete its comment.

2002-10-13  Paul Eggert  <eggert@twinsun.com>

	Fix problem reported by Henrik Grubbstroem in
	<http://mail.gnu.org/pipermail/bug-bison/2002-October/001670.html>:
	"nonterm: { $$ = 123; } { $$ = $1; };" was wrongly rejected,
	because the Bison parser reads the second action before reducing
	the first one.
	* src/scan-gram.l (rule_length): New static var.
	Use it to keep track of the rule length in the scanner, since
	we can't expect the parser to be in lock-step sync with the scanner.
	(handle_action_dollar, handle_action_at): Use this var.
	* tests/actions.at (Exotic Dollars): Test for the problem.

2002-10-12  Paul Eggert  <eggert@twinsun.com>

	* lib/timevar.c [! IN_GCC && HAVE_SYS_TIME_H]: Include <sys/time.h>.
	* m4/timevar.m4 (BISON_PREREQ_TIMEVAR): Check for <sys/time.h>.
	Include <sys/time.h> when checking for clock_t and struct tms.
	Use same include order as source.
	This is for the SunOS 4.1.4 porting bug reported by Peter Klein in
	<http://mail.gnu.org/pipermail/bug-bison/2002-October/001674.html>.

	* lib/timevar.c: Update copyright date and clarify comments.
	(get_time) [IN_GCC]: Keep the GCC version for reference.

	* lib/timevar.c, lib/timevar.h, lib/timevar.def: Import
	GCC version as of today, then merge Bison's changes.
	Change "GCC" to "Bison" in copyright notice.  timevar.def's
	author is Akim, so change that too.

	* src/reader.c (grammar_current_rule_check):
	Don't worry about the default action if $$ is untyped.
	Prevents bogus warnings reported by Jim Gifford in
	<http://mail.gnu.org/pipermail/bug-bison/2002-October/001673.html>.

	* data/c.m4 (b4_token_enum): Do not define YYTOKENTYPE.
	* data/glr.c, data/lalr1.cc, data/yacc.c:
	Output token definitions before the first part of user declarations.
	Fixes compatibility problem reported by Jim Gifford for kbd in
	<http://mail.gnu.org/pipermail/bug-bison/2002-October/001672.html>.

2002-10-11  Paul Eggert  <eggert@twinsun.com>

	* data/yacc.c (yyreport_parse_error): Remove, putting its body into...
	(yyparse): here.  This undoes some of the 2002-07-25 change.
	Compatibility problem reported by Ralf S. Engelschall with
	OSSP cfg <http://www.ossp.org/pkg/lib/cfg/>.

2002-10-11  Akim Demaille  <akim@epita.fr>

	* tests/regression.at Characters Escapes): New.
	* src/scan-gram.l (SC_ESCAPED_CHARACTER): Accept \' in strings and
	characters.
	Reported by Jan Nieuwenhuizen.

2002-10-11  Akim Demaille  <akim@epita.fr>

	* po/id.po: New.

2002-10-10  Paul Eggert  <eggert@twinsun.com>

	Portability fixes for bitsets; this also avoids several GCC
	warnings.

	* lib/abitset.c: Include <stddef.h>, for offsetof.
	* lib/lbitset.c: Likewise.

	* lib/abitset.c (abitset_bytes): Return a size that is aligned
	properly for vectors of objects.  Do not assume that adding a
	header size to a multiple of a word size yields a value that is
	properly aligned for the whole union.
	* lib/bitsetv.c (bitsetv_alloc): Likewise.

	* lib/bitset_stats.c (bitset_stats_bytes): Adjust to new,
	unique names for structures.
	* lib/ebitset.c (ebitset_bytes): Likewise.
	* lib/lbitset.c (lbitset_bytes): Likewise.

	* lib/abitset.c (abitset_ones, abitset_zero, abitset_empty_p,
	abitset_copy1, abitset_not, abitset_equal_p, abitset_subset_p,
	abitset_disjoint_p, abitset_and, abitset_and_cmp, abitset_andn,
	abitset_andn_cmp, abitset_or, abitset_or_cmp, abitset_xor,
	abitset_xor_cmp, abitset_and_or, abitset_and_or_cmp,
	abitset_andn_or, abitset_andn_or_cmp, abitset_or_and,
	abitset_or_and_cmp, abitset_copy): Supply prototype decls,
	to improve the type-checking that GCC can do.
	* lib/bitset.c (bitset_op4_cmp): Likewise.
	* lib/bitset_stats.c (bitset_stats_count,
	bitset_stats_empty_p, bitset_stats_ones, bitset_stats_zero,
	bitset_stats_copy, bitset_stats_disjoint_p,
	bitset_stats_equal_p, bitset_stats_not, bitset_stats_subset_p,
	bitset_stats_and, bitset_stats_and_cmp, bitset_stats_andn,
	bitset_stats_andn_cmp, bitset_stats_or, bitset_stats_or_cmp,
	bitset_stats_xor, bitset_stats_xor_cmp, bitset_stats_and_or,
	bitset_stats_and_or_cmp, bitset_stats_andn_or,
	bitset_stats_andn_or_cmp, bitset_stats_or_and,
	bitset_stats_or_and_cmp): Likewise.
	* lib/lbitset.c (lbitset_and, lbitset_and_cmp, lbitset_andn,
	lbitset_andn_cmp, lbitset_or, lbitset_or_cmp, lbitset_xor,
	lbitset_xor_cmp, lbitset_empty_p, lbitset_ones, lbitset_not,
	lbitset_subset_p, lbitset_disjoint_p, debug_lbitset): Likewise.

	* lib/abitset.h: Include bitset.h, not bbitset.h.
	* lib/ebitset.h: Likewise.
	* lib/lbitset.h: Likewise.

	* lib/bbitset.h: (enum_bitset_ops, enum_bitset_type): New types.
	All instances of parameters of type enum bitset_opts are now of
	type enum_bitset_opts, to conform to the C Standard, and similarly
	for enum_bitset_type.
	* lib/ebitset.c (enum_ebitset_find_mode): Likewise.
	* lib/lbitset.c (enum_lbitset_find_mode): Likewise.

	Do not use "struct bitset_struct" to mean different things in
	different modules.  Not only is this confusing, it violates
	the C Standard, which requires that structure types in different
	modules must be compatible if one is to be passed to the other.
	* lib/bbitset.h (bitset): Now points to a union, not to a struct.
	All instances of "struct bitset_struct *" replaced with "bitset".
	* lib/bitset.h (struct bitset_struct): Remove, replacing with....
	(union bitset_union, struct abitset_struct, struct ebitset_struct,
	struct lbitset_struct, struct bitset_stats_struct): New types.
	All uses of struct bitset_struct changed to union bitset_union,
	etc.
	* lib/abitset.c	(struct abitset_struct, abitset,
	struct bitset_struct): Remove.
	* lib/bitset_stats.c (struct bitset_stats_struct, bitset_stats,
	struct bitset_struct): Remove.
	* lib/ebitset.c (struct ebitset_struct, ebitset, struct
	bitset_struct): Remove.
	* lib/lbitset.c (struct lbitset_struct, lbitset, bitset_struct):
	Likewise.

	Do not call a function of type T using a call that assumes the
	function is of a different type U.  Standard C requires that a
	function must be called with a type that is compatible with its
	definition.
	* lib/bbitset.h (bitset_and_or_, bitset_andn_or_, bitset_or_and_):
	New decls.
	* lib/bitset.c (bitset_and_or_, bitset_andn_or_, bitset_or_and_):
	New functions.
	* lib/ebitset.c (PFV): Remove.
	* lib/lbitset.c (PFV): Likewise.
	* lib/ebitset.c (ebitset_and, ebitset_andn, ebitset_or,
	ebitset_xor, ebitset_copy, ebitset_ones, ebitset_empty_p): New
	decls.
	(ebitset_and, ebitset_andn, ebitset_or, ebitset_xor): New functions.
	(ebitset_vtable): Use them.
	* lib/lbitset.c (lbitset_and, lbitset_andn, lbitset_or,
	lbitset_xor): New functions.
	(lbitset_vtable): Use them.

	* lib/bitset.h (bitset_next, bitset_prev, bitset_only_set_p):
	Declare.

	* lib/bitsetv.c (bitsetv_alloc): Add a cast to (void *) to avoid a
	GCC warning.
	* lib/lbitset.c (LBITSET_CURRENT1): Likewise.
	Use offsetof, for simplicity.

2002-10-06  Paul Eggert  <eggert@twinsun.com>

	* lib/bitset.h (bitset_reset): Do not assume that bitset_word is
	the same width as int.  This reapplies a hunk of the 2002-08-12 patch
	<http://mail.gnu.org/pipermail/bison-patches/2002-August/001111.html>,
	which was inadvertently undone by the 2002-09-30 patch.
	* lib/lbitset.c (debug_lbitset): Do not assume that bitset_word is
	the same width as int.

2002-10-04  Paul Eggert  <eggert@twinsun.com>

	Version 1.50.

	* configure.ac (AC_INIT), NEWS: Increment version number.

	* doc/bison.texinfo: Minor spelling, grammar, and white space
	fixes.
	(Symbols): Mention that any negative value returned from yylex
	signifies end-of-input.  Warn about negative chars.  Mention
	the portable Standard C character set.

	The GNU coding standard says CFLAGS and YFLAGS are reserved
	for the installer to set.
	* lib/Makefile.am (AM_CFLAGS): Renamed from CFLAGS.
	* src/Makefile.am (AM_CFLAGS): Likewise.
	(AM_YFLAGS): Renamed from YFLAGS.

	Fix some MAX and MIN problems.
	* src/gram.h (ITEM_NUMBER_MIN): MIN_MAX -> INT_MIN.
	* src/lalr.h (GOTO_NUMBER_MAX): INT_MAX -> SHRT_MAX.
	* src/symtab.h (SYMBOL_NUMBER_MAX): New macro.
	* src/reader.c (reader): Use it.

	* tests/regression.at (Braces parsing): Use grep, not fgrep, as
	POSIX 1003.1-2001 has removed fgrep.

2002-10-04  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>

	* lib/bbitset.h (BITSET_WINDEX_MAX): Redefine so that it cannot be
	interpreted as signed.
	* lib/ebitset.c (ebitset_list): Fix bug.

2002-10-01  Paul Eggert  <eggert@twinsun.com>

	More fixes for 64-bit hosts and large bitsets.

	* lib/abitset.c (struct abitset_struct.n_bits, abitset_small_list,
	abitset_size, abitset_list, abitset_list_reverse, abitset_list):
	Use bitset_bindex, not int or unsigned int or size_t, to count bits.
	* lib/bbitset.h (struct bitset_vtable.size, struct bitset_vtable.count,
	struct bitset_vtable.list, struct bitset_vtable.list_reverse,
	bitset_count_, bitset_next, bitset_prev, bitset_first, bitset_last,
	bitset_count_): Likewise.
	* lib/bitset.h (bitset_iterator.num, bitset_iterator.i,
	bitset_first, bitset_last): Likewise.
	* lib/bitset_stats.c (bitset_stats_size, bitset_stats_list,
	bitset_stats_list_reverse, bitset_stats_size,
	bitset_stats_count, bitset_stats_list, bitset_stat_list_reverse):
	Likewise.
	* lib/bitsetv-print.c (bitsetv_matrix_dump): Likewise.
	* lib/bitsetv.c (bitsetv_alloc, bitsetv_create, bitsetv_free,
	bitsetv_zero, bitsetv_ones, bitsetv_transitive_closure,
	bitsetv_reflexive_transitive_closure): Likewise.
	* lib/bitsetv.h (bitsetv_alloc, bitsetv_create): Likewise.
	* lib/ebitset.c (ebitset_size, ebitset_list, ebitset_list_reverse):
	Likewise.
	* lib/lbitset.c (lbitset_size, lbitset_list, lbitset_list_merge):
	Likewise.

	* lib/abitset.c (abitset_ones, abitset_zero, abitset_bytes):
	Use size_t, not unsigned int, to count bytes.
	* lib/abitset.h (abitset_bytes): Likewise.
	* lib/bitset.c (bitset_bytes, bitset_alloc, bitset_obstack_alloc):
	Likewise.
	* lib/bitset.h (bitset_bytes): Likewise.
	* lib/bitset_stats.c (bitset_stats_bytes, bitset_stats_init): Likewise.
	* lib/bitset_stats.h (bitset_stats_bytes): Likewise.
	* lib/bitsetv.c (bitsetv_alloc): Likewise.
	* lib/ebitset.c (ebitset_bytes): Likewise.
	* lib/ebitset.h (ebitset_bytes): Likewise.
	* lib/lbitset.c (lbitset_bytes): Likewise.
	* lib/lbitset.h (lbitset_bytes): Likewise.

	* lib/abitset.c (abitset_empty_p, abitset_not, abitset_equal_p,
	abitset_subset_p, abitset_disjoint_p, abitset_and,
	abitset_and_cmp, abitset_andn, abitset_andn_cmp, abitset_or,
	abitset_or_cmp, abitset_xor, abitset_xor_cmp, abitset_and_or,
	abitset_and_or_cmp, abitset_andn_or, abitset_andn_or_cmp,
	abitset_or_and, abitset_or_and_cmp):
	Use bitset_windex instead of unsigned int.
	* lib/bitsetv.c (bitsetv_dump, debug_bitsetv): Likewise.
	* lib/ebitset.c (struct ebitset_struct.size, ebitset_elts_grow,
	ebitset_elt_add, ebitset_elt_remove, ebitset_weed,
	ebitset_elt_find, ebitset_list_reverse, ebitset_list, ebitset_init):
	Likewise.
	* lib/lbitset.c (lbitset_ones, lbitset_not): Likewise.

	* lib/bitset.c (bitset_print):
	Use proper printf formats for widths of integer types.
	* lib/bitset_stats.c (bitset_percent_histogram_print,
	bitset_log_histogram_print, bitset_stats_print_1): Likewise.
	* lib/bitsetv-print.c (bitsetv_matrix_dump): Likewise.
	* lib/bitsetv.c (bitsetv_dump, debug_bitsetv): Likewise.
	* lib/lbitset.c (lbitset_bytes): Likewise.

	* lib/bbitset.h (BITSET_BINDEX_MAX, BITSET_WINDEX_MAX,
	BITSET_SIZE_MAX): New macros.
	(BITSET_INDEX_MAX): Remove.  It wasn't right, since it assumed that
	sizeof (bitset_word) == sizeof (bitset_windex).  All uses changed
	to BITSET_WINDEX_MAX.

	* lib/bitset.c (bitset_next, bitset_prev, bitset_first,
	bitset_last): Return BITSET_BINDEX_MAX (not -1) for no value,
	since we now return the bitset_bindex type (not int).

	* lib/bitsetv.c (bitsetv_alloc): Check for arithmetic overflow
	when computing sizes.
	* lib/ebitset.c (ebitset_elts_grow): Likewise.

	* lib/lbitset.c (lbitset_elt_find): Simplify windex calculation
	and avoid cast to unsigned.

2002-09-30  Akim Demaille  <akim@epita.fr>

	* lib/abitset.c, lib/bbitset.h, lib/bitset.c, lib/bitset.h,
	* lib/bitset_stats.c, lib/bitsetv.c, lib/ebitset.c, lib/lbitset.c:
	Updates from Michael Hayes.

2002-09-30  Art Haas  <ahaas@neosoft.com>

	* configure.ac: Update AC_OUTPUT and AM_CONFIG_HEADER
	invocations.
	* tests/cxx-type.at (declarator): Don't rely on NDEBUG being not
	defined.

2002-09-27  Akim Demaille  <akim@epita.fr>

	Version 1.49c.

2002-09-27  Akim Demaille  <akim@epita.fr>

	* configure.ac (AM_INIT_AUTOMAKE): We _need_ 1.7.
	(Because of AC_LIBSOURCE).

2002-09-27  Akim Demaille  <akim@epita.fr>

	Playing with Autoscan.

	* configure.ac: Remove the old LIBOBJ tweaks.
	(AC_REPLACE_FUNCS): Add strrchr and strtol.
	* lib/strrchr.c: New.
	* lib/strtol.c: New, from the Coreutils 4.5.1.

2002-09-27  Akim Demaille  <akim@epita.fr>

	Playing with Autoscan.

	* m4/prereq.m4 (jm_PREREQ_ARGMATCH, jm_FUNC_ARGMATCH): New.
	* lib/Makefile.am (libbison_a_SOURCES): No longer include
	argmatch.c and argmatch.h, since they are AC_LIBSOURCE'd.
	* lib/strcasecmp.c, lib/strncasecmp.c, lib/memcmp.c: New, from the
	Coreutils 4.5.1.

2002-09-24  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo (Stack Overflow): xref to Recursion.
	(Frequently Asked Questions, Parser Stack Overflow): New.

2002-09-13  Akim Demaille  <akim@epita.fr>

	Playing with autoscan.

	* src/reader.c (get_merge_function): Use xstrdup, not strdup.
	* src/files.c (skeleton_find): Remove, unused.
	* m4/memcmp.m4: New, from the Coreutils 4.5.1.
	* m4/prereq.m4 (jm_PREREQ_QUOTEARG): Run jm_FUNC_MEMCMP.

2002-09-13  Akim Demaille  <akim@epita.fr>

	* configure.ac (AM_INIT_AUTOMAKE): Require Automake 1.6.3.
	* Makefile.am (AUTOMAKE_OPTIONS): Don't.

2002-09-13  Akim Demaille  <akim@epita.fr>

	* configure.ac: Require 2.54.
	s/jm_FUNC_MALLOC/AC_FUNC_MALLOC/.
	s/jm_FUNC_REALLOC/AC_FUNC_REALLOC/.
	* m4/c-bs-a.m4, m4/malloc.m4, m4/mbstate_t.m4, m4/realloc.m4:
	Remove, provided by Autoconf macros.

2002-09-12  Akim Demaille  <akim@epita.fr>

	* m4/prereq.m4: Update, from Coreutils 4.5.1.

2002-09-12  Akim Demaille  <akim@epita.fr>

	* m4/prereq.m4: Update, from Fileutils 4.1.5.
	* configure.ac (jm_PREREQ_TEMPNAME): Invoke it.
	Reported by Martin Mokrejs.

2002-09-10  Akim Demaille  <akim@epita.fr>

	* src/parse-gram.y: Associate a human readable string to each
	token type.
	* tests/regression.at (Invalid inputs): Adjust.

2002-09-10  Gary V. Vaughan  <gary@gnu.org>

	* tests/Makefile.am ($(srcdir)/package.m4): Bison now ships
	with an Autoconf-2.5x style configure.ac.

2002-09-06  Paul Eggert  <eggert@twinsun.com>

	* doc/bison.texinfo (Conditions): Make explicit that the GPL
	exception applies only to yacc.c.  This is a modification of a
	patch originally suggested by Akim Demaille.

2002-09-06  Akim Demaille  <akim@epita.fr>

	* data/c.m4 (b4_copyright): Move the GPL exception comment from
	here to...
	* data/yacc.c: here.

	* data/lalr1.cc (struct yyltype): Don't define it, since we use
	LocationType.
	(b4_ltype): Default to yy::Location from location.hh.

2002-09-04  Jim Meyering  <jim@meyering.net>

	* data/yacc.c: Guard the declaration of yytoknum also with
	`#ifdef YYPRINT', so it is declared only when used.

2002-09-04  Akim Demaille  <akim@epita.fr>

	* configure.in: Rename as...
	* configure.ac: this.
	Bump to 1.49c.

2002-09-04  Akim Demaille  <akim@epita.fr>

	* src/assoc.c, src/closure.c, src/gram.c, src/injections.c,
	* src/lalr.c, src/LR0.c, src/relation.c, src/tables.c: Don't
	translate maintainer only messages.

2002-08-12  Paul Eggert  <eggert@twinsun.com>

	Version 1.49b.

	* Makefile.am (SUBDIRS): Remove intl.
	(DISTCLEANFILES): Remove.
	* NEWS: Mention that GNU M4 is now required.  Clarify what is
	meant by "larger grammars".  Mention the pt_BR translation.
	* configure.in (AC_CHECK_DECLS): Add getenv, getopt.
	(AM_GNU_GETTEXT_VERSION): New macro, replacing GETTEXT_VERSION var.
	Bump version from 0.11.2 to 0.11.5.
	(BISON_PREREQ_STAGE): Remove.
	(AM_GNU_GETTEXT): Use external gettext.
	(AC_OUTPUT): Remove intl/Makefile.

	* config/depcomp, config/install-sh: Sync with Automake 1.6.3.

	* data/glr.c: Include string.h, for strlen.
	(yyreportParseError): Use size_t for yysize.
	(yy_yypstack): No longer nested inside yypstates, as nested
	functions are not portable.  Do not assume size_t is the
	same width as int.
	(yypstates): Do not assume that ptrdiff_t is the same width
	as int, and similarly for yyposn and YYINDEX.

	* data/yacc.c: Fix comment about `$$ = $1': it can copy garbage.

	* lib/Makefile.am (INCLUDES): Do not include from the intl
	directory, which has been removed.
	* src/Makefile.am (INCLUDES): Likewise.

	* lib/Makefile.am (libbison_a_SOURCES): Add unlocked-io.h.
	(bitsets_sources, additional_bitsets_sources, timevars_sources):
	New vars.

	* lib/Makefile.am (libbison_a_SOURCES): Avoid +=, a GNU make extension.
	* tests/Makefile.am (EXTRA_DIST): Likewise.

	* lib/abitset.c (abitset_reverse_list, ebitset_reverse_list):
	Do not assume that bitset_windex is the same width as unsigned.

	* lib/abitset.c (abitset_unused_clear): Do not assume that
	bitset_word is the same width as int.
	* lib/bbitset.h (BITSET_INDEX_MAX, BITSET_MSB): Likewise.
	* lib/bitset.h (bitset_set, bitset_reset): Likewise.
	* lib/bitset_stats.c (bitset_stats_set, bitset_stats_reset): Likewise.
	* lib/ebitset.c (ebitset_set, ebitset_reset): Likewise.
	* lib/lbitset.c (lbitset_set, lbitset_reset): Likewise.

	* lib/abitset.c (abitset_op1): Use -1, not ~0, as memset arg (for
	portability to one's complement hosts!).
	* lib/ebitset.c (ebitset_op1): Likewise.
	* lib/lbitset.c (lbitset_op1): Likewise.

	* lib/argmatch.c, lib/quotearg.c, quotearg.h: Sync with GNU tar.
	* lib/argmatch.h, lib/basename.c, lib/dirname.c, lib/dirname.h,
	lib/hash.c, lib/hash.h, lib/strnlen.c, lib/xmalloc.c:
	Sync with fileutils.
	* lib/error.c, lib/getopt.c, lib/getopt.h, lib/getopt1.c,
	lib/gettext.h: Sync with diffutils.

	* lib/memrchr.c, lib/mkstemp.c, lib/strchr.c, lib/strnlen.c,
	lib/strspn.c, lib/tempname.c: Use GPL, not LGPL.

	* lib/obstack.c, lib/obstack.h: Sync with fileutils, except use
	PROTOTYPES to check for prototypes, and "defined __STDC__" to
	check for void *.

	* lib/bbitset.h (BITSET_WORD_BITS): Now of type unsigned, not
	size_t; the old version tried to do this but casted improperly.
	(bitset_bindex, bitset_windex): Now size_t, not unsigned long.
	(bitset_test): Now returns int, not unsigned long.

	* lib/bitset_stats.c: Include "gettext.h".
	(_): New macro.
	(bitset_stats_set, bitset_stats_reset, bitset_stats_test): Don't
	name locals "index", as it generates unnecessary warnings on some
	hosts that have an "index" function.

	* lib/bitset_stats.c (bitset_stats_print_1, bitset_stats_print,
	bitset_stats_read, bitset_stats_write): Wrap strings in _() if
	they need translation.
	* src/LR0.c (state_list_append, new_itemsets, get_state,
	append_states, generate_states): Likewise.
	* src/assoc.c (assoc_to_string): Likewise.
	* src/closure.c (print_closure, set_firsts, closure): Likewise.
	* src/gram.c (grammar_dump): Likewise.
	* src/injections.c (injections_compute): Likewise.
	* src/lalr.c (lookaheads_print): Likewise.
	* src/relation.c (relation_transpose): Likewise.
	* src/scan-gram.l: Likewise.
	* src/tables.c (table_grow, pack_vector): Likewise.

	* m4/Makefile.am (EXTRA_DIST): Remove codeset.m4,
	glibc21.m4, isc-posix.m4 lcmessage.m4, stage.m4.
	* m4/malloc.m4, m4/realloc.m4: Sync with diffutils.
	* m4/mbstate_t.m4: Sync with fileutils.
	* m4/prereq.m4 (jm_PREREQ_QUOTEARG): AC_MBSTATE_T -> AC_TYPE_MBSTATE_T.

	* po/LINGUAS: Add pt_BR.
	* po/POTFILES.in: Add src/assoc.c, src/closure.c, src/gram.c,
	src/main.c, src/relation.c, src/state.c, lib/bitset_stats.c,
	lib/timevar.c.
	Use src/parse-gram.y instead of src/parse-gram.c, as the gettext
	manual recommends.
	Similarly, use src/scan-gram.l instead of src/scan-gram.c.

	* src/complain.c (strerror_r): Remove decl; not needed.
	(strerror): Use same pattern as ../lib/error.c.

	* src/files.c, src/files.h (compute_header_macro): Remove; unused.

	* src/gram.c (grammar_dump): Do not assume ptrdiff_t fits in int.

	* src/main.c (main): Cast result of bindtextdomain and textdomain
	to void, to avoid a GCC warning when --disable-nls is in effect.

	* src/scan-gram.l: Use strings rather than escapes when possible,
	to minimize the number of warnings from xgettext.
	(handle_action_dollar, handle_action_at): Don't use isdigit,
	as it mishandles negative chars and it may not work as expected
	outside the C locale.

	* src/symtab.c (symbol_get): Don't cast LHS of an assignment;
	this is a GCC extension and is not portable to other compilers.

	* src/system.h (alloca): Use same pattern as ../lib/error.c.
	Do not include <ctype.h>; no longer needed.
	Do not include <malloc.h>; no longer needed (and generates
	warnings on OpenBSD 3.0).

	* tests/cxx-type.at (yylex): Do not pass signed char to isupper;
	it's not portable.

	* tests/regression.at: Do not use 'cc -c input.c -o input';
	Sun C rejects this.  Instead, use 'cc -c input.c -o input.o'.

	* tests/synclines.at (AC_SYNCLINES_COMPILE): Accept any nonzero
	exit status as failure, not just exit status 1.  Sun C exits
	with status 2 sometimes.

	* tests/torture.at (AT_INCREASE_DATA_SIZE): New macro.
	Use it for the two large tests.

2002-08-02  Akim Demaille  <akim@epita.fr>

	* src/conflicts.c (conflicts_output): Don't output rules never
	reduced here, since anyway that computation doesn't work.
	* src/gram.h, src/gram.h (rule_filter_t, rule_useful_p)
	(rule_useless_p, rule_never_reduced_p): New.
	(grammar_rules_partial_print): Use a filter instead of a range.
	Display the title only if needed.
	(grammar_rules_print): Adjust.
	(grammar_rules_never_reduced_report): New.
	* src/tables.c (action_row): Move the computation of rules never
	reduced to...
	(token_actions): here.
	* src/main.c (main): Make the parser before making the report, so
	that rules never reduced are computed.
	Call grammar_rules_never_reduced_report.
	* src/print.c (print_results): Report rules never reduced.
	* tests/conflicts.at, tests/reduce.at: Adjust.

2002-08-01  Akim Demaille  <akim@epita.fr>

	Instead of attaching lookaheads and duplicating the rules being
	reduced by a state, attach the lookaheads to the reductions.

	* src/state.h (state_t): Remove the `lookaheads',
	`lookaheads_rule' member.
	(reductions_t): Add a `lookaheads' member.
	Use a regular array for the `rules'.
	* src/state.c (reductions_new): Initialize the lookaheads member
	to 0.
	(state_rule_lookaheads_print): Adjust.
	* src/state.h, src/state.c (state_reductions_find): New.
	* src/conflicts.c (resolve_sr_conflict, set_conflicts)
	(count_rr_conflicts): Adjust.
	* src/lalr.c (LArule): Remove.
	(add_lookback_edge): Adjust.
	(state_lookaheads_count): New.
	(states_lookaheads_initialize): Merge into...
	(initialize_LA): this.
	(lalr_free): Adjust.
	* src/main.c (main): Don't free nullable and derives too early: it
	is used by --verbose.
	* src/print.c, src/print_graph.c, src/tables.c: Adjust.

2002-08-01  Akim Demaille  <akim@epita.fr>

	* src/derives.h, src/derives.c (derives): A `rule_t***' instead of
	`rule_number_t**'.
	(set_derives, free_derives): Rename as...
	(derives_compute, derives_free): this.
	Adjust all dependencies.
	* src/nullable.c (set_nullable, free_nullable): Rename as...
	(nullable_compute, nullable_free): these.
	(rule_list_t): Store rule_t *, not rule_number_t.
	* src/state.c (state_rule_lookaheads_print): Directly compare rule
	pointers, instead of their numbers.
	* src/main.c (main): Call nullable_free, and derives_free earlier,
	as they were lo longer used.

2002-08-01  Akim Demaille  <akim@epita.fr>

	* lib/timevar.c (get_time): Include children time.
	* src/lalr.h (LA, LArule): Don't export them: used with the
	state_t.
	* src/lalr.c (LA, LArule): Static.
	* src/lalr.h, src/lalr.c (lalr_free): New.
	* src/main.c (main): Call it.
	* src/tables.c (pack_vector): Check whether loc is >= to the
	table_size, not >.
	(pack_tables): Don't free froms, tos, conflict_tos, and pos...
	(tables_generate): do it, since that's also it which allocates
	them.
	Don't free LA and LArule, main does.

2002-07-31  Akim Demaille  <akim@epita.fr>

	Separate parser tables computation and output.

	* src/output.c (nvectors, base_t, base, base_ninf, conflict_table)
	(conflict_list, conflict_list_cnt, table, check, table_ninf)
	(yydefgoto, yydefact, high): Move to...
	* src/tables.h, src/tables.c: here.
	* src/output.c (vector_number_t, VECTOR_NUMBER_MAX)
	(VECTOR_NUMBER_MIN, state_number_to_vector_number)
	(symbol_number_to_vector_number, nvectors, BASE_MAX, BASE_MIN)
	(froms, tos, conflict_tos, tally, width, action_t, ACTION_MAX)
	(ACTION_MIN, actrow, order, nentries, pos, conflrow)
	(conflict_list_free, table_size, lowzero, table_grow, conflict_row)
	(action_row, save_row, token_actions, save_column, default_goto)
	(goto_actions, sort_actions, matching_state, pack_vector)
	(table_ninf_remap, pack_table, prepare_actions): Move to...
	* src/tables.c: here.
	* src/tables.h, src/tables.c(tables_generate, tables_free): New.
	* src/output.c (token_actions, output_base, output_conflicts)
	(output_check): Merge into...
	(prepare_actions): this.
	(actions_output): Rename as...
	(user_actions_output): this.
	* src/main.c (main): Call tables_generate and tables_free.

2002-07-31  Akim Demaille  <akim@epita.fr>

	Steal GCC's --time-report support.

	* lib/timevar.c, lib/timevar.h, lib/timevar.def: New,
	stolen/adjusted from GCC.
	* m4/stage.m4: Remove time related checks.
	* m4/timevar.m4: New.
	* configure.in: Adjust.
	* src/system.h: Adjust to using timevar.h.
	* src/getargs.h, src/getargs.c: Support trace_time for
	--trace=time.
	* src/main.c (stage): Remove.
	(main): Replace `stage' invocations with timevar calls.
	* src/output.c: Insert pertinent timevar calls.

2002-07-31  Akim Demaille  <akim@epita.fr>

	Let --trace have arguments.

	* src/getargs.h (enum trace_e): New.
	* src/getargs.c (trace_args, trace_types, trace_argmatch): New.
	(long_options, short_options): --trace/-T takes an optional
	argument.
	Change all the uses of trace_flag to reflect the new flags.
	* tests/sets.at (Firsts, Nullable, Broken Closure): Use --trace=sets.

	Strengthen `stage' portability.

	* m4/stage.m4 (BISON_PREREQ_STAGE): New.
	* configure.in: Use it.
	Don't check for malloc.h and sys/times.h.
	* src/system.h: Include them when appropriate.
	* src/main.c (stage): Compile only when mallinfo, struct mallinfo,
	times and struct tms are available.

2002-07-30  Akim Demaille  <akim@epita.fr>

	In verbose parse error message, don't report `error' as an
	expected token.
	* tests/actions.at (Printers and Destructors): Adjust.
	* tests/calc.at (Calculator $1): Adjust.
	* data/yacc.c, data/glr.c, data/lalr1.c: When making the verbose
	error message, do not report the parser accepts the error token in
	that state.

2002-07-30  Akim Demaille  <akim@epita.fr>

	Normalize conflict related messages.

	* src/complain.h, src/complain.c (warn, complain): New.
	* src/conflicts.c (conflicts_print): Use them.
	(conflict_report_yacc): New, extracted from...
	(conflicts_print): here.
	* tests/conflicts.at, tests/existing.at: Adjust.

2002-07-30  Akim Demaille  <akim@epita.fr>

	Report rules which are never reduced by the parser: those hidden
	by conflicts.

	* src/LR0.c (save_reductions): Don't make the final state too
	different: save its reduction (accept) instead of having a state
	without any action (no shift or goto, no reduce).
	Note: the final state is now a ``regular'' state, i.e., the
	parsers now contain `reduce 0' as default reduction.
	Nevertheless, since they decide to `accept' when yystate =
	final_state, they still will not reduce rule 0.
	* src/print.c (print_actions, print_reduction): Adjust.
	* src/output.c (action_row): Track reduced rules.
	(token_actions): Report rules never reduced.
	* tests/conflicts.at, tests/regression.at: Adjust.

2002-07-30  Akim Demaille  <akim@epita.fr>

	`stage' was accidently included in a previous patch.
	Initiate its autoconfiscation.

	* configure.in: Look for malloc.h and sys/times.h.
	* src/main.c (stage): Adjust.
	Report only when trace_flag.

2002-07-29  Akim Demaille  <akim@epita.fr>

	* src/state.h, src/state.c (transitions_t): Holds state_t*'s, not
	state_number_t.
	(errs_t): symbol_t*, not symbol_number_t.
	(reductions_t): rule_t*, not rule_number_t.
	(FOR_EACH_SHIFT): New.
	* src/LR0.c, src/conflicts.c, src/lalr.c, src/output.c
	* src/print.c, src/print_graph.c: Adjust.

2002-07-29  Akim Demaille  <akim@epita.fr>

	Use $accept and $end, as BYacc and BTYacc do, instead of $axiom and $.

	* src/symtab.h, src/symtab.c (eoftoken, axiom): Rename as...
	(endtoken, accept): these.
	* src/reader.c (reader): Set endtoken's default tag to "$end".
	Set undeftoken's tag to "$undefined" instead of "$undefined.".
	* doc/bison.texinfo (Table of Symbols): Mention $accept and $end.
	Adjust.

2002-07-29  Akim Demaille  <akim@epita.fr>

	* src/reduce.c (reduce_grammar): When the language is empty,
	complain about the start symbol, not the axiom.
	Use its location.
	* tests/reduce.at (Empty Language): New.

2002-07-26  Akim Demaille  <akim@epita.fr>

	* src/reader.h, src/reader.c (gram_error): ... can't get
	yycontrol without making too strong assumptions on the parser
	itself.
	* src/output.c (prepare_tokens): Use the real 0th value of
	token_translations instead of `0'.
	* src/parse-gram.y (yyerror): Don't rely on yycontrol being
	visible here.
	* data/yacc.c (yyreport_parse_error): Rename yylocation as yylloc
	for the time being: %locations ought to provide it to yyerror.

2002-07-25  Akim Demaille  <akim@epita.fr>

	* src/output.c (prepare_tokens): Go up to ntokens, not ntokens + 1.
	* doc/bison.texinfo (Decl Summary): s/$illegal/$undefined./.
	* tests/regression.at (Web2c Actions): Adjust.

2002-07-25  Akim Demaille  <akim@epita.fr>

	Stop storing rules from 1 to nrules + 1.

	* src/LR0.c, src/closure.c, src/derives.c, src/gram.c, src/lalr.c
	* src/nullable.c, src/output.c, src/print.c, src/reader.c
	* src/reduce.c: Allocate and free from &rules[0], not &rules[1].
	Iterate from 0 to nrules.
	Use rule_number_as_item_number and item_number_as_rule_number.
	Adjust to `derive' now containing possibly 0.
	* src/gram.h (rule_number_as_item_number, item_number_as_rule_number):
	Handle the `- 1' part in rule numbers from/to item numbers.
	* src/conflicts.c (log_resolution): Fix the message which reversed
	shift and reduce.
	* src/output.c (action_row): Initialize default_rule to -1.
	(token_actions): Adjust.
	* tests/sets.at (Nullable, Firsts): Fix the previously bogus
	expected output.
	* tests/conflicts.at (Resolved SR Conflicts): Likewise.

2002-07-25  Akim Demaille  <akim@epita.fr>

	* data/c.m4 (b4_c_function, b4_c_ansi_args, b4_c_ansi_arg)
	(b4_c_knr_arg_names, b4_c_knr_arg_name, b4_c_knr_arg_decls)
	(b4_c_knr_arg_decl): New.
	* data/yacc.c: Use it to define yysymprint, yydestruct, and
	yyreport_parse_error.

2002-07-25  Akim Demaille  <akim@epita.fr>

	* data/yacc.c (yyreport_parse_error): New, extracted from...
	(yyparse): here.
	(yydestruct, yysymprint): Move above yyparse.
	Be K&R compliant.

2002-07-25  Akim Demaille  <akim@epita.fr>

	* data/c.m4 (b4_ints_in, b4_int_type, b4_int_type_for): New,
	replace...
	(b4_sint_type, b4_uint_type): these.
	* data/yacc.c, data/glr.c, data/lalr1.cc: Use b4_int_type_for.
	* tests/regression.at (Web2c Actions): Adjust.

2002-07-25  Akim Demaille  <akim@epita.fr>

	* src/gram.h (TIEM_NUMBER_MAX): New.
	(item_number_of_rule_number, rule_number_of_item_number): Rename
	as...
	(rule_number_as_item_number, item_number_as_rule_number): these.
	Adjust dependencies.
	* src/output.c (vector_number_t, VECTOR_NUMBER_MAX)
	(VECTOR_NUMBER_MIN, state_number_to_vector_number)
	(symbol_number_to_vector_number): New.
	(order): Of vector_number_t* type.
	(base_t, BASE_MAX, BASE_MIN): New.
	(froms, tos, width, pos, check): Of base_t type.
	(action_number_t, ACTION_MIN, ACTION_MAX): New.
	(actrow): Of action_number_t type.
	(conflrow): Of unsigned int type.
	(table_ninf, base_ninf): New.
	(GENERATE_MUSCLE_INSERT_TABLE): Also output the `*_min' value.
	(muscle_insert_int_table, muscle_insert_base_table)
	(muscle_insert_rule_number_table): New.
	(prepare_tokens): Output `toknum' as int_table.
	(action_row): Returns a rule_number_t.
	Use ACTION_MIN, not SHRT_MIN.
	(token_actions): yydefact is rule_number_t*.
	(table_ninf_remap): New.
	(pack_table): Use it for `base' and `table'.
	* data/yacc.c, data/glr.c, data/lalr1.cc (YYFLAG): Remove,
	replaced with...
	(YYPACT_NINF, YYTABLE_NINF): these.
	(yypact, yytable): Compute their types instead of hard-coded
	`short'.
	* tests/regression.at (Web2c Actions): Adjust.

2002-07-19  Akim Demaille  <akim@epita.fr>

	* src/scan-gram.l (id): Can start with an underscore.

2002-07-16  Akim Demaille  <akim@epita.fr>

	* src/assoc.c, src/asssoc.h (assoc_t, assoc_to_string): New.
	Adjust all former `associativity' dependencies.
	* src/symtab.c (symbol_new): Default associativity is `undef', not
	`right'.
	(symbol_check_alias_consistence): Adjust.

2002-07-09  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo: Properly set the ``header'' part.
	Use @dircategory ``GNU programming tools'' as per Texinfo's
	documentation.
	Use @copying.

2002-07-09  Akim Demaille  <akim@epita.fr>

	* lib/quotearg.h: Protect against multiple inclusions.
	* src/location.h (location_t): Add a `file' member.
	(LOCATION_RESET, LOCATION_PRINT): Adjust.
	* src/complain.c (warn_at, complain_at, fatal_at): Drop
	`error_one_per_line' support.

2002-07-09  Akim Demaille  <akim@epita.fr>

	* src/complain.h, src/complain.c (warn, complain): Remove, unused.
	* src/reader.c (lineno): Remove.
	Adjust all dependencies.
	(get_merge_function): Take a location and use complain_at.
	* src/symtab.h, src/symtab.c (symbol_make_alias): Likewise.
	* tests/regression.at (Invalid inputs, Mixing %token styles):
	Adjust.

2002-07-09  Akim Demaille  <akim@epita.fr>

	* src/parse-gram.y (rules_or_grammar_declaration): Add an error
	recovery rule, and forbid extensions when --yacc.
	(gram_error): Use complain_at.
	* src/reader.c (reader): Exit if there were parse errors.

2002-07-09  Akim Demaille  <akim@epita.fr>

	* tests/synclines.at (AT_SYNCLINES_COMPILE): New.
	(AT_TEST_SYNCLINE): Adjust to unusual GCC outputs.
	Reported by R Blake <blakers@mac.com>.

2002-07-09  Akim Demaille  <akim@epita.fr>

	* data/yacc.c: Output the copyright notive in the header.

2002-07-03  Akim Demaille  <akim@epita.fr>

	* src/output.c (froms, tos): Are state_number_t.
	(save_column): sp, sp1, and sp2 are state_number_t.
	(prepare): Rename `final' as `final_state_number', `nnts' as
	`nterms_number', `nrules' as `rules_number', `nstates' as
	`states_number', and `ntokens' as `tokens_number'.  Remove `nsym',
	unused.
	* data/yacc.c, data/glr.c, data/lalr1.cc: Adjust.
	* data/lalr1.cc (nsym_): Remove, unused.

2002-07-03  Akim Demaille  <akim@epita.fr>

	* src/lalr.h, src/lalr.c (goto_number_t): New.
	* src/lalr.c (goto_list_t): New.
	Propagate them.
	* src/nullable.c (rule_list_t): New.
	Propagate.
	* src/types.h: Remove.

2002-07-03  Akim Demaille  <akim@epita.fr>

	* src/closure.c (print_fderives): Use rule_rhs_print.
	* src/derives.c (print_derives): Use rule_rhs_print.
	(rule_list_t): New, replaces `shorts'.
	(set_derives): Add comments.
	* tests/sets.at (Nullable, Firsts): Adjust.

2002-07-03  Akim Demaille  <akim@epita.fr>

	* src/output.c (prepare_actions): Free `tally' and `width'.
	(prepare_actions): Allocate and free `order'.
	* src/symtab.c (symbols_free): Free `symbols'.
	* src/scan-gram.l (scanner_free): Clear Flex's scanners memory.
	* src/output.c (m4_invoke): Move to...
	* src/scan-skel.l: here.
	(<<EOF>>): Close yyout, and free its name.

2002-07-03  Akim Demaille  <akim@epita.fr>

	Fix some memory leaks, and fix a bug: state 0 was examined twice.

	* src/LR0.c (new_state): Merge into...
	(state_list_append): this.
	(new_states): Merge into...
	(generate_states): here.
	(set_states): Don't ensure a proper `errs' state member here, do it...
	* src/conflicts.c (conflicts_solve): here.
	* src/state.h, src/state.c: Comment changes.
	(state_t): Rename member `shifts' as `transitions'.
	Adjust all dependencies.
	(errs_new): For consistency, also take the values as argument.
	(errs_dup): Remove.
	(state_errs_set): New.
	(state_reductions_set, state_transitions_set): Assert that no
	previous value was assigned.
	(state_free): New.
	(states_free): Use it.
	* src/conflicts.c (resolve_sr_conflict): Don't use an `errs_t' as
	temporary storage: use `errs' and `nerrs' as elsewhere.
	(set_conflicts): Allocate and free this `errs'.

2002-07-02  Akim Demaille  <akim@epita.fr>

	* lib/libiberty.h: New.
	* lib: Update the bitset implementation from upstream.
	* src/closure.c, src/lalr.c, src/output.c, src/print_graph.c,
	* src/state.c: Use BITSET_FOR_EACH, not BITSET_EXECUTE.
	* src/main.c: Adjust bitset stats calls.

2002-07-01  Paul Eggert  <eggert@twinsun.com>

	* src/scan-gram.l (<SC_ESCAPED_CHARACTER>): Convert to unsigned
	char, so that negative chars don't collide with $.

2002-06-30  Akim Demaille  <akim@epita.fr>

	Have the GLR tests be `warning' checked, and fix the warnings.

	* data/glr.c (YYFPRINTF): Always define it, not only when YYDEBUG
	(yyuserAction, yyreportAmbiguity): `Use' all the arguments.
	(yyremoveDeletes): `yyi' and `yyj' are size_t.
	Use YYFPRINTF when under if (YYDEBUG) to avoid empty `if' bodies.
	(yyaddDeferredAction): static.
	(yyglrReduce): yyi, yyk, amd yyposn are size_t.
	(yyreportParseError): yyprefix is const.
	yytokenp is used only when verbose.
	(yy__GNUC__): Replace with __GNUC__.
	(yypdumpstack): yyi is size_t.
	(yypreference): Un-yy local variables and arguments, to avoid
	clashes with `yyr1'.  Anyway, we are not in the user name space.
	(yytname_size): be an int, as is compared with ints.
	* tests/testsuite.at (AT_COMPILE, AT_PARSER_CHECK): New.
	Use them.
	* tests/cxx-gram.at: Use quotation to protect $1.
	Use AT_COMPILE to enable warnings hunts.
	Prototype yylex and yyerror.
	`Use' argc.
	Include `string.h', not `strings.h'.
	Produce and prototype stmtMerge only when used.
	yylex takes a location.

2002-06-30  Akim Demaille  <akim@epita.fr>

	We spend a lot of time in quotearg, in particular when --verbose.

	* src/symtab.c (symbol_get): Store a quoted version of the key.
	(symbol_tag_get, symbol_tag_get_n, symbol_tag_print): Remove.
	Adjust all callers.

2002-06-30  Akim Demaille  <akim@epita.fr>

	* src/state.h (reductions_t): Rename member `nreds' as num.
	(errs_t): Rename members `nerrs' and `errs' as `num' and `symbols'.
	* src/state.c (ERRS_ALLOC, REDUCTIONS_ALLOC): Use the correct types.

2002-06-30  Akim Demaille  <akim@epita.fr>

	* src/state.h, src/state.c (shift_t, SHIFT_SYMBOL, SHIFT_IS_SHIFT)
	(SHIFT_IS_GOTO, SHIFT_IS_ERROR, SHIFT_DISABLE, SHIFT_IS_DISABLED)
	(shifts_to): Rename as...
	(transition_t, TRANSITION_SYMBOL, TRANSITION_IS_TRANSITION)
	(TRANSITION_IS_GOTO, TRANSITION_IS_ERROR, TRANSITION_DISABLE)
	(TRANSITION_IS_DISABLED, transitions_to): these.

2002-06-30  Akim Demaille  <akim@epita.fr>

	* src/print.c (print_shifts, print_gotos): Merge into...
	(print_transitions): this.
	(print_transitions, print_errs, print_reductions): Align the
	lookaheads columns.
	(print_core, print_transitions, print_errs, print_state,
	print_grammar): Output empty lines separator before, not after.
	(state_default_rule_compute): Rename as...
	(state_default_rule): this.
	* tests/conflicts.at (Defaulted Conflicted Reduction),
	(Unresolved SR Conflicts, Resolved SR Conflicts): Adjust.
	* tests/regression.at (Rule Line Numbers, Web2c Report): Adjust.

2002-06-30  Akim Demaille  <akim@epita.fr>

	Display items as we display rules.

	* src/gram.h, src/gram.c (rule_lhs_print): New.
	* src/gram.c (grammar_rules_partial_print): Use it.
	* src/print.c (print_core): Likewise.
	* tests/conflicts.at (Defaulted Conflicted Reduction),
	(Unresolved SR Conflicts): Adjust.
	(Unresolved SR Conflicts): Adjust and rename as...
	(Resolved SR Conflicts): this, as was meant.
	* tests/regression.at (Web2c Report): Adjust.

2002-06-30  Akim Demaille  <akim@epita.fr>

	* src/print.c (state_default_rule_compute): New, extracted from...
	(print_reductions): here.
	Pessimize, but clarify the code.
	* tests/conflicts.at (Defaulted Conflicted Reduction): New.

2002-06-30  Akim Demaille  <akim@epita.fr>

	* src/output.c (action_row): Let default_rule be always a rule
	number.

2002-06-30  Akim Demaille  <akim@epita.fr>

	* src/closure.c (print_firsts, print_fderives, closure):
	Use BITSET_EXECUTE.
	* src/lalr.c (lookaheads_print): Likewise.
	* src/state.c (state_rule_lookaheads_print): Likewise.
	* src/print_graph.c (print_core): Likewise.
	* src/print.c (print_reductions): Likewise.
	* src/output.c (action_row): Likewise.
	Use SHIFT_IS_DISABLED, SHIFT_IS_SHIFT and SHIFT_SYMBOL.

2002-06-30  Akim Demaille  <akim@epita.fr>

	* src/print_graph.c: Use report_flag.

2002-06-30  Akim Demaille  <akim@epita.fr>

	* src/lalr.c (traverse, digraph, matrix_print, transpose): Move
	to...
	* src/relation.h, src/relation.c (traverse, relation_digraph)
	(relation_print, relation_transpose): New.

2002-06-30  Akim Demaille  <akim@epita.fr>

	* src/state.h, src/state.c (shifts_to): New.
	* src/lalr.c (build_relations): Use it.

2002-06-30  Akim Demaille  <akim@epita.fr>

	* src/gram.h (rule_number_t, RULE_NUMBER_MAX, int_of_rule_number)
	(item_number_of_rule_number, rule_number_of_item_number): New.
	* src/LR0.c, src/closure.c, src/derives.c, src/derives.h,
	* src/gram.c, src/lalr.c, src/nullable.c, src/output.c, src/print.c,
	* src/print_graph.c, src/reader.c, src/reduce.c, src/reduce.h:
	Propagate their use.
	Much remains to be done, in particular wrt `shorts' from types.h.

2002-06-30  Akim Demaille  <akim@epita.fr>

	* src/symtab.c (symbol_new): Initialize the `printer' member.

2002-06-30  Akim Demaille  <akim@epita.fr>

	* src/LR0.c (save_reductions): Remove, replaced by...
	* src/state.h, src/state.c (state_reductions_set): New.
	(reductions, errs): Rename as...
	(reductions_t, errs_t): these.
	Adjust all dependencies.

2002-06-30  Akim Demaille  <akim@epita.fr>

	* src/LR0.c (state_list_t, state_list_append): New.
	(first_state, last_state): Now symbol_list_t.
	(this_state): Remove.
	(new_itemsets, append_states, save_reductions): Take a state_t as
	argument.
	(set_states, generate_states): Adjust.
	(save_shifts): Remove, replaced by...
	* src/state.h, src/state.c (state_shifts_set): New.
	(shifts): Rename as...
	(shifts_t): this.
	Adjust all dependencies.
	* src/state.h (state_t): Remove the `next' member.

2002-06-30  Akim Demaille  <akim@epita.fr>

	* src/vcg.c (quote): Use slot 2, since we often pass symbol tag
	escaped in slot 0.

2002-06-30  Akim Demaille  <akim@epita.fr>

	Use hash.h for the state hash table.

	* src/LR0.c (STATE_HASH_SIZE, state_hash): Remove.
	(allocate_storage): Use state_hash_new.
	(free_storage): Use state_hash_free.
	(new_state, get_state): Adjust.
	* src/lalr.h, src/lalr.c (states): Move to...
	* src/states.h (state_t): Remove the `link' member, no longer
	used.
	* src/states.h, src/states.c: here.
	(state_hash_new, state_hash_free, state_hash_lookup)
	(state_hash_insert, states_free): New.
	* src/states.c (state_table, state_compare, state_hash): New.
	* src/output.c (output_actions): Do not free states now, since we
	still need to know the final_state number in `prepare', called
	afterwards.  Do it...
	* src/main.c (main): here: call states_free after `output'.

2002-06-30  Akim Demaille  <akim@epita.fr>

	* src/state.h, src/state.c (state_new): New, extracted from...
	* src/LR0.c (new_state): here.
	* src/state.h (STATE_ALLOC): Move to...
	* src/state.c: here.
	* src/LR0.h, src/LR0.c (nstates, final_state): Move to...
	* src/state.h, src/state.c: here.

2002-06-30  Akim Demaille  <akim@epita.fr>

	* src/reader.c (gensym): Rename as...
	* src/symtab.h, src/symtab.c (dummy_symbol_get): this.
	(getsym): Rename as...
	(symbol_get): this.

2002-06-30  Akim Demaille  <akim@epita.fr>

	* src/state.h (state_number_t, STATE_NUMBER_MAX): New.
	* src/LR0.c, src/LR0.h, src/conflicts.c, src/lalr.c, src/lalr.h,
	* src/output.c, src/print.c, src/print_graph.c: Propagate.
	* src/LR0.h, src/LR0.h (final_state): Is a state_t*.

2002-06-30  Akim Demaille  <akim@epita.fr>

	Make the test suite pass with warnings checked.

	* tests/actions.at (Printers and Destructors): Improve.
	Avoid unsigned vs. signed issues.
	* tests/calc.at: Don't exercise the scanner here, do it...
	* tests/input.at (Torturing the Scanner): here.

2002-06-28  Paul Hilfinger  <Hilfinger@CS.Berkeley.EDU>

	* data/glr.c: Correct typo in Emacs-mode directive.  Slightly
	reorganize first lines parallel to yacc.c.

2002-06-28  Akim Demaille  <akim@epita.fr>

	* data/c.m4 (b4_copyright, b4_sint_type, b4_uint_type, b4_token_define)
	(b4_token_enum, b4_token_defines): New, factored from...
	* data/lalr1.cc, data/yacc.c, glr.c: here.

2002-06-28  Akim Demaille  <akim@epita.fr>

	* data/yacc.c (yydestruct, yysymprint): Pacify GCC warnings for
	unused variables.
	* src/output.c (merger_output): static.

2002-06-28  Akim Demaille  <akim@epita.fr>

	* src/reader.h:	s/grammer_current_rule_merge_set/grammar_.../.
	* src/conflicts.c (conflicts_total_count): `i' is unsigned, to
	pacify GCC.
	* src/output.c (save_row): Initialize all the variables to pacify GCC.

2002-06-27  Paul Hilfinger  <Hilfinger@CS.Berkeley.EDU>

	Accumulated changelog for new GLR parsing features.

	* src/conflicts.c (count_total_conflicts): Change name to
	conflicts_total_count.
	* src/conflicts.h: Ditto.
	* src/output.c (token_actions): Use the new name.
	(output_conflicts): Change conflp => conflict_list_heads, and
	confl => conflict_list for better readability.
	* data/glr.c: Use the new names.
	* NEWS: Add self to GLR announcement.

	* src/reader.c (free_merger_functions): Cleanup: XFREE->free.

	* doc/bison.texinfo (GLR Parsers): Make corrections suggested by
	Akim Demaille.

	* data/bison.glr: Change name to glr.c
	* data/glr.c: Renamed from bison.glr.
	* data/Makefile.am: Add glr.c

	* src/getargs.c:

	* src/symlist.h:  Add dprec and merger fields to symbol_list_s.
	* src/symlist.c	(symbol_list_new): Initialize dprec and merger fields.

	Originally 2002-06-16  Paul Hilfinger  <Hilfinger@CS.Berkeley.EDU>

	* data/bison.glr: Be sure to restore the
	current #line when returning to the skeleton contents after having
	exposed the input file's #line.

	Originally 2002-06-13  Paul Hilfinger  <Hilfinger@CS.Berkeley.EDU>

	* data/bison.glr: Bring up to date with changes to bison.simple.

	Originally 2002-06-03  Paul Hilfinger  <Hilfinger@CS.Berkeley.EDU>

	* data/bison.glr: Correct definitions that use b4_prefix.
	Various reformatting.
	(GLRStack): Make yychar (in YYPURE case) and yytokenp as part of stack.
	(yyreportParseError, yyrecoverParseError, yyprocessOneStack): remove
	yytokenp argument; now part of stack.
	(yychar): Define to behave as documented.
	(yyclearin): Ditto.

	Originally 2002-05-14  Paul Hilfinger  <Hilfinger@CS.Berkeley.EDU>

	* src/reader.h: Add declaration for free_merger_functions.

	* src/reader.c (merge_functions): New variable.
	(get_merge_function): New function.
	(free_merger_functions): New function.
	(readgram): Check for %prec that is not followed by a symbol.
	Handle %dprec and %merge declarations.
	(packgram): Initialize dprec and merger fields in rules array.

	* src/output.c (conflict_tos, conflrow, conflict_table, conflict_list,
	conflict_list_cnt, conflict_list_free): New variables.
	(table_grow): Also grow conflict_table.
	(prepare_rules): Output dprec and merger tables.
	(conflict_row): New function.
	(action_row): Output conflict lists for GLR parser.  Don't use
	default reduction in conflicted states for GLR parser so that there
	are spaces for the conflict lists.
	(save_row): Also save conflict information.
	(token_actions): Allocate conflict list.
	(merger_output): New function.
	(pack_vector): Pack conflict table, too.
	(output_conflicts): New function to output yyconflp and yyconfl.
	(output_check): Allocate conflict_tos.
	(output_actions): Output conflict tables, also.
	(output_skeleton): Output b4_mergers definition.
	(prepare): Output b4_max_rhs_length definition.
	Use 'bison.glr' as default skeleton for GLR parsers.

	* src/gram.c (glr_parser): New flag.
	(grammar_free): Call free_merger_functions.

	* src/conflicts.c (count_rr_conflicts): Augment to optionally count
	all pairs of conflicting reductions, rather than just all tokens
	causing conflicts.  Needed to size conflict tables.
	(conflicts_output): Modify call to count_rr_conflicts for new
	interface.
	(conflicts_print): Ditto.
	(count_total_conflicts): New function.

	* src/reader.h (merger_list): New type.
	(merge_functions): New variable.

	* src/lex.h (tok_dprec, tok_merge): New token types.

	* src/gram.h (rule_s): Add dprec and merger fields.
	(glr_parser): New flag.

	* src/conflicts.h (count_total_conflicts): New function.

	* src/options.c (option_table): Add %dprec, %merge, and %glr-parser.

	* doc/bison.texinfo (Generalized LR Parsing): New section.
	(GLR Parsers): New section.
	(Language and Grammar): Mention GLR parsing.
	(Table of Symbols): Add %dprec, %glr-parser, %merge, GLR
	Correct typo ("tge" -> "the").

	* data/bison.glr: New skeleton for GLR parsing.

	* tests/cxx-gram.at: New tests for GLR parsing.

	* tests/testsuite.at: Include cxx-gram.at.

	* tests/Makefile.am: Add cxx-gram.at.

	* src/parse-gram.y:

	* src/scan-gram.l: Add %dprec, %glr-parser, %merge.

	* src/parse-gram.y: Grammar for %dprec, %merge, %glr-parser.

2002-06-27  Akim Demaille  <akim@epita.fr>

	* src/options.h, src/options.c: Remove.
	* src/getargs.c (short_options, long_options): New.

2002-06-27  Akim Demaille  <akim@epita.fr>

	* data/bison.simple, data/bison.c++: Rename as...
	* data/yacc.c, data/lalr1.cc: these.
	* doc/bison.texinfo (Environment Variables): Remove.

2002-06-25  Raja R Harinath  <harinath@cs.umn.edu>

	* src/getargs.c (report_argmatch): Initialize strtok().

2002-06-20  Akim Demaille  <akim@epita.fr>

	* data/bison.simple (b4_symbol_actions): New, replaces...
	(b4_symbol_destructor, b4_symbol_printer): these.
	(yysymprint): Be sure to call YYPRINT only for tokens, and using
	user token numbers.

2002-06-20  Akim Demaille  <akim@epita.fr>

	* data/bison.simple (yydestructor): Rename as...
	(yydestruct): this.

2002-06-20  Akim Demaille  <akim@epita.fr>

	* src/symtab.h, src/symtab.c (symbol_type_set)
	(symbol_destructor_set, symbol_precedence_set): The location is
	the last argument.
	Adjust all callers.

2002-06-20  Akim Demaille  <akim@epita.fr>

	* src/parse-gram.y (YYPRINT, yyprint): Don't mess with the parser
	internals.
	* src/reader.h, src/reader.c (grammar_current_rule_prec_set):
	Takes a location.
	* src/symtab.h, src/symtab.c (symbol_class_set)
	(symbol_user_token_number_set): Likewise.
	Adjust all callers.
	Promote complain_at.
	* tests/input.at (Type Clashes): Adjust.

2002-06-20  Akim Demaille  <akim@epita.fr>

	* data/bison.simple (YYLEX): Fix the declaration when
	%pure-parser.

2002-06-20  Akim Demaille  <akim@epita.fr>

	* data/bison.simple (yysymprint): Don't print the token number,
	just its name.
	* tests/actions.at (Destructors): Rename as...
	(Printers and Destructors): this.
	Also exercise %printer.

2002-06-20  Akim Demaille  <akim@epita.fr>

	* data/bison.simple (YYDSYMPRINT): New.
	Use it to remove many of the #if YYDEBUG/if (yydebug).

2002-06-20  Akim Demaille  <akim@epita.fr>

	* src/symtab.h, src/symtab.c (symbol_t): printer and
	printer_location are new members.
	(symbol_printer_set): New.
	* src/parse-gram.y (PERCENT_PRINTER): New token.
	Handle its associated rule.
	* src/scan-gram.l: Adjust.
	(handle_destructor_at, handle_destructor_dollar): Rename as...
	(handle_symbol_code_at, handle_symbol_code_dollar): these.
	* src/output.c (symbol_printers_output): New.
	(output_skeleton): Call it.
	* data/bison.simple (yysymprint): New.  Cannot be named yyprint
	since there are already many grammar files with a user `yyprint'.
	Replace the calls to YYPRINT to calls to yysymprint.
	* tests/calc.at: Adjust.
	* tests/torture.at (AT_DATA_STACK_TORTURE): Remove YYPRINT: it was
	taking advantage of parser very internal details (stack size!).

2002-06-20  Akim Demaille  <akim@epita.fr>

	* src/scan-gram.l: Complete the scanner with the missing patterns
	to pacify Flex.
	Use `quote' and `symbol_tag_get' where appropriate.

2002-06-19  Akim Demaille  <akim@epita.fr>

	* tests/actions.at (Destructors): Augment to test locations.
	* data/bison.simple (yydestructor): Pass it the current location
	if locations are enabled.
	Prototype only when __STDC__ or C++.
	Change the argument names to move into the yy name space: there is
	user code here.

2002-06-19  Akim Demaille  <akim@epita.fr>

	* data/bison.simple (b4_pure_if): New.
	Use it instead of #ifdef YYPURE.

2002-06-19  Akim Demaille  <akim@epita.fr>

	* data/bison.simple (b4_location_if): New.
	Use it instead of #ifdef YYLSP_NEEDED.

2002-06-19  Akim Demaille  <akim@epita.fr>

	Prepare @$ in %destructor, but currently don't bind it in the
	skeleton, as %location use is not cleaned up yet.

	* src/scan-gram.l (handle_dollar, handle_destructor_at)
	(handle_action_at): New.
	(handle_at, handle_action_dollar, handle_destructor_dollar): Take
	a braced_code_t and a location as additional arguments.
	(handle_destructor_dollar): Instead of requiring `b4_eval', just
	unquote one when outputting `b4_dollar_dollar'.
	Adjust callers.
	* data/bison.simple (b4_eval): Remove.
	(b4_symbol_destructor): Adjust.
	* tests/input.at (Invalid @n): Adjust.

2002-06-19  Zack Weinberg  <zack@codesourcery.com>

	* doc/bison.texinfo: Document ability to have multiple
	prologue sections.

2002-06-18  Akim Demaille  <akim@epita.fr>

	* src/files.c (compute_base_names): When computing the output file
	names from the input file name, strip the directory part.

2002-06-18  Akim Demaille  <akim@epita.fr>

	* data/bison.simple.new: Comment changes.
	Reported by Andreas Schwab.

2002-06-18  Matt Kraai  <kraai@alumni.cmu.edu>

	* data/bison.simple (yyoverflowlab): #ifndef yyoverflow, so that
	there are no `label `yyoverflowlab' defined but not used' warnings
	when yyoverflow is defined.

2002-06-18  Akim Demaille  <akim@epita.fr>

	* src/symtab.h, src/symtab.c (symbol_t): destructor_location is a
	new member.
	(symbol_destructor_set): Adjust.
	* src/output.c (symbol_destructors_output): Output the destructor
	locations.
	Output the symbol name.
	* data/bison.simple (b4_symbol_destructor): Adjust.

2002-06-18  Cris Bailiff  <c.bailiff@awayweb.com>
	and Akim Demaille  <akim@epita.fr>

	* data/bison.simple.new (yyerrlab1): Be sure to pop and destroy
	what's left on the stack when the error recovery hits EOF.
	* tests/actions.at (Destructors): Complete to exercise this case.

2002-06-17  Akim Demaille  <akim@epita.fr>

	* data/m4sugar/m4sugar.m4 (m4_map): Recognize when the list of
	arguments is really empty, not only equal to `[]'.
	* src/symtab.h, src/symtab.c (symbol_t): `destructor' is a new
	member.
	(symbol_destructor_set): New.
	* src/output.c (symbol_destructors_output): New.
	* src/reader.h (brace_code_t, current_braced_code): New.
	* src/scan-gram.l (BRACED_CODE): Use it to branch on...
	(handle_dollar): Rename as...
	(handle_action_dollar): this.
	(handle_destructor_dollar): New.
	* src/parse-gram.y (PERCENT_DESTRUCTOR): New.
	(grammar_declaration): Use it.
	* data/bison.simple (yystos): Is always defined.
	(yydestructor): New.
	* tests/actions.at (Destructors): New.
	* tests/calc.at (_AT_CHECK_CALC_ERROR): Don't rely on egrep.

2002-06-17  Akim Demaille  <akim@epita.fr>

	* src/symlist.h, src/symlist.c (symbol_list_length): New.
	* src/scan-gram.l (handle_dollar, handle_at): Compute the
	rule_length only when needed.
	* src/output.c (actions_output, token_definitions_output): Output
	the full M4 block.
	* src/symtab.c: Don't access directly to the symbol tag, use
	symbol_tag_get.
	* src/parse-gram.y: Use symbol_list_free.

2002-06-17  Akim Demaille  <akim@epita.fr>

	* src/reader.h, src/reader.c (symbol_list, symbol_list_new)
	(symbol_list_prepend, get_type_name): Move to...
	* src/symlist.h, src/symlist.c (symbol_list_t, symbol_list_new)
	(symbol_list_prepend, symbol_list_n_type_name_get): here.
	Adjust all callers.
	(symbol_list_free): New.
	* src/scan-gram.l (handle_dollar): Takes a location.
	* tests/input.at (Invalid $n): Adjust.

2002-06-17  Akim Demaille  <akim@epita.fr>

	* src/reader.h, src/reader.c (symbol_list_new): Export it.
	(symbol_list_prepend): New.
	* src/parse-gram.y (%union): `list' is a new member.
	(symbols.1): New, replaces...
	(terms_to_prec.1, nterms_to_type.1): these.
	* src/symtab.h, src/symtab.c (symbol_type_set, symbol_precedence_set)
	Take a location as additional argument.
	Adjust all callers.

2002-06-15  Akim Demaille  <akim@epita.fr>

	* src/parse-gram.y: Move %token in the declaration section so that
	we don't depend upon CVS Bison.

2002-06-15  Akim Demaille  <akim@epita.fr>

	* src/state.h, src/state.c (state_rule_lookaheads_print): New.
	* src/print.c (print_core): Use it.

2002-06-15  Akim Demaille  <akim@epita.fr>

	* src/conflicts.c (log_resolution): Accept the rule involved in
	the sr conflicts instead of the lookahead number that points to
	that rule.
	(flush_reduce): Accept the current lookahead vector as argument,
	instead of the index in LA.
	(resolve_sr_conflict): Accept the current number of lookahead
	bitset to consider for the STATE, instead of the index in LA.
	(set_conflicts): Adjust.
	* src/lalr.c, src/lalr.h, src/state.h: Comment changes.

2002-06-15  Akim Demaille  <akim@epita.fr>

	* src/state.h (state_t): Replace the `lookaheadsp' member, a
	short, with `lookaheads' (bitsetv), `lookaheads_rule' (rule_t**).
	Adjust all dependencies.
	* src/lalr.c (initialize_lookaheads): Split into...
	(states_lookaheads_count, states_lookaheads_initialize): these.
	(lalr): Adjust.

2002-06-15  Akim Demaille  <akim@epita.fr>

	* src/gram.h, src/gram.c (grammar_rules_partial_print): New, eved
	out of...
	(grammar_rules_print): here.
	* src/reduce.c (reduce_output): Use it.
	* tests/reduce.at (Useless Rules, Reduced Automaton)
	(Underivable Rules): Adjust.

2002-06-15  Akim Demaille  <akim@epita.fr>

	Copy BYacc's nice way to report the grammar.

	* src/gram.h, src/gram.c (grammar_rhs_print, grammar_rules_print):
	New.
	Don't print the rules' location, it is confusing and useless.
	(rule_print): Use grammar_rhs_print.
	* src/print.c (print_grammar): Use grammar_rules_print.

2002-06-15  Akim Demaille  <akim@epita.fr>

	Complete and rationalize `useless thing' warnings.

	* src/symtab.h, src/symtab.c (symbol_tag_get, symbol_tag_get_n)
	(symbol_tag_print): New.
	Use them everywhere in place of accessing directly the tag member.
	* src/gram.h, src/gram.c (rule_print): New.
	Use it where a rule used to be printed `by hand'.
	* src/reduce.c (nonterminals_reduce): Report the use nonterminals.
	(reduce_grammar_tables): Report the useless rules.
	(reduce_print): Useless things are a warning, not an error.
	Report it as such.
	* tests/reduce.at (Useless Nonterminals, Useless Rules):
	(Reduced Automaton, Underivable Rules): Adjust.
	* tests/regression.at (Web2c Report, Web2c Report): Adjust.
	* tests/conflicts.at (Unresolved SR Conflicts)
	(Solved SR Conflicts): Adjust.

2002-06-15  Akim Demaille  <akim@epita.fr>

	Let symbols have a location.

	* src/symtab.h, src/symtab.c (symbol_t): Location is a new member.
	(getsym): Adjust.
	Adjust all callers.
	* src/complain.h, src/complain.c (complain_at, fatal_at, warn_at):
	Use location_t, not int.
	* src/symtab.c (symbol_check_defined): Take advantage of the
	location.
	* tests/regression.at (Invalid inputs): Adjust.

2002-06-15  Akim Demaille  <akim@epita.fr>

	* src/parse-gram.y (YYLLOC_DEFAULT, current_lhs_location): New.
	(input): Don't try to initialize yylloc here, do it in the
	scanner.
	* src/scan-gram.l (YY_USER_INIT): Initialize yylloc.
	* src/gram.h (rule_t): Change line and action_line into location
	and action_location, of location_t type.
	Adjust all dependencies.
	* src/location.h, src/location.c (empty_location): New.
	* src/reader.h, src/reader.c (grammar_start_symbol_set)
	(grammar_symbol_append, grammar_rule_begin, grammar_rule_end)
	(grammar_current_rule_symbol_append)
	(grammar_current_rule_action_append): Expect a location as argument.
	* src/reader.c (grammar_midrule_action): Adjust to attach an
	action's location as dummy symbol location.
	* src/symtab.h, src/symtab.c (startsymbol_location): New.
	* tests/regression.at (Web2c Report, Rule Line Numbers): Adjust
	the line numbers.

2002-06-14  Akim Demaille  <akim@epita.fr>

	Grammar declarations may be found in the grammar section.

	* src/parse-gram.y (rules_or_grammar_declaration): New.
	(declarations): Each declaration may end with a semicolon, not
	just...
	(grammar_declaration): `"%union"'.
	(grammar): Branch to rules_or_grammar_declaration.

2002-06-14  Akim Demaille  <akim@epita.fr>

	* src/main.c (main): Invoke scanner_free.

2002-06-14  Akim Demaille  <akim@epita.fr>

	* src/output.c (m4_invoke): Extracted from...
	(output_skeleton): here.
	Free tempfile.

2002-06-14  Akim Demaille  <akim@epita.fr>

	* src/parse-gram.y (directives, directive, gram)
	(grammar_directives, precedence_directives, precedence_directive):
	Rename as...
	(declarations, declaration, grammar, grammar_declaration)
	(precedence_declaration, precedence_declarator): these.
	(symbol_declaration): New.

2002-06-14  Akim Demaille  <akim@epita.fr>

	* src/files.c (action_obstack): Remove, unused.
	(output_obstack): Remove it, and all its dependencies, as it is no
	longer needed.
	* src/reader.c (epilogue_set): Build the epilogue in the
	muscle_obstack.
	* src/output.h, src/output.c (muscle_obstack): Move to...
	* src/muscle_tab.h, src/muscle_tab.h: here.
	(muscle_init): Initialize muscle_obstack.
	(muscle_free): New.
	* src/main.c (main): Call it.

2002-06-14  Akim Demaille  <akim@epita.fr>

	* src/location.h: New, extracted from...
	* src/reader.h: here.
	* src/Makefile.am (noinst_HEADERS): Merge into
	(bison_SOURCES): this.
	Add location.h.
	* src/parse-gram.y: Use location_t instead of Bison's.
	* src/reader.h, src/reader.c (prologue_augment, epilogue_set):
	Use location_t instead of ints.

2002-06-14  Akim Demaille  <akim@epita.fr>

	* data/bison.simple, data/bison.c++: Be sure to restore the
	current #line when returning to the skeleton contents after having
	exposed the input file's #line.

2002-06-12  Akim Demaille  <akim@epita.fr>

	* src/scan-gram.l (SC_BRACED_CODE): Don't use `<.*>', it is too
	eager.
	* tests/actions.at (Exotic Dollars): New.

2002-06-12  Akim Demaille  <akim@epita.fr>

	* src/scan-gram.l (SC_PROLOGUE): Don't eat characters amongst
	['"/] too eagerly.
	* tests/input.at (Torturing the Scanner): New.

2002-06-11  Akim Demaille  <akim@epita.fr>

	* src/scan-gram.l (YY_OBS_INIT): Remove, replace with...
	[SC_COMMENT,SC_STRING,SC_CHARACTER,SC_BRACED_CODE,SC_PROLOGUE]
	[SC_EPILOGUE]: Output the quadrigraphs only when not in a comment.
	* src/reader.h, src/scan-gram.l (scanner_initialize): this.
	* src/reader.c (reader): Use it.

2002-06-11  Akim Demaille  <akim@epita.fr>

	* src/scan-gram.l (YY_OBS_FINISH): Don't set yylval.
	Adjust all callers.
	(scanner_last_string_free): New.

2002-06-11  Akim Demaille  <akim@epita.fr>

	* src/scan-gram.l (YY_INIT, YY_GROW, YY_FINISH): Rename as...
	(YY_OBS_INIT, YY_OBS_GROW, YY_OBS_FINISH): these.
	(last_string, YY_OBS_FREE): New.
	Use them when returning an ID.

2002-06-11  Akim Demaille  <akim@epita.fr>

	Have Bison grammars parsed by a Bison grammar.

	* src/reader.c, src/reader.h (prologue_augment): New.
	* src/reader.c (copy_definition): Remove.

	* src/reader.h, src/reader.c (gram_start_symbol_set, prologue_augment)
	(grammar_symbol_append, grammar_rule_begin, grammar_midrule_action)
	(grammar_current_rule_prec_set, grammar_current_rule_check)
	(grammar_current_rule_symbol_append)
	(grammar_current_rule_action_append): Export.
	* src/parse-gram.y (symbol_list_new, symbol_list_symbol_append_
	(symbol_list_action_append): Remove.
	Hook the routines from reader.
	* src/scan-gram.l: In INITIAL, characters and strings are tokens.
	* src/system.h (ATTRIBUTE_NORETURN, ATTRIBUTE_UNUSED): Now.

	* src/reader.c (read_declarations): Remove, unused.

	* src/parse-gram.y: Handle the epilogue.
	* src/reader.h, src/reader.c (gram_start_symbol_set): Rename as...
	(grammar_start_symbol_set): this.
	* src/scan-gram.l: Be sure to ``use'' yycontrol to keep GCC quiet.
	* src/reader.c (readgram): Remove, unused.
	(reader): Adjust to insert eoftoken and axiom where appropriate.

	* src/reader.c (copy_dollar): Replace with...
	* src/scan-gram.h (handle_dollar): this.
	* src/parse-gram.y: Remove `%thong'.

	* src/reader.c (copy_at): Replace with...
	* src/scan-gram.h (handle_at): this.

	* src/complain.h, src/complain.c (warn_at, complain_at, fatal_at):
	New.

	* src/scan-gram.l (YY_LINES): Keep lineno synchronized for the
	time being.

	* src/reader.h, src/reader.c (grammar_rule_end): New.

	* src/parse.y (current_type, current_class): New.
	Implement `%nterm', `%token' support.
	Merge `%term' into `%token'.
	(string_as_id): New.
	* src/symtab.h, src/symtab.c (symbol_make_alias): Don't pass the
	type name.

	* src/parse-gram.y: Be sure to handle properly the beginning of
	rules.

	* src/parse-gram.y: Handle %type.
	* src/reader.c (grammar_rule_end): Call grammar_current_rule_check.

	* src/parse-gram.y: More directives support.
	* src/options.c: No longer handle source directives.

	* src/parse-gram.y: Fix %output.

	* src/parse-gram.y: Handle %union.
	Use the prologue locations.
	* src/reader.c (parse_union_decl): Remove.

	* src/reader.h, src/reader.c (epilogue_set): New.
	* src/parse-gram.y: Use it.

	* data/bison.simple, data/bison.c++: b4_stype is now either not
	defined, then default to int, or to the contents of %union,
	without `union' itself.
	Adjust.
	* src/muscle_tab.c (muscle_init): Don't predefine `stype'.

	* src/output.c (actions_output): Don't output braces, as they are
	already handled by the scanner.

	* src/scan-gram.l (SC_CHARACTER): Set the user_token_number of
	characters to themselves.

	* tests/reduce.at (Reduced Automaton): End the grammars with %% so
	that the epilogue has a proper #line.

	* src/parse-gram.y: Handle precedence/associativity.

	* src/symtab.c (symbol_precedence_set): Requires the symbol to be
	a terminal.
	* src/scan-gram.l (SC_BRACED_CODE): Catch strings and characters.
	* tests/calc.at: Do not use `%token "foo"' as it makes not sense
	at all to define terminals that cannot be emitted.

	* src/scan-gram.l: Escape M4 characters.

	* src/scan-gram.l: Working properly with escapes in user
	strings/characters.

	* tests/torture.at (AT_DATA_TRIANGULAR_GRAMMAR)
	(AT_DATA_HORIZONTAL_GRAMMAR): Respect the `%token ID NUM STRING'
	grammar.
	Use more modest sizes, as for the time being the parser does not
	release memory, and therefore the process swallows a huge amount
	of memory.

	* tests/torture.at (AT_DATA_LOOKAHEADS_GRAMMAR): Adjust to the
	stricter %token grammar.

	* src/symtab.h (associativity): Add `undef_assoc'.
	(symbol_precedence_set): Do nothing when passed an undef_assoc.
	* src/symtab.c (symbol_check_alias_consistence): Adjust.

	* tests/regression.at (Invalid %directive): Remove, as it is now
	meaningless.
	(Invalid inputs): Adjust to the new error messages.
	(Token definitions): The new grammar doesn't allow too many
	eccentricities.

	* src/lex.h, src/lex.c: Remove.
	* src/reader.c (lastprec, skip_to_char, read_signed_integer)
	(copy_character, copy_string2, copy_string, copy_identifier)
	(copy_comment, parse_token_decl, parse_type_decl, parse_assoc_decl)
	(parse_muscle_decl, parse_dquoted_param, parse_skel_decl)
	(parse_action): Remove.
	* po/POTFILES.in: Adjust.

2002-06-11  Akim Demaille  <akim@epita.fr>

	* src/reader.c 	(parse_action): Don't store directly into the
	rule's action member: return the action as a string.
	Don't require `rule_length' as an argument: compute it.
	(grammar_current_rule_symbol_append)
	(grammar_current_rule_action_append): New, eved out from
	(readgram): here.
	Remove `action_flag', `rulelength', unused now.

2002-06-11  Akim Demaille  <akim@epita.fr>

	* src/reader.c (grammar_current_rule_prec_set).
	(grammar_current_rule_check): New, eved out from...
	(readgram): here.
	Remove `xaction', `first_rhs': useless.
	* tests/input.at (Type clashes): New.
	* tests/existing.at (GNU Cim Grammar): Adjust.

2002-06-11  Akim Demaille  <akim@epita.fr>

	* src/reader.c (grammar_midrule_action): New, Eved out from
	(readgram): here.

2002-06-11  Akim Demaille  <akim@epita.fr>

	* src/reader.c (grammar_rule_begin, previous_rule, current_rule):
	New.
	(readgram): Use them as replacement of inlined code, crule and
	crule1.

2002-06-11  Akim Demaille  <akim@epita.fr>

	* src/reader.c (grammar_end, grammar_symbol_append): New.
	(readgram): Use them.
	Make the use of `p' as local as possible.

2002-06-10  Akim Demaille  <akim@epita.fr>

	GCJ's parser requires the tokens to be defined before the prologue.

	* data/bison.simple: Output the token definition before the user's
	prologue.
	* tests/regression.at (Braces parsing, Duplicate string)
	(Mixing %token styles): Check the output from bison.
	(Early token definitions): New.

2002-06-10  Akim Demaille  <akim@epita.fr>

	* src/symtab.c (symbol_user_token_number_set): Don't complain when
	assigning twice the same user number to a token, so that we can
	use it in...
	* src/lex.c (lex): here.
	Also use `symbol_class_set' instead of hand written code.
	* src/reader.c (parse_assoc_decl): Likewise.

2002-06-10  Akim Demaille  <akim@epita.fr>

	* src/symtab.c, src/symtab.c (symbol_class_set)
	(symbol_user_token_number_set): New.
	* src/reader.c (parse_token_decl): Use them.
	Use a switch instead of ifs.
	Use a single argument.

2002-06-10  Akim Demaille  <akim@epita.fr>

	Remove `%thong' support as it is undocumented, unused, duplicates
	`%token's job, and creates useless e-mail traffic with people who
	want to know what it is, why it is undocumented, unused, and
	duplicates `%token's job.

	* src/reader.c (parse_thong_decl): Remove.
	* src/options.c (option_table): Remove "thong".
	* src/lex.h (tok_thong): Remove.

2002-06-10  Akim Demaille  <akim@epita.fr>

	* src/symtab.c, src/symtab.c (symbol_type_set)
	(symbol_precedence_set): New.
	* src/reader.c (parse_type_decl, parse_assoc_decl): Use them.
	(value_components_used): Remove, unused.

2002-06-09  Akim Demaille  <akim@epita.fr>

	Move symbols handling code out of the reader.

	* src/reader.h, src/reader.c (errtoken, undeftoken, eoftoken)
	(axiom): Move to...
	* src/symtab.h, src/symtab.c: here.

	* src/gram.c (start_symbol): Remove: use startsymbol->number.
	* src/reader.c (startval): Rename as...
	* src/symtab.h, src/symtab.c (startsymbol): this.
	* src/reader.c: Adjust.

	* src/reader.c (symbol_check_defined, symbol_make_alias)
	(symbol_check_alias_consistence, symbol_pack, symbol_translation)
	(token_translations_init)
	Move to...
	* src/symtab.c: here.
	* src/reader.c (packsymbols): Move to...
	* src/symtab.h, src/symtab.c (symbols_pack): here.
	* src/symtab.h, src/symtab.c (symbol_make_alias): Takes SYMVAL as
	argument.

2002-06-03  Akim Demaille  <akim@epita.fr>

	* src/muscle_tab.c (muscle_insert, muscle_find): Declarations,
	then statements.

2002-06-03  Akim Demaille  <akim@epita.fr>

	* src/muscle_tab.c (muscle_find, muscle_insert): Don't initialize
	structs with non literals.
	* src/scan-skel.l: never-interactive.
	* src/conflicts.c (enum conflict_resolution_e): No trailing
	comma.
	* src/getargs.c (usage): Split long literal strings.
	Reported by Hans Aberg.

2002-05-28  Akim Demaille  <akim@epita.fr>

	* data/bison.c++: Use C++ ostreams.
	(cdebug_): New member.

2002-05-28  Akim Demaille  <akim@epita.fr>

	* src/output.c (output_skeleton): Be sure to allocate enough room
	for `/' _and_ for `\0' in full_skeleton.

2002-05-28  Akim Demaille  <akim@epita.fr>

	* data/bison.c++: Catch up with bison.simple:
	2002-05-24  Paul Hilfinger  <Hilfinger@CS.Berkeley.EDU>
	and Paul Eggert  <eggert@twinsun.com>: `error' handing.
	2002-05-26  Akim Demaille  <akim@epita.fr>: stos_, token_number_,
	and popping traces.

2002-05-27  Paul Hilfinger  <Hilfinger@CS.Berkeley.EDU>

	* src/output.c (output_skeleton): Put an explicit path in front of
	the skeleton file name, rather than relying on the -I directory,
	to partially alleviate effects of having a skeleton file lying around
	in the current directory.

2002-05-27  Paul Hilfinger  <Hilfinger@CS.Berkeley.EDU>

	* src/conflicts.c (log_resolution): Correct typo:
	obstack_printf should be obstack_fgrow1.

2002-05-26  Akim Demaille  <akim@epita.fr>

	* src/state.h (state_t): `solved_conflicts' is a new member.
	* src/LR0.c (new_state): Set it to 0.
	* src/conflicts.h, src/conflicts.c (print_conflicts)
	(free_conflicts, solve_conflicts): Rename as...
	(conflicts_print, conflicts_free, conflicts_solve): these.
	Adjust callers.
	* src/conflicts.c (enum conflict_resolution_e)
	(solved_conflicts_obstack): New, used by...
	(log_resolution): this.
	Adjust to attach the conflict resolution to each state.
	Complete the description with the precedence/associativity
	information.
	(resolve_sr_conflict): Adjust.
	* src/print.c (print_state): Output its solved_conflicts.
	* tests/conflicts.at (Unresolved SR Conflicts)
	(Solved SR Conflicts): Exercise --report=all.

2002-05-26  Akim Demaille  <akim@epita.fr>

	* src/LR0.c, src/derives.c, src/gram.c, src/gram.h, src/lalr.c,
	* src/nullable.c, src/output.c, src/print.c, src/print_graph.c,
	* src/reader.c, src/reduce.c, src/state.h, src/symtab.h
	(token_number_t, item_number_as_token_number)
	(token_number_as_item_number, muscle_insert_token_number_table):
	Rename as...
	(symbol_number_t, item_number_as_symbol_number)
	(symbol_number_as_item_number, muscle_insert_symbol_number_table):
	these, since it is more appropriate.

2002-05-26  Akim Demaille  <akim@epita.fr>

	* tests/calc.at (AT_CHECK_CALC): Adjust: there are now additional
	`Error:' lines.
	* data/bison.simple (yystos) [YYDEBUG]: New.
	(yyparse) [YYDEBUG]: Display the symbols which are popped during
	error recovery.
	* tests/regression.at (Web2c Actions): Adjust: yystos is output now.

2002-05-25  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo (Debugging): Split into...
	(Tracing): this new section, its former contents, and...
	(Understanding): this new section.
	* src/getargs.h, src/getargs.c (verbose_flag): Remove, replaced
	by...
	(report_flag): this.
	Adjust all dependencies.
	(report_args, report_types, report_argmatch): New.
	(usage, getargs): Report/support -r, --report.
	* src/options.h
	(struct option_table_struct): Rename as..,
	(struct option_table_s): this.
	Rename the `set_flag' member to `flag' to match with getopt_long's
	struct.
	* src/options.c (option_table): Split verbose into an entry for
	%verbose, and another for --verbose.
	Support --report/-r, so remove -r from the obsolete --raw.
	* src/print.c: Attach full item sets and lookaheads reports to
	report_flag instead of trace_flag.
	* lib/argmatch.h, lib/argmatch.c: New, from Fileutils 4.1.

2002-05-24  Paul Hilfinger  <Hilfinger@CS.Berkeley.EDU>
	and Paul Eggert  <eggert@twinsun.com>

	* data/bison.simple (yyparse): Correct error handling to conform to
	POSIX and yacc.  Specifically, after syntax error is discovered,
	do not reduce further before shifting the error token.
	Clean up the code a bit by removing the labels yyerrdefault,
	yyerrhandle, yyerrpop.
	* NEWS: Document the above.

2002-05-20  Paul Hilfinger  <Hilfinger@CS.Berkeley.EDU>

	* data/bison.simple (yyr1): Don't use yy_token_number_type as element
	type; it isn't always big enough, since it doesn't necessarily
	include non-terminals.
	(yytranslate): Expand definition of yy_token_number_type, so that
	the latter can be removed.
	(yy_token_number_type): Remove, only one use.
	* data/bison.c++ (r1_): Parallel change to yyr1 in bison.simple---
	don't use TokenNumberType as element type.

	* tests/regression.at: Modify expected output to agree with change
	to yyr1 and yytranslate.

2002-05-13  Florian Krohm  <florian@edamail.fishkill.ibm.com>

	* src/reader.c (parse_action): Use copy_character instead of
	obstack_1grow.

2002-05-13  Akim Demaille  <akim@epita.fr>

	* tests/regression.at (Token definitions): Prototype yylex and
	yyerror.

2002-05-12  Paul Hilfinger  <Hilfinger@CS.Berkeley.EDU>

	* src/scan-skel.l: Correct off-by-one error in handling of __oline__.
	* data/bison.simple (b4_sint_type, b4_uint_type): Correct to reflect
	32-bit arithmetic.
	* data/bison.c++ (b4_sint_type, b4_uint_type): Ditto.

2002-05-07  Akim Demaille  <akim@epita.fr>

	* tests/synclines.at: Be sure to prototype yylex and yyerror to
	avoid GCC warnings.

2002-05-07  Akim Demaille  <akim@epita.fr>

	Kill GCC warnings.

	* src/reduce.c (nonterminals_reduce): Don't loop over RITEM: loop
	over the RHS of each rule.
	* src/gram.h, src/gram.c (nritems): Is `unsigned int', not int.
	* src/state.h (state_t): Member `nitems' is unsigned short.
	* src/LR0.c (get_state): Adjust.
	* src/reader.c (packgram): Likewise.
	* src/output.c (GENERATE_MUSCLE_INSERT_TABLE): `max' is of type
	`Type'.
	(muscle_insert_int_table): Remove, unused.
	(prepare_rules): Remove `max'.

2002-05-06  Akim Demaille  <akim@epita.fr>

	* src/closure.c (print_firsts): Display of the symbol tags.
	(bitmatrix_print): Move to...
	* lib/bitsetv-print.h, lib/bitsetv-print.c (bitsetv_matrix_dump):
	here.
	* tests/sets.at (Nullable, Broken Closure, Firsts): Adjust.

2002-05-06  Akim Demaille  <akim@epita.fr>

	* src/muscle_tab.c (muscle_m4_output): Must return TRUE for
	hash_do_for_each.

2002-05-06  Akim Demaille  <akim@epita.fr>

	* src/LR0.c (new_state, get_state): Instead of using the global
	`kernel_size' and `kernel_base', have two new arguments:
	`core_size' and `core'.
	Adjust callers.

2002-05-06  Akim Demaille  <akim@epita.fr>

	* src/reader.c (packgram): No longer end `ritem' with a 0
	sentinel: it is not used.

2002-05-05  Akim Demaille  <akim@epita.fr>

	New experimental feature: display the lookaheads in the report and
	graph.

	* src/print (print_core): When --trace-flag, display the rules
	lookaheads.
	* src/print_graph.c (print_core): Likewise.
	Swap the arguments.
	Adjust caller.

2002-05-05  Akim Demaille  <akim@epita.fr>

	* tests/torture.at (Many lookaheads): New test.

2002-05-05  Akim Demaille  <akim@epita.fr>

	* src/output.c (GENERATE_OUTPUT_TABLE): Replace with...
	(GENERATE_MUSCLE_INSERT_TABLE): this.
	(output_int_table, output_unsigned_int_table, output_short_table)
	(output_token_number_table, output_item_number_table): Replace with...
	(muscle_insert_int_table, muscle_insert_unsigned_int_table)
	(muscle_insert_short_table, muscle_insert_token_number_table)
	(muscle_insert_item_number_table): these.
	Adjust all callers.
	(prepare_tokens): Don't free `translations', since...
	* src/reader.h, src/reader.c (grammar_free): do it.
	Move to...
	* src/gram.h, src/gram.c (grammar_free): here.
	* data/bison.simple, data/bison.c++: b4_token_number_max is now
	b4_translate_max.

2002-05-05  Akim Demaille  <akim@epita.fr>

	* src/output.c (output_unsigned_int_table): New.
	(prepare_rules): `i' is unsigned.
	`prhs', `rline', `r2' are unsigned int.
	Rename muscle `rhs_number_max' as `rhs_max'.
	Output muscles `prhs_max', `rline_max', and `r2_max'.
	Free rline and r1.
	* data/bison.simple, data/bison.c++: Adjust to use these muscles
	to compute types instead of constant types.
	* tests/regression.at (Web2c Actions): Adjust.

2002-05-04  Akim Demaille  <akim@epita.fr>

	* src/symtab.h (SALIAS, SUNDEF): Rename as...
	(USER_NUMBER_ALIAS, USER_NUMBER_UNDEFINED): these.
	Adjust dependencies.
	* src/output.c (token_definitions_output): Be sure not to output a
	`#define 'a'' when fed with `%token 'a' "a"'.
	* tests/regression.at (Token definitions): New.

2002-05-03  Paul Eggert  <eggert@twinsun.com>

	* data/bison.simple (b4_token_defines): Also define YYTOKENTYPE
	for K&R C.

2002-05-03  gettextize  <bug-gnu-gettext@gnu.org>

	* Makefile.am (SUBDIRS): Remove intl.
	(EXTRA_DIST): Add config/config.rpath.

2002-05-03  Akim Demaille  <akim@epita.fr>

	* data/bison.simple (m4_if): Don't output empty enums.
	And actually, output valid enum definitions :(.

2002-05-03  Akim Demaille  <akim@epita.fr>

	* configure.bat: Remove, completely obsolete.
	* Makefile.am (EXTRA_DIST): Adjust.
	Don't distribute config.rpath...
	* config/Makefile.am (EXTRA_DIST): Do it.

2002-05-03  Akim Demaille  <akim@epita.fr>

	* configure.in (GETTEXT_VERSION): New.
	Suggested by Bruno Haible for the forthcoming Gettext 0.10.3.

2002-05-03  Akim Demaille  <akim@epita.fr>

	* data/bison.simple (b4_token_enum): New.
	(b4_token_defines): Use it to output tokens both as #define and
	enums.
	Suggested by Paul Eggert.
	* src/output.c (token_definitions_output): Don't output spurious
	white spaces.

2002-05-03  Akim Demaille  <akim@epita.fr>

	* data/m4sugar/m4sugar.m4: Update from CVS Autoconf.

2002-05-02  Robert Anisko  <robert@lrde.epita.fr>

	* data/bison.c++: Adapt expansion of $s and @s to the C++ parser.
	Update the stack class, give a try to deque as the default container.

2002-05-02  Akim Demaille  <akim@epita.fr>

	* data/bison.simple (yyparse): Do not implement @$ = @1.
	(YYLLOC_DEFAULT): Adjust to do it.
	* doc/bison.texinfo (Location Default Action): Fix.

2002-05-02  Akim Demaille  <akim@epita.fr>

	* src/reader.c (parse_braces): Merge into...
	(parse_action): this.

2002-05-02  Akim Demaille  <akim@epita.fr>

	* configure.in (ALL_LINGUAS): Remove.
	* po/LINGUAS, hr.po: New.

2002-05-02  Akim Demaille  <akim@epita.fr>

	Remove the so called hairy (semantic) parsers.

	* src/system.h (EXT_GUARD_C, EXT_STYPE_H): Remove.
	* src/gram.h, src/gram.c (semantic_parser): Remove.
	(rule_t): Remove the guard and guard_line members.
	* src/lex.h (token_t): remove tok_guard.
	* src/options.c (option_table): Remove %guard and %semantic_parser
	support.
	* src/output.c, src/output.h (guards_output): Remove.
	(prepare): Adjust.
	(token_definitions_output): Don't output the `T'
	tokens (???).
	(output_skeleton): Don't output the guards.
	* src/files.c, src/files.c (attrsfile): Remove.
	* src/reader.c (symbol_list): Remove the guard and guard_line
	members.
	Adjust dependencies.
	(parse_guard): Remove.
	* data/bison.hairy: Remove.
	* doc/bison.texinfo (Environment Variables): Remove occurrences of
	BISON_HAIRY.

2002-05-02  Akim Demaille  <akim@epita.fr>

	* src/reader.c (copy_at, copy_dollarm parse_braces, parse_action)
	(parse_guard): Rename the formal argument `stack_offset' as
	`rule_length', which is more readable.
	Adjust callers.
	(copy_at, copy_dollar): Instead of outputting the hard coded
	values of $$, $n and so forth, output invocation to b4_lhs_value,
	b4_lhs_location, b4_rhs_value, and b4_rhs_location.
	Note: this patch partially drops `semantic-parser' support: it
	always does `rule_length - n', where semantic parsers ought to
	always use `-n'.
	* data/bison.simple, data/bison.c++ (b4_lhs_value)
	(b4_lhs_location, b4_rhs_value, and b4_rhs_location: New.

2002-05-02  Akim Demaille  <akim@epita.fr>

	* configure.in (AC_INIT): Bump to 1.49b.
	(AM_INIT_AUTOMAKE): Short invocation.

2002-05-02  Akim Demaille  <akim@epita.fr>

	Version 1.49a.

2002-05-01  Akim Demaille  <akim@epita.fr>

	* src/skeleton.h: Remove.

2002-05-01  Akim Demaille  <akim@epita.fr>

	* src/skeleton.h: Fix the #endif.
	Reported by Magnus Fromreide.

2002-04-26  Paul Eggert  <eggert@twinsun.com>

	* data/bison.simple (YYSTYPE_IS_TRIVIAL, YYLTYPE_IS_TRIVIAL):
	Define if we define YYSTYPE and YYLTYPE, respectively.
	(YYCOPY): Fix [] quoting problem in the non-GCC case.

2002-04-25  Robert Anisko  <robert@lrde.epita.fr>

	* src/scan-skel.l: Postprocess quadrigraphs.

	* src/reader.c (copy_character): New function, used to output
	single characters while replacing `[' and `]' with quadrigraphs, to
	avoid troubles with M4 quotes.
	(copy_comment): Output characters with copy_character.
	(read_additionnal_code): Likewise.
	(copy_string2): Likewise.
	(copy_definition): Likewise.

	* tests/calc.at: Exercise M4 quoting.

2002-04-25  Akim Demaille  <akim@epita.fr>

	* tests/sets.at (AT_EXTRACT_SETS): Sed portability issue: no space
	between `!' and the command.
	Reported by Paul Eggert.

2002-04-24  Robert Anisko  <robert@lrde.epita.fr>

	* tests/calc.at: Exercise prologue splitting.

	* data/bison.simple, data/bison.c++: Use `b4_pre_prologue' and
	`b4_post_prologue' instead of `b4_prologue'.

	* src/output.c (prepare): Add the `pre_prologue' and `post_prologue'
	muscles.
	(output): Free pre_prologue_obstack and post_prologue_obstack.
	* src/files.h, src/files.c (attrs_obstack): Remove.
	(pre_prologue_obstack, post_prologue_obstack): New.
	* src/reader.c (copy_definition): Add a parameter to specify the
	obstack to fill, instead of using attrs_obstack unconditionally.
	(read_declarations): Pass pre_prologue_obstack to copy_definition if
	`%union' has not yet been seen, pass post_prologue_obstack otherwise.

2002-04-23  Paul Eggert  <eggert@twinsun.com>

	* data/bison.simple: Remove unnecessary commentary and white
	space differences from 1_29-branch.
	Depend on YYERROR_VERBOSE, not defined (YYERROR_VERBOSE).

	(union yyalloc, YYSTACK_GAP_MAX, YYSTACK_BYTES, YYCOPY,
	YYSTACK_RELOCATE): Do not define if yyoverflow is defined, or
	if this is a C++ parser and YYSTYPE or YYLTYPE has nontrivial
	constructors or destructors.

	(yyparse) [! defined YYSTACK_RELOCATE]: Do not relocate the stack.

2002-04-23  Akim Demaille  <akim@epita.fr>

	* tests/sets.at (AT_EXTRACT_SETS): Don't use 8 char long sed labels.
	* tests/synclines.at (AT_TEST_SYNCLINE): Be robust to GCC's
	location with columns.
	* tests/conflicts.at (%nonassoc and eof): Don't use `error.h'.
	All reported by Paul Eggert.

2002-04-22  Akim Demaille  <akim@epita.fr>

	* src/reduce.c (dump_grammar): Move to...
	* src/gram.h, src/gram.c (grammar_dump): here.
	Be sure to separate long item numbers.
	Don't read the members of a rule's prec if its nil.

2002-04-22  Akim Demaille  <akim@epita.fr>

	* src/output.c (table_size, table_grow): New.
	(MAXTABLE): Remove, replace uses with table_size.
	(pack_vector): Instead of dying when the table is too big, grow it.

2002-04-22  Akim Demaille  <akim@epita.fr>

	* data/bison.simple (yyr1): Its type is that of a token number.
	* data/bison.c++ (r1_): Likewise.
	* tests/regression.at (Web2c Actions): Adjust.

2002-04-22  Akim Demaille  <akim@epita.fr>

	* src/reader.c (token_translations_init): 256 is now the default
	value for the error token, i.e., it will be assigned another
	number if the user assigned 256 to one of her tokens.
	(reader): Don't force 256 to error.
	* doc/bison.texinfo (Symbols): Adjust.
	* tests/torture.at (AT_DATA_HORIZONTAL_GRAMMAR)
	(AT_DATA_TRIANGULAR_GRAMMAR): Number the tokens as 1, 2, 3
	etc. instead of 10, 20, 30 (which was used to `jump' over error
	(256) and undefined (2)).

2002-04-22  Akim Demaille  <akim@epita.fr>

	Propagate more token_number_t.

	* src/gram.h (token_number_as_item_number)
	(item_number_as_token_number): New.
	* src/output.c (GENERATE_OUTPUT_TABLE): New.
	Use it to create output_item_number_table and
	output_token_number_table.
	* src/LR0.c, src/derives.c, src/gram.c, src/gram.h, src/lalr.c,
	* src/lex.c, src/nullable.c, src/output.c, src/print.c,
	* src/print_graph.c, src/reader.c, src/reduce.c, src/state.h,
	* src/symtab.c, src/symtab.h: Use token_number_t instead of shorts.

2002-04-22  Akim Demaille  <akim@epita.fr>

	* src/output.h, src/output.c (get_lines_number): Remove.

2002-04-19  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo (Actions): Make clear that `|' is not the same
	as Lex/Flex'.
	(Debugging): More details about enabling the debugging features.
	(Table of Symbols): Describe $$, $n, @$, and @n.
	Suggested by Tim Josling.

2002-04-19  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo: Remove the uses of the obsolete @refill.

2002-04-10  Akim Demaille  <akim@epita.fr>

	* src/system.h: Rely on HAVE_LIMITS_H.
	Suggested by Paul Eggert.

2002-04-09  Akim Demaille  <akim@epita.fr>

	* tests/calc.at (_AT_CHECK_CALC_ERROR): Receive as argument the
	full stderr, and strip it according to the bison options, instead
	of composing the error message from different bits.
	This makes it easier to check for several error messages.
	Adjust all the invocations.
	Add an invocation exercising the error token.
	Add an invocation demonstrating a stupid error message.
	(_AT_DATA_CALC_Y): Follow the GCS: initial column is 1, not 0.
	Adjust the tests.
	Error message are for stderr, not stdout.

2002-04-09  Akim Demaille  <akim@epita.fr>

	* src/gram.h, src/gram.c (error_token_number): Remove, use
	errtoken->number.
	* src/reader.c (reader): Don't specify the user token number (2)
	for $undefined, as it uselessly prevents using it.
	* src/gram.h (token_number_t): Move to...
	* src/symtab.h: here.
	(state_t.number): Is a token_number_t.
	* src/print.c, src/reader.c: Use undeftoken->number instead of
	hard coded 2.
	(Even though this 2 is not the same as above: the number of the
	undeftoken remains being 2, it is its user token number which
	might not be 2).
	* src/output.c (prepare_tokens): Rename the `maxtok' muscle with
	`user_token_number_max'.
	Output `undef_token_number'.
	* data/bison.simple, data/bison.c++: Use them.
	Be sure to map invalid yylex return values to
	`undef_token_number'.  This saves us from gratuitous SEGV.

	* tests/conflicts.at (Solved SR Conflicts)
	(Unresolved SR Conflicts): Adjust.
	* tests/regression.at (Web2c Actions): Adjust.

2002-04-08  Akim Demaille  <akim@epita.fr>

	* data/bison.c++: s/b4_item_number_max/b4_rhs_number_max/.
	Adding #line.
	Remove the duplicate `typedefs'.
	(RhsNumberType): Fix the declaration and various other typos.
	Use __ofile__.
	* data/bison.simple: Use __ofile__.
	* src/scan-skel.l: Handle __ofile__.

2002-04-08  Akim Demaille  <akim@epita.fr>

	* src/gram.h (item_number_t): New, the type of item numbers in
	RITEM.  Note that it must be able to code symbol numbers as
	positive number, and the negation of rule numbers as negative
	numbers.
	Adjust all dependencies (pretty many).
	* src/reduce.c (rule): Remove this `short *' pointer: use
	item_number_t.
	* src/system.h (MINSHORT, MAXSHORT): Remove.
	Include `limits.h'.
	Adjust dependencies to using SHRT_MAX and SHRT_MIN.
	(shortcpy): Remove.
	(MAXTABLE): Move to...
	* src/output.c (MAXTABLE): here.
	(prepare_rules): Use output_int_table to output rhs.
	* data/bison.simple, data/bison.c++: Adjust.
	* tests/torture.at (Big triangle): Move the limit from 254 to
	500.
	* tests/regression.at (Web2c Actions): Ajust.

	Trying with bigger grammars shows various phenomena: at 3000 (28Mb
	of grammar file) bison is killed by my system, at 2000 (12Mb) bison
	passes, but produces negative #line number, once fixed, GCC is
	killed while compiling 14Mb, at 1500 (6.7 Mb of grammar, 8.2Mb of
	C), it passes.
	* src/state.h (state_h): Code input lines on ints, not shorts.

2002-04-08  Akim Demaille  <akim@epita.fr>

	* src/reduce.c (reduce_grammar): First reduce the nonterminals,
	and then the grammar.

2002-04-08  Akim Demaille  <akim@epita.fr>

	* src/system.h: No longer using strndup.

2002-04-07  Akim Demaille  <akim@epita.fr>

	* src/muscle_tab.h (MUSCLE_INSERT_LONG_INT): New.
	* src/output.c (output_table_data): Return the longest number.
	(prepare_tokens): Output `token_number_max').
	* data/bison.simple, data/bison.c++ (b4_sint_type, b4_uint_type):
	New.
	Use them to define yy_token_number_type/TokenNumberType.
	Use this type for yytranslate.
	* tests/torture.at (Big triangle): Push the limit from 124 to
	253.
	* tests/regression.at (Web2c Actions): Adjust.

2002-04-07  Akim Demaille  <akim@epita.fr>

	* tests/torture.at (Big triangle): New.
	(GNU AWK Grammar, GNU Cim Grammar): Move to...
	* tests/existing.at: here.

2002-04-07  Akim Demaille  <akim@epita.fr>

	* src/gram.h, src/gram.c (nitems): Remove, it is an alias of
	nritems.
	Adjust dependencies.

2002-04-07  Akim Demaille  <akim@epita.fr>

	* src/reader.c: Normalize increments to prefix form.

2002-04-07  Akim Demaille  <akim@epita.fr>

	* src/reader.c, symtab.c: Remove debugging code.

2002-04-07  Akim Demaille  <akim@epita.fr>

	Rename all the `bucket's as `symbol_t'.

	* src/gram.c, src/gram.h, src/lex.c, src/lex.h, src/output.c,
	* src/reader.c, src/reader.h, src/reduce.c, src/state.h,
	* src/symtab.c, src/symtab.h (bucket): Rename as...
	(symbol_t): this.
	(symbol_list_new, bucket_check_defined, bucket_make_alias)
	(bucket_check_alias_consistence, bucket_pack, bucket_translation)
	(bucket_new, bucket_free, hash_compare_bucket, hash_bucket)
	(buckets_new, buckets_free, buckets_do): Rename as...
	(symbol_list_new, symbol_check_defined, symbol_make_alias)
	(symbol_check_alias_consistence, symbol_pack, symbol_translation)
	(symbol_new, symbol_free, hash_compare_symbol_t, hash_symbol_t)
	(symbols_new, symbols_free, symbols_do): these.

2002-04-07  Akim Demaille  <akim@epita.fr>

	Use lib/hash for the symbol table.

	* src/gram.c (ntokens): Initialize to 1, to reserve a slot for
	EOF.
	* src/lex.c (lex): Set the `number' member of new terminals.
	* src/reader.c (bucket_check_defined, bucket_make_alias)
	(bucket_check_alias_consistence, bucket_translation): New.
	(reader, grammar_free, readgram, token_translations_init)
	(packsymbols): Adjust.
	(reader): Number the predefined tokens.
	* src/reduce.c (inaccessable_symbols): Just use hard coded numbers
	for predefined tokens.
	* src/symtab.h (bucket): Remove all the hash table related
	members.
	* src/symtab.c (symtab): Replace by...
	(bucket_table): this.
	(bucket_new, bucket_free, hash_compare_bucket, hash_bucket)
	(buckets_new, buckets_do): New.

2002-04-07  Akim Demaille  <akim@epita.fr>

	* src/gram.c (nitems, nrules, nsyms, ntokens, nvars, nritems)
	(start_symbol, max_user_token_number, semantic_parser)
	(error_token_number): Initialize.
	* src/reader.c (grammar, start_flag, startval, typed, lastprec):
	Initialize.
	(reader): Don't.
	(errtoken, eoftoken, undeftoken, axiom): Extern.

2002-04-07  Akim Demaille  <akim@epita.fr>

	* src/gram.h (rule_s): prec and precsym are now pointers
	to the bucket giving the priority/associativity.
	Member `associativity' removed: useless.
	* src/reduce.c, src/conflicts.c: Adjust.

2002-04-07  Akim Demaille  <akim@epita.fr>

	* src/lalr.c, src/LR0.c, src/closure.c, src/gram.c, src/reduce.c:
	Properly escape the symbols' TAG when outputting them.

2002-04-07  Akim Demaille  <akim@epita.fr>

	* src/lalr.h (LA): Is a bitsetv, not bitset*.

2002-04-07  Akim Demaille  <akim@epita.fr>

	* src/lalr.h, src/lalr.c (LAruleno): Replace with...
	(LArule): this, which is an array to rule_t*.
	* src/print.c, src/conflicts.c: Adjust.

2002-04-07  Akim Demaille  <akim@epita.fr>

	* src/gram.h (rule_t): Rename `number' as `user_number'.
	`number' is a new member.
	Adjust dependencies.
	* src/reduce.c (reduce_grammar_tables): Renumber rule_t.number.

2002-04-07  Akim Demaille  <akim@epita.fr>

	As a result of the previous patch, it is no longer needed
	to reorder ritem itself.

	* src/reduce.c (reduce_grammar_tables): Don't sort RITEM.

2002-04-07  Akim Demaille  <akim@epita.fr>

	Be sure never to walk through RITEMS, but use only data related to
	the rules themselves. RITEMS should be banished.

	* src/output.c (output_token_translations): Rename as...
	(prepare_tokens): this.
	In addition to `translate', prepare the muscles `tname' and
	`toknum', which were handled by...
	(output_rule_data): this.
	Remove, and move the remainder of its outputs into...
	(prepare_rules): this new routines, which also merges content from
	(output_gram): this.
	(prepare_rules): Be sure never to walk through RITEMS.
	(output_stos): Rename as...
	(prepare_stos): this.
	(output): Always invoke prepare_states, after all, just don't use it
	in the output if you don't need it.

2002-04-07  Akim Demaille  <akim@epita.fr>

	* src/LR0.c (new_state): Display `nstates' as the name of the
	newly created state.
	Adjust to initialize first_state and last_state if needed.
	Be sure to distinguish the initial from the final state.
	(new_states): Create the itemset of the initial state, and use
	new_state.
	* src/closure.c (closure): Now that the initial state has its
	items properly set, there is no need for a special case when
	creating `ruleset'.

	As a result, now the rule 0, reducing to $axiom, is visible in the
	outputs.  Adjust the test suite.

	* tests/conflicts.at (Solved SR Conflicts)
	(Unresolved SR Conflicts): Adjust.
	* tests/regression.at (Web2c Report, Rule Line Numbers): Idem.
	* tests/conflicts.at (S/R in initial): New.

2002-04-07  Akim Demaille  <akim@epita.fr>

	* src/LR0.c (allocate_itemsets): Don't loop over ritem: loop over
	the RHS of the rules.
	* src/output.c (output_gram): Likewise.

2002-04-07  Akim Demaille  <akim@epita.fr>

	* src/gram.h (rule_t): `lhs' is now a pointer to the symbol's
	bucket.
	Adjust all dependencies.
	* src/reduce.c (nonterminals_reduce): Don't forget to renumber the
	`number' of the buckets too.
	* src/gram.h: Include `symtab.h'.
	(associativity): Move to...
	* src/symtab.h: here.
	No longer include `gram.h'.

2002-04-07  Akim Demaille  <akim@epita.fr>

	* src/gram.h, src/gram.c (rules_rhs_length): New.
	(ritem_longest_rhs): Use it.
	* src/gram.h (rule_t): `number' is a new member.
	* src/reader.c (packgram): Set it.
	* src/reduce.c (reduce_grammar_tables): Move the useless rules at
	the end of `rules', and count them out of `nrules'.
	(reduce_output, dump_grammar): Adjust.
	* src/print.c (print_grammar): It is no longer needed to check for
	the usefulness of a rule, as useless rules are beyond `nrules + 1'.
	* tests/reduce.at (Reduced Automaton): New test.

2002-04-07  Akim Demaille  <akim@epita.fr>

	* src/reduce.c (inaccessable_symbols): Fix a buglet: because of a
	lacking `+ 1' to nrules, Bison reported as useless a token if it
	was used solely to set the precedence of the last rule...

2002-04-07  Akim Demaille  <akim@epita.fr>

	* data/bison.c++, data/bison.simple: Don't output the current file
	name in #line, to avoid useless diffs between two identical
	outputs under different names.

2002-04-07  Akim Demaille  <akim@epita.fr>

	* src/closure.c, src/print.c, src/reader.c, src/reduce.c:
	Normalize loops to using `< nrules + 1', not `<= nrules'.

2002-04-07  Akim Demaille  <akim@epita.fr>

	* TODO: Update.

2002-04-07  Akim Demaille  <akim@epita.fr>

	* src/output.c, src/reader.c, src/symtab.c, src/symtab.h: Rename
	bucket.value as bucket.number.

2002-04-07  Akim Demaille  <akim@epita.fr>

	* src/closure.c, src/derives.c, src/gram.h, src/lalr.c,
	* src/nullable.c, src/output.c, src/print.c, src/print_graph.c,
	* src/reader.c, src/reduce.c: Let rule_t.rhs point directly to the
	RHS, instead of being an index in RITEMS.

2002-04-04  Paul Eggert  <eggert@twinsun.com>

	* doc/bison.texinfo: Update copyright date.
	(Rpcalc Lexer, Symbols, Token Decl): Don't assume ASCII.
	(Symbols): Warn about running Bison in one character set,
	but compiling and/or running in an incompatible one.
	Warn about character code 256, too.

2002-04-03  Paul Eggert  <eggert@twinsun.com>

	* src/bison.data (YYSTACK_ALLOC): Depend on whether
	YYERROR_VERBOSE is nonzero, not whether it is defined.

	Merge changes from bison-1_29-branch.

2002-03-20  Paul Eggert  <eggert@twinsun.com>

	Merge fixes from Debian bison_1.34-1.diff.

	* configure.in (AC_PREREQ): 2.53.

2002-03-20  Akim Demaille  <akim@epita.fr>

	* src/conflicts.c (log_resolution): Argument `resolution' is const.

2002-03-19  Paul Eggert  <eggert@twinsun.com>

	* src/bison.simple (YYCOPY): New macro.
	(YYSTACK_RELOCATE): Use it.
	Remove Type arg; no longer needed.  All callers changed.
	(yymemcpy): Remove; no longer needed.

	* Makefile.am (AUTOMAKE_OPTIONS): 1.6.
	* doc/Makefile.am (AUTOMAKE_OPTIONS): Remove.

2002-03-19  Akim Demaille  <akim@epita.fr>

	Test and fix the #line outputs.

	* tests/atlocal.at (GCC): New.
	* tests/synclines.at (AT_TEST_SYNCLINE): New macro.
	(Prologue synch line, ,%union synch line, Postprologue synch line)
	(Action synch line, Epilogue synch line): New tests.
	* src/reader.c (parse_union_decl): Define the muscle stype_line.
	* data/bison.simple, data/bison.c++: Use it.

2002-03-19  Akim Demaille  <akim@epita.fr>

	* tests/regression.at (%nonassoc and eof, Unresolved SR Conflicts)
	(Solved SR Conflicts, %expect not enough, %expect right)
	(%expect too much): Move to...
	* tests/conflicts.at: this new file.

2002-03-19  Akim Demaille  <akim@epita.fr>

	* data/m4sugar/m4sugar.m4: Update from CVS Autoconf.
	* data/bison.simple, data/bison.c++: Handle the `#define' part, so
	that we can move to enums for instance.
	* src/output.c (token_definitions_output): Output a list of
	`token-name, token-number' instead of the #define.
	(output_skeleton): Name this list `b4_tokens', not `b4_tokendefs'.

2002-03-14  Akim Demaille  <akim@epita.fr>

	Use Gettext 0.11.1.

2002-03-09  Robert Anisko  <robert@lrde.epita.fr>

	* data/bison.c++: Make the user able to add members to the generated
	parser by subclassing.

2002-03-05  Robert Anisko  <robert@lrde.epita.fr>

	* src/reader.c (read_additionnal_code): `c' should be an integer, not
	a character.
	Reported by Nicolas Tisserand and Nicolas Burrus.

2002-03-04  Robert Anisko  <robert@lrde.epita.fr>

	* src/reader.c: Warn about lacking semi-colons, do not complain.

2002-03-04  Robert Anisko  <robert@lrde.epita.fr>

	* data/bison.c++: Remove a debug line.

2002-03-04  Robert Anisko  <robert@lrde.epita.fr>

	* data/bison.c++: Unmerge value as yylval and value as yyval.  Unmerge
	location as yylloc and location as yyloc.  Use YYLLOC_DEFAULT, and
	provide a default implementation.

2002-03-04  Akim Demaille  <akim@epita.fr>

	* tests/input.at (Invalid $n, Invalid @n): Add the ending `;'.
	* tests/output.at (AT_CHECK_OUTPUT): Likewise.
	* tests/headers.at (AT_TEST_CPP_GUARD_H): Ditto.
	* tests/semantic.at (Parsing Guards): Similarly.
	* src/reader.at (readgram): Complain if the last rule is not ended
	with a semi-colon.

2002-03-04  Akim Demaille  <akim@epita.fr>

	* src/warshall.h, src/warshall.c (bitmatrix_print): Move to...
	* src/closure.c: here.
	(set_firsts): Use bitsetv_reflexive_transitive_closure instead of
	RTC.
	* src/warshall.h, src/warshall.c: Remove.
	* tests/sets.at (Broken Closure): Adjust.

2002-03-04  Akim Demaille  <akim@epita.fr>

	* src/output.c (output_skeleton): tempdir is const.
	bytes_read is unused.

2002-03-04  Akim Demaille  <akim@epita.fr>

	* lib/bbitset.h, lib/bitset.c, lib/bitset.h, lib/bitsetv.c,
	* lib/bitsetv.h, lib/ebitset.c, lib/lbitset.c, lib/sbitset.c:
	Update.
	From Michael Hayes.

2002-03-04  Akim Demaille  <akim@epita.fr>

	* src/closure.c (closure): `r' is unused.

2002-03-04  Akim Demaille  <akim@epita.fr>

	* tests/sets.at (Broken Closure): Add the ending `;'.
	* src/reader.at (readgram): Complain if a rule is not ended with a
	semi-colon.

2002-03-04  Akim Demaille  <akim@epita.fr>

	* src/conflicts.c (set_conflicts): Use bitset_disjoint_p.
	(count_sr_conflicts): Use bitset_count.
	* src/reduce.c (inaccessable_symbols): Ditto.
	(bits_size): Remove.
	* src/warshall.h, src/warshall.c: Convert to bitsetv.

2002-03-04  Akim Demaille  <akim@epita.fr>

	* src/closure.c, src/conflicts.c, src/lalr.c, src/print.c,
	* src/reduce.c: Remove the `bitset_zero's following the
	`bitset_create's, as now it is performed by the latter.

2002-03-04  Akim Demaille  <akim@epita.fr>

	* lib/bitset.c, lib/bitset.h, lib/bitsetv.c, lib/bitsetv.h,
	* lib/ebitset.c, lib/ebitset.h, lib/lbitset.c, lib/lbitset.h,
	* lib/sbitset.c, lib/sbitset.h, lib/bbitset.h: Update from the
	latest sources from Michael.

2002-03-04  Akim Demaille  <akim@epita.fr>

	* src/output.c (output): Don't free the grammar.
	* src/reader.c (grammar_free): New.
	* src/main.c (main): Call it and don't free symtab here.

2002-03-04  Akim Demaille  <akim@epita.fr>

	* src/lex.c (parse_percent_token): Be sure to 0-end token_buffer
	before returning.
	Reported by Benoit Perrot.

2002-03-04  Akim Demaille  <akim@epita.fr>

	Use bitset operations when possible, not loops over bits.

	* src/conflicts.c (set_conflicts, count_sr_conflicts): Use
	bitset_or.
	* src/print.c (print_reductions): Use bitset_and, bitset_andn.
	* src/reduce.c (useless_nonterminals): Formatting changes.
	* src/warshall.c (TC): Use bitset_or.

2002-03-04  Akim Demaille  <akim@epita.fr>

	* src/lalr.h, src/lalr.c (tokensetsize): Remove, unused.
	* src/system.h (BITS_PER_WORD, WORDSIZE, SETBIT, RESETBIT, BITISSET):
	Ditto.

2002-03-04  Akim Demaille  <akim@epita.fr>

	* src/lalr.c (F): Now a bitset*.
	Adjust all dependencies.

2002-03-04  Akim Demaille  <akim@epita.fr>

	* src/conflicts.c (shiftset, lookaheadset): Now bitset.
	Adjust all dependencies.

2002-03-04  Akim Demaille  <akim@epita.fr>

	* src/L0.c, src/LR0.h (nstates): Be size_t.
	Adjust comparisons (signed vs unsigned).
	* src/conflics.c, src/lalr.c, src/lalr.h, src/output.c (LA): Now a
	bitset*.
	Adjust all dependencies.

2002-03-04  Akim Demaille  <akim@epita.fr>

	* src/closure.c (firsts): Now, also a bitset.
	Adjust all dependencies.
	(varsetsize): Remove, now unused.
	* src/warshall.h, src/warshall.c: Now work on arrays of bitsets.

2002-03-04  Akim Demaille  <akim@epita.fr>

	* src/print.c: Convert to use bitset.h, not hand coded iterations
	over ints.

2002-03-04  Akim Demaille  <akim@epita.fr>

	* src/reduce.c: Convert to use bitset.h, not hand coded BSet.

2002-03-04  Akim Demaille  <akim@epita.fr>

	* src/closure.c (ruleset): Be a bitset.
	(rulesetsize): Remove.

2002-03-04  Akim Demaille  <akim@epita.fr>

	* lib/bitset-int.h, lib/bitset.c, lib/bitset.h, lib/bitsetv.c,
	* lib/bitsetv.h, lib/ebitset.c, lib/ebitset.h, lib/lbitset.c,
	* lib/lbitset.h, lib/sbitset.c, lib/sbitset.h: New.
	* src/closure.c (fderives): Be an array of bitsets.

2002-02-28  Robert Anisko  <robert@lrde.epita.fr>

	* data/bison.c++: Merge the two generated headers.  Insert a copyright
	notice in each output file.

2002-02-28  Akim Demaille  <akim@epita.fr>

	* data/bison.c++: Copy the prologue of bison.simple to fetch
	useful M4 definitions, such as b4_header_guard.

2002-02-25  Akim Demaille  <akim@epita.fr>

	* src/getargs.c (version): Give the name of the authors, and use a
	translator friendly scheme for the bgr
	copyright notice.

2002-02-25  Akim Demaille  <akim@epita.fr>

	* src/output.c (header_output): Remove, now handled completely via
	M4.

2002-02-25  Akim Demaille  <akim@epita.fr>

	* m4/m4.m4: New, from CVS Autoconf.
	* configure.in: Invoke it.
	* src/output.c (output_skeleton): Use its result instead of the
	hard coded name.

2002-02-25  Akim Demaille  <akim@epita.fr>

	* lib/tempname.c, lib/mkstemp.c, m4/mkstemp.m4: New, stolen from
	Fileutils 4.1.5.
	* configure.in: Invoke UTILS_FUNC_MKSTEMP.
	* src/output.c (output_skeleton): Use mkstemp to create a real
	temporary file.
	Move the filling of `skeleton' and its muscle to...
	(prepare): here.
	(output): Move the definition of the prologue muscle to...
	(prepare): here.
	* src/system.h (DEFAULT_TMPDIR): New.

2002-02-14  Paul Eggert  <eggert@twinsun.com>

	Remove the support for C++ namespace cleanliness; it was
	causing more problems than it was curing, since it didn't work
	properly on some nonstandard C++ compilers.  This can wait
	for a proper C++ parser.

	* NEWS: Document this.
	* doc/bison.texinfo (Bison Parser, Debugging): Remove special mention
	of C++, as it's treated like C now.
	* src/bison.simple (YYSTD): Remove.
	(YYSIZE_T, YYFPRINTF, YYPARSE_PARAM_ARG, YYPARSE_PARAM_DECL):
	Treat C++ just like Standard C instead of trying to support
	namespace cleanliness.

2002-02-14  Akim Demaille  <akim@epita.fr>

	* tests/regression.at (else): Adjust to Andreas' change.

2002-02-14  Akim Demaille  <akim@epita.fr>

	* lib/Makefile.am (EXTRA_DIST): Ship strnlen.c.

2002-02-13  Andreas Schwab  <schwab@suse.de>

	* src/output.c (output_rule_data): Don't output NULL, it might
	not be defined yet.

2002-02-11  Robert Anisko  <robert@lrde.epita.fr>

	* data/bison.c++ (YYDEBUG, YYERROR_VERBOSE): After the prologue.
	(Copyright notice): Update.

2002-02-11  Akim Demaille  <akim@epita.fr>

	* tests/regression.at (%nonassoc and eof): Don't include
	nonportable headers.

2002-02-08  Robert Anisko  <robert@lrde.epita.fr>

	* data/bison.c++: Correct error recovery.  Make the user able to
	initialize the starting location.

2002-02-07  Akim Demaille  <akim@epita.fr>

	* tests/input.at: New.

2002-02-07  Robert Anisko  <robert@lrde.epita.fr>

	* data/bison.c++: Replace some direct m4 expansions by constants.  Be
	more consistent when naming methods and variables.  Put preprocessor
	directives around tables only needed for debugging.

2002-02-07  Robert Anisko  <robert@lrde.epita.fr>

	* data/bison.c++ (yy::b4_name::print_): New method, replaces yyprint in
	C++ parsers.
	(yy::b4_name::parse): Use print_.

2002-02-07  Robert Anisko  <robert@lrde.epita.fr>

	* data/bison.c++ (yy::b4_name::parse): Error recovery is back.

2002-02-07  Robert Anisko  <robert@lrde.epita.fr>

	* data/bison.c++ (yy::b4_name::error_): New method, replaces yyerror in
	C++ parsers.
	(yy::b4_name::parse): Build verbose error messages, and use error_.

2002-02-06  Robert Anisko  <robert@lrde.epita.fr>

	* data/bison.c++: Fix m4 quoting in comments.

2002-02-06  Robert Anisko  <robert@lrde.epita.fr>

	* data/bison.c++: Adjust the parser code.  Fix some muscles that were
	not expanded by m4.

2002-02-05  Akim Demaille  <akim@epita.fr>

	* data/bison.c++: Adjust to the M4 back end.
	More is certainly needed.

2002-02-05  Akim Demaille  <akim@epita.fr>

	Give a try to M4 as a back end.

	* lib/readpipe.c: New, from wdiff.
	* src/Makefile.am (DEFS): Define PKGDATADIR, not BISON_SIMPLE and
	BISON_HAIRY.
	* src/system.h (BISON_HAIRY, BISON_SIMPLE): Remove the DOS and VMS
	specific values.  Now it is m4 that performs the lookup.
	* src/parse-skel.y: Remove.
	* src/muscle_tab.c, src/muscle_tab.h (muscles_m4_output): New.
	* src/output.c (actions_output, guards_output)
	(token_definitions_output): No longer keeps track of the output
	line number, hence remove the second argument.
	(guards_output): Check against the guard member of a rule, not the
	action member.
	Adjust callers.
	(output_skeleton): Don't look for the skeleton location, let m4 do
	that.
	Create `/tmp/muscles.m4'.  This is temporary, a proper temporary
	file will be used.
	Invoke `m4' on m4sugar.m4, muscles.m4, and the skeleton.
	(prepare): Given that for the time being changesyntax is not
	usable in M4, rename the muscles using `-' to `_'.
	Define `defines_flag', `output_parser_name' and `output_header_name'.
	* src/output.h (actions_output, guards_output)
	(token_definitions_output): Adjust prototypes.
	* src/scan-skel.l: Instead of scanning the skeletons, it now
	processes the output of m4: `__oline__' and `#output'.
	* data/bison.simple: Adjust to be used by M4(sugar).
	* tests/Makefile.am: Use check_SCRIPTS to make sure `bison' is up
	to date.
	* tests/bison.in: Use the secrete envvar `BISON_PKGDATADIR'
	instead of the dead `BISON_SIMPLE' and `BISON_HAIRY'.
	* data/m4sugar/m4sugar.m4, data/m4sugar/version.m4: New,
	shamelessly stolen from CVS Autoconf.

2002-02-05  Akim Demaille  <akim@epita.fr>

	* lib/hash.c, lib/hash.h: Replace with Fileutils 4.1's version.
	* configure.in: Check for the declarations of free and malloc.
	* src/muscle_tab.c: Adjust.

2002-02-05  Akim Demaille  <akim@epita.fr>

	* src/muscle_tab.c (muscle_init): Don't default to NULL muscle
	which have no values.

2002-02-05  Akim Demaille  <akim@epita.fr>

	* src/bison.simple, src/bison.hairy, src/bison.c++: Move to...
	* data/: here.

2002-01-29  Paul Eggert  <eggert@twinsun.com>

	* src/bison.simple (YYSIZE_T): Do not define merely because
	YYSTACK_USE_ALLOCA is nonzero or alloca or _ALLOCA_H are defined.
	On some platforms, <alloca.h> does not declare YYSTD (size_t).

2002-01-27  Akim Demaille  <akim@epita.fr>

	Fix `%nonassoc and eof'.

	* src/state.c (errs_dup): Aaaah!  The failure was due to bytes
	which were not properly copied!  Replace
	memcpy (res->errs, src->errs, src->nerrs);
	with
	memcpy (res->errs, src->errs, src->nerrs * sizeof (src->errs[0]));
	!!!
	* tests/regression.at (%nonassoc and eof): Adjust to newest
	Autotest: `.' is not in the PATH.

2002-01-27  Akim Demaille  <akim@epita.fr>

	* tests/sets.at (AT_EXTRACT_SETS): New.
	(Nullable): Use it.
	(Firsts): New.

2002-01-26  Akim Demaille  <akim@epita.fr>

	* tests/actions.at, tests/calc.at, tests/headers.at,
	* tests/torture.at: Adjust to the newest Autotest which no longer
	forces `.' in the PATH.

2002-01-25  Akim Demaille  <akim@epita.fr>

	* tests/regression.at (%nonassoc and eof): New.
	Suggested by Robert Anisko.

2002-01-24  Akim Demaille  <akim@epita.fr>

	Bison dumps core when trying to complain about broken input files.
	Reported by Cris van Pelt.

	* src/lex.c (parse_percent_token): Be sure to set token_buffer.
	* tests/regression.at (Invalid input: 1, Invalid input: 2): Merge
	into...
	(Invalid inputs): Strengthen: exercise parse_percent_token.

2002-01-24  Robert Anisko  <robert.anisko@epita.fr>

	* src/Makefile.am: Add bison.c++.
	* src/bison.c++: New skeleton.

2002-01-21  Paolo Bonzini <bonzini@gnu.org>

	* po/it.po: New.

2002-01-21  Kees Zeelenberg  <kzlg@users.sourceforge.net>

	* src/files.c (skeleton_find) [MSDOS]: Fix cp definition.

2002-01-20  Marc Autret  <marc@gnu.org>

	* src/files.c (compute_output_file_names): Fix

2002-01-20  Marc Autret  <marc@gnu.org>

	* tests/output.at: New test.
	* src/files.c (compute_base_names): Don't map extensions when
	the YACC flag is set, use defaults.
	Reported by Evgeny Stambulchik.

2002-01-20  Marc Autret  <marc@gnu.org>

	* src/system.h: Need to	define __attribute__ away for non-GCC
	compilers as well (i.e.	the vendor C compiler).
	Suggested by Albert Chin-A-Young.

2002-01-11  Tim Van Holder  <tim.van.holder@pandora.be>

	* lib/hash.h, lib/hash.c: Renamed __P to PARAMS and used the
	canonical definition.
	* src/system.h: Use the canonical definition for PARAMS (avoids
	a conflict with the macro from lib/hash.h).

2002-01-11  Akim Demaille  <akim@epita.fr>

	* configure.in: Use AC_FUNC_STRNLEN.
	Fixes the failures observed on AIX 4.3 by H.Merijn Brand.

2002-01-09  Akim Demaille  <akim@epita.fr>

	* src/files.c, src/files.h (output_infix): New.
	(tab_extension): Remove.
	(compute_base_names): Compute the former, drop the latter.
	* src/output.c (prepare): Insert the muscles `output-infix', and
	`output-suffix'.
	* src/parse-skel.y (string, string.1): New.
	(section.header): Use it.
	(section.yacc): Remove.
	(prefix): Remove too.
	* src/scan-skel.l: Adjust.
	* src/bison.simple, src/bison.hairy: Adjust.

2002-01-09  Akim Demaille  <akim@epita.fr>

	* configure.in (WERROR_CFLAGS): Compute it.
	* src/Makefile.am (CFLAGS): Pass it.
	* tests/atlocal.in (CFLAGS): Idem.
	* src/files.c: Fix a few warnings.
	(get_extension_index): Remove, unused.

2002-01-08  Akim Demaille  <akim@epita.fr>

	* src/getargs.c (AS_FILE_NAME): New.
	(getargs): Use it to convert DOSish file names.
	* src/files.c (base_name): Rename as full_base_name to avoid
	clashes with `base_name ()'.
	(filename_split): New.
	(compute_base_names): N-th rewrite, using filename_split.

2002-01-08  Akim Demaille  <akim@epita.fr>

	* lib/basename.c, lib/dirname.h, lib/dirname.c, lib/memrchr.c:
	New, stolen from the Fileutils 4.1.
	* lib/Makefile.am (libbison_a_SOURCES): Adjust.
	* configure.in: Check for the presence of memrchr, and of its
	prototype.

2002-01-07  Tim Van Holder  <tim.van.holder@pandora.be>

	* lib/hash.h (__P): Added definition for this macro.
	* src/Makefile.am: Add parse-skel.c and scan-skel.c to
	BUILT_SOURCES, to ensure they are generated first.
	* src/parse-skel.y: Use YYERROR_VERBOSE instead of
	%error-verbose to allow bootstrapping with bison 1.30x.

2002-01-06  Akim Demaille  <akim@epita.fr>

	* src/reader.c (parse_braces): Don't fetch the next char, the
	convention is to fetch on entry.
	* tests/torture.at (GNU Cim Grammar): Reintroduce their weird
	'switch' without a following semicolon.
	* tests/regression.at (braces parsing): New.

2002-01-06  Akim Demaille  <akim@epita.fr>

	Bison is dead wrong in its RR conflict reports.

	* tests/torture.at (GNU Cim Grammar): New.
	* src/conflicts.c (count_rr_conflicts): Fix.

2002-01-06  Akim Demaille  <akim@epita.fr>

	Creating package.m4 from configure.ac causes too many problems.

	* tests/Makefile.am (package.m4): Create it by hand,
	AC_CONFIG_TESTDIR no longer does in the most recent CVS Autoconf.

2002-01-06  Akim Demaille  <akim@epita.fr>

	* src/Makefile.am (bison_SOURCES): Add parse-skel.h and
	skeleton.h.

2002-01-04  Paul Eggert  <eggert@twinsun.com>

	* doc/bison.texinfo (Debugging):
	Remove YYSTDERR; it's no longer defined or used.
	Also, s/cstdio.h/cstdio/.

2002-01-03  Akim Demaille  <akim@epita.fr>

	* tests/bison.in, tests/atlocal.in: Adjust to CVS Autoconf.

2002-01-03  Akim Demaille  <akim@epita.fr>

	* src/parse-skel.y (process_skeleton): Don't bind the parser's
	tracing code to --trace, wait for a better --trace option, with
	args.

2002-01-03  Akim Demaille  <akim@epita.fr>

	* src/bison.simple (YYSTDERR): Remove, replace `stderr'.
	The ISO C++ standard is extremely clear about it: stderr is
	considered a macro, not a regular symbol (see table 94 `Header
	<cstdio> synopsis', [lib.c.files] 27.8.2 C Library files).
	Therefore std:: does not apply to it.  It still does with fprintf.
	Also, s/cstdio.h/cstdio/.

2002-01-03  Akim Demaille  <akim@epita.fr>

	* lib/quotearg.c: Use `#include "..."' instead of `#include <...>'
	for non system headers.

2002-01-02  Akim Demaille  <akim@epita.fr>

	Equip the skeleton chain with location tracking, runtime trace,
	pure parser and scanner.

	* src/parse-skel.y: Request a pure parser, locations, and prefix
	renaming.
	(%union): Having several members with the same type does not help
	type mismatches, simplify.
	(YYPRINT, yyprint): New.
	(yyerror): ``Rename'' (there is a #define yyerror skel_error) as...
	(skel_error): this.
	Handle locations.
	* src/scan-skel.l: Adjust to these changes.
	* src/skeleton.h (LOCATION_RESET, LOCATION_LINES, LOCATION_STEP)
	(LOCATION_PRINT, skel_control_t): New.

2001-12-30  Akim Demaille  <akim@epita.fr>

	* src/parse-skel.y: Get rid of the shift/reduce conflict:
	replace `gb' with BLANKS.
	* src/scan-skel.l: Adjust.

2001-12-30  Akim Demaille  <akim@epita.fr>

	* src/system.h: We don't need nor want bcopy.
	Throw away MS-DOS crap: we don't need getpid.
	* configure.in: We don't need strndup.  It was even causing
	problems: because Flex includes the headers *before* us,
	_GNU_SOURCE is not defined by config.h, and therefore strndup was
	not visible.
	* lib/xstrndup.c: New.
	* src/scan-skel.l: Use it.
	Be sure to initialize yylval.muscle member when scanning a MUSCLE.
	* src/parse-skel.y: Use %directives instead of #defines.

2001-12-30  Akim Demaille  <akim@epita.fr>

	* src/skeleton.h: New.
	* src/output.c (output_parser, output_master_parser): Remove, dead
	code.
	* src/output.h (get_lines_number, actions_output, guards_output)
	(token_definitions_output): Prototype them.
	* src/parse-skel.y: Add the license notice.
	Include output.h and skeleton.h.
	(process_skeleton): Returns void, and takes a single parameter.
	* src/scan-skel.l: Add the license notice.
	Include skeleton.h.
	Don't use %option yylineno: it seems that then Flex imagines
	REJECT has been used, and therefore it won't reallocate its
	buffers (which makes no other sense to me than a bug).  It results
	in warnings for `unused: yy_flex_realloc'.

2001-12-30  Robert Anisko  <robert.anisko@epita.fr>

	* src/muscle_tab.h (MUSCLE_INSERT_INT, MUSCLE_INSERT_STRING)
	(MUSCLE_INSERT_PREFIX): ...to there.
	* src/output.c (MUSCLE_INSERT_INT, MUSCLE_INSERT_STRING)
	(MUSCLE_INSERT_PREFIX): Move from here...

	* src/bison.hairy: Add a section directive.  Put braces around muscle
	names.  This parser skeleton is still broken, but Bison should not
	choke on a bad muscle 'syntax'.
	* src/bison.simple: Add a section directive.  Put braces around muscle
	names.

	* src/files.h (strsuffix, stringappend): Add declarations.
	(tab_extension): Add declaration.
	(short_base_name): Add declaration.

	* src/files.c (strsuffix, stringappend): No longer static.  These
	functions are used in the skeleton parser.
	(tab_extension): New.
	(compute_base_names): Use the computations done in this function
	to guess if the generated parsers should have '.tab' in their
	names.
	(short_base_name): No longer static.

	* src/output.c (output_skeleton): New.
	(output): Disable call to output_master_parser, and give a try to
	a new skeleton handling system.
	(guards_output, actions_output): No longer static.
	(token_definitions_output, get_lines_number): No longer static.

	* configure.in: Use AM_PROG_LEX and AC_PROG_YACC.

	* src/Makefile.am (bison_SOURCES): Add scan-skel.l and
	parse-skel.y.

	* src/parse-skel.y: New file.
	* src/scan-skel.l: New file.

2001-12-29  Akim Demaille  <akim@epita.fr>

	%name-prefix is broken.

	* src/files.c (spec_name_prefix): Initialize to NULL, not to "yy".
	Adjust all dependencies.
	* tests/headers.at (export YYLTYPE): Strengthen this test: use
	%name-prefix.

	Renaming yylval but not yylloc is not consistent.  Now we do.

	* src/bison.simple: Prefix yylloc if used.
	* doc/bison.texinfo (Decl Summary): Document that.

2001-12-29  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo: Promote `%long-directive' over
	`%long_directive'.
	Remove all references to fixed-output-files, yacc is enough.

2001-12-29  Akim Demaille  <akim@epita.fr>

	* src/bison.simple: Define YYDEBUG and YYERROR_VERBOSE *after* the
	user prologue.  These are defaults.
	* tests/actions.at (Mid-rule actions): Make sure the user can
	define YYDEBUG and YYERROR_VERBOSE.

2001-12-29  Akim Demaille  <akim@epita.fr>

	* src/output.c (header_output): Don't forget to export YYLTYPE and
	yylloc.
	* tests/headers.at (export YYLTYPE): New, make sure it does.
	* tests/regression.at (%union and --defines, Invalid CPP headers):
	Move to...
	* tests/headers.at: here.

2001-12-29  Akim Demaille  <akim@epita.fr>

	* src/gram.h (rule_s): Member `assoc' is of type `associativity'.

2001-12-29  Akim Demaille  <akim@epita.fr>

	* tests/actions.at (Mid-rule actions): Output on a single line
	instead of several.

2001-12-29  Akim Demaille  <akim@epita.fr>

	* doc/bison.texinfo: Formatting changes.

2001-12-29  Akim Demaille  <akim@epita.fr>

	Don't store the token defs in a muscle, just be ready to output it
	on command.  Now possible via `symbols'.  Fixes a memory leak.

	* src/output.c (token_definitions_output): New.
	(output_parser, header_output): Use it.
	* src/reader.c (symbols_save): Remove.

2001-12-29  Akim Demaille  <akim@epita.fr>

	* src/bison.simple: Do not provide a default for YYSTYPE and
	YYLTYPE before the user's prologue.  Otherwise it's hardly... a
	default.

2001-12-29  Akim Demaille  <akim@epita.fr>

	Mid-rule actions are simply... ignored!

	* src/reader.c (readgram): Be sure to attach mid-rule actions to
	the empty-rule associated to the dummy symbol, not to the host
	rule.
	* tests/actions.at (Mid-rule actions): New.

2001-12-29  Akim Demaille  <akim@epita.fr>

	Memory leak.

	* src/reader.c (reader): Free grammar.

2001-12-29  Akim Demaille  <akim@epita.fr>

	Memory leak.

	* src/LR0.c (new_itemsets): Don't allocate `shift_symbol' here,
	since it allocates it for each state, although only one is needed.
	(allocate_storage): Do it here.

2001-12-29  Akim Demaille  <akim@epita.fr>

	* src/options.h, src/options.c (create_long_option_table): Rename
	as...
	(long_option_table_new): this, with a clearer prototype.
	(percent_table): Remove, unused,
	* src/getargs.c (getargs): Adjust.

2001-12-29  Akim Demaille  <akim@epita.fr>

	* src/LR0.c, src/conflicts.c, src/lalr.c, src/lalr.h, src/output.c
	* src/print.c, src/print_graph.c, src/state.h: Rename state_table
	as states.

2001-12-29  Akim Demaille  <akim@epita.fr>

	* src/lalr.c (build_relations): Rename `states' as `states1'.
	Sorry, I don't understand exactly what it is, no better name...

2001-12-29  Akim Demaille  <akim@epita.fr>

	* src/closure.c, src/conflicts.c, src/derives.c, src/gram.c
	* src/gram.h, src/lalr.c, src/nullable.c, src/output.c, src/print.c
	* src/print_graph.c, src/reader.c, src/reduce.c: Rename rule_table
	as rules.

2001-12-29  Akim Demaille  <akim@epita.fr>

	* src/gram.c (rprec, rprecsym, rassoc): Remove, unused since long
	ago.

2001-12-29  Akim Demaille  <akim@epita.fr>

	* src/reader.c, src/reader.h (user_toknums): Remove.
	Adjust all users to use symbols[i]->user_token_number.

2001-12-29  Akim Demaille  <akim@epita.fr>

	* src/gram.c, src/gram.h (sprec, sassoc): Remove.
	Adjust all users to use symbols[i]->prec or ->assoc.

2001-12-29  Akim Demaille  <akim@epita.fr>

	* src/reader.c, src/reader.h (tags): Remove.
	Adjust all users to use symbols[i]->tag.

2001-12-29  Akim Demaille  <akim@epita.fr>

	* src/gram.h, src/gram.c (symbols): New, similar to state_table
	and rule_table.
	* src/reader.c (packsymbols): Fill this table.
	Drop sprec.
	* src/conflicts.c (resolve_sr_conflict): Adjust.
	* src/reduce.c (reduce_grammar): Adjust: just sort symbols, a
	single table.
	Use symbols[i]->tag instead of tags[i].

2001-12-29  Akim Demaille  <akim@epita.fr>

	* tests/calc.at (_AT_DATA_CALC_Y): Also use %union.
	In addition, put a comment in there, to replace...
	* tests/regression.at (%union and C comments): Remove.

2001-12-29  Akim Demaille  <akim@epita.fr>

	* tests/regression.at (Web2c Actions): Blindly move the actual
	output as expected output.  The contents *seem* right to me, but I
	can't pretend reading perfectly parser tables...  Nonetheless, all
	the other tests pass correctly, the table look OK, even though the
	presence of `$axiom' is to be noted: AFAICS it is useless (but
	harmless).

2001-12-29  Akim Demaille  <akim@epita.fr>

	* src/reader.c (readgram): Don't add the rule 0 if there were no
	rules read.  In other words, add it _after_ having performed
	grammar sanity checks.
	Fixes the `tests/regression.at (Invalid input: 1)' Failure.

2001-12-29  Akim Demaille  <akim@epita.fr>

	* tests/regression.at (Web2c Report): Catch up: the rule 0 is now
	visible, and some states have now a different number.

2001-12-29  Akim Demaille  <akim@epita.fr>

	* src/reader.c (readgram): Bind the initial rule's lineno to that
	of the first rule.
	* tests/regression.at (Rule Line Numbers, Unresolved SR Conflicts):
	(Solved SR Conflicts): Adjust rule 0's line number.

2001-12-29  Akim Demaille  <akim@epita.fr>

	Fix the `GAWK Grammar' failure.

	* src/LR0.c (final_state): Initialize to -1 so that we do compute
	the reductions of the first state which was mistakenly confused
	with the final state because precisely final_state was initialized
	to 0.
	* tests/sets.at (Nullable): Adjust: state 0 does have lookaheads,
	now noticed by Bison.
	* tests/regression.at (Rule Line Numbers): Adjust: state 0 does
	have a reduction on $default.

2001-12-29  Akim Demaille  <akim@epita.fr>

	* src/gram.c (ritem_print): Be sure to subtract 1 when displaying
	rule line numbers.
	* src/closure.c (print_closure): Likewise.
	* src/derives.c (print_derives): Likewise.
	* tests/sets.at (Nullable): Adjust: the rule numbers are correct
	now.

2001-12-29  Akim Demaille  <akim@epita.fr>

	* src/lalr.c (lookaheads_print): New.
	(lalr): Call it when --trace-flag.
	* tests/sets.at (Nullable): Adjust: when tracing, the lookaheads
	are dumped.

2001-12-29  Akim Demaille  <akim@epita.fr>

	* src/derives.c (print_derives): Be sure to use `>= 0', not `> 0',
	when walking through ritem, even via rule->rhs.
	* src/reduce.c (dump_grammar, useful_production, reduce_output)
	(useful_production, useless_nonterminals): Likewise.
	(reduce_grammar_tables): Likewise, plus update nritems.
	* src/nullable.c (set_nullable): Likewise.
	* src/lalr.c (build_relations): Likewise.
	* tests/sets.at (Nullable): Adjust.
	Fortunately, now, the $axiom is no longer nullable.

2001-12-29  Akim Demaille  <akim@epita.fr>

	* src/LR0.c (generate_states): Use nritems, not nitems, nor using
	the 0-sentinel.
	* src/gram.c (ritem_longest_rhs): Likewise.
	* src/reduce.c (nonterminals_reduce): Likewise.
	* src/print_graph.c (print_graph): Likewise.
	* src/output.c (output_rule_data): Likewise.
	* src/nullable.c (set_nullable):  Likewise.

2001-12-29  Akim Demaille  <akim@epita.fr>

	* src/output.c: Comment changes.

2001-12-27  Paul Eggert  <eggert@twinsun.com>

	* src/bison.simple (YYSTACK_ALLOC, YYSIZE_T): Remove special
	cases for non-GNU systems like AIX, HP-UX, SGI, Sun, and
	Sparc, as they were causing more porting problems than the
	(minor) performance improvement was worth.

	Also, catch up with 1.31's YYSTD.

2001-12-27  Akim Demaille  <akim@epita.fr>

	* src/output.c (output_gram): Rely on nritems, not the
	0-sentinel.  See below.
	Use -1 as separator, not 0.
	* src/bison.simple (yyparse): Subtract 1 to the rule numbers.
	Rely on -1 as separator in yyrhs, instead of 0.
	* tests/calc.at (AT_CHECK_CALC): Now, the parsers no longer issue
	twice `Now at end of input', therefore there are two lines less to
	expect.

2001-12-27  Akim Demaille  <akim@epita.fr>

	* tests/regression.at (Unresolved SR Conflicts):
	(Solved SR Conflicts, Rule Line Numbers): Adjust to the changes
	below.

2001-12-27  Akim Demaille  <akim@epita.fr>

	* src/LR0.c (new_state): Recognize the final state by the fact it
	is reached by eoftoken.
	(insert_start_shifting_state, insert_eof_shifting_state)
	(insert_accepting_state, augment_automaton): Remove, since now
	these states are automatically computed from the initial state.
	(generate_states): Adjust.
	* src/print.c: When reporting a rule number to the user, substract
	1, so that the axiom rule is rule 0, and the first user rule is 1.
	* src/reduce.c: Likewise.
	* src/print_graph.c (print_core): For the time being, just as for
	the report, depend upon --trace-flags to dump the full set of
	items.
	* src/reader.c (readgram): Once the grammar read, insert the rule
	0: `$axiom: START-SYMBOL $'.
	* tests/set.at: Adjust: rule 0 is now displayed, and since the
	number of the states has changed (the final state is no longer
	necessarily the last), catch up.

2001-12-27  Akim Demaille  <akim@epita.fr>

	Try to make the use of the eoftoken valid.  Given that its value
	is 0 which was also used as a sentinel in ritem, (i) make sure >= 0
	is used instead of > 0 where appropriate, (ii), depend upon nritems
	instead of the 0-sentinel.

	* src/gram.h, src/gram.c (nritems): New.
	Expected to be duplication of nitems, but for the time being...
	* src/reader.c (packgram): Assert nritems and nitems are equal.
	* src/LR0.c (allocate_itemsets, new_itemsets): Adjust.
	* src/closure.c (print_closure, print_fderives): Likewise.
	* src/gram.c (ritem_print): Likewise.
	* src/print.c (print_core, print_grammar): Likewise.
	* src/print_graph.c: Likewise.

2001-12-27  Akim Demaille  <akim@epita.fr>

	* src/main.c (main): If there are complains after grammar
	reductions, then output the report anyway if requested, then die.
	* src/symtab.c (bucket_new): Initialize `value' to -1, not 0.
	* src/reader.c (eoftoken): New.
	(parse_token_decl): If the token being defined has value `0', it
	is the eoftoken.
	(packsymbols): No longer hack `tags' to insert `$' by hand.
	Be sure to preserve the value of the eoftoken.
	(reader): Make sure eoftoken is defined.
	Initialize nsyms to 0: now eoftoken is created just like the others.
	* src/print.c (print_grammar): Don't special case the eof token.
	* src/regression.at: Adjust: `$' has value 0, not -1, which was a
	lie anyway, albeit pleasant.
	* tests/calc.at: Exercise error messages with eoftoken.
	Change the grammar so that empty input is invalid.
	Adjust expectations.
	When yyungeting, be sure to use a valid yylloc: use last_yylloc.

2001-12-27  Akim Demaille  <akim@epita.fr>

	* configure.in: Check the protos of strchr ans strspn.
	Replace strchr if needed.
	* src/system.h: Provide the protos of strchr, strspn and memchr if
	missing.
	* lib/strchr.c: New.
	* src/reader.c (symbols_save): Use strchr.

2001-12-27  Akim Demaille  <akim@epita.fr>

	* src/print.c, src/print_graph.c (escape): New.
	Use it to quote the TAGS outputs.
	* src/print_graph.c (print_state): Now errors are in red, and
	reductions in green.
	Prefer high to wide: output the state number on a line of its own.

2001-12-27  Akim Demaille  <akim@epita.fr>

	* src/state.h, src/state.c (reductions_new): New.
	* src/LR0.c (set_state_table): Let all the states have a
	`reductions', even if reduced to 0.
	(save_reductions): Adjust.
	* src/lalr.c (initialize_LA, initialize_lookaheads): Adjust.
	* src/print.c (print_reductions, print_actions): Adjust.
	* src/output.c (action_row): Adjust.

2001-12-27  Akim Demaille  <akim@epita.fr>

	* src/state.h, src/state.c (errs_new, errs_dup): New.
	* src/LR0.c (set_state_table): Let all the states have an errs,
	even if reduced to 0.
	* src/print.c (print_errs, print_reductions): Adjust.
	* src/output.c (output_actions, action_row): Adjust.
	* src/conflicts.c (resolve_sr_conflict): Adjust.

2001-12-27  Akim Demaille  <akim@epita.fr>

	* src/lalr.c (set_goto_map, initialize_F): Use SHIFT_SYMBOL.

2001-12-27  Akim Demaille  <akim@epita.fr>

	* src/conflicts.c, src/conflicts.h (print_reductions): Move to...
	* src/print.c: here.
	(lookaheadset, shiftset): New, used as additional storage by
	print_reductions.
	(print_results): Adjust.
	(print_shifts, print_gotos, print_errs): New, extracted from...
	(print_actions): here.
	* src/print_graph.c (print_actions): Remove dead code.

2001-12-27  Akim Demaille  <akim@epita.fr>

	* src/reader.c (copy_dollar, copy_at): Better checking of `n' in
	`$n' and `@n'.

2001-12-27  Akim Demaille  <akim@epita.fr>

	* src/lalr.c (add_lookback_edge): Use state_t instead of ints.
	(build_relations): Adjust.

2001-12-27  Akim Demaille  <akim@epita.fr>

	* src/lalr.c (set_goto_map): Remove a wrong but benign loop
	duplication.

2001-12-27  Akim Demaille  <akim@epita.fr>

	* src/reader.c (packgram): Catch nitems overflows.

2001-12-27  Akim Demaille  <akim@epita.fr>

	* src/files.c, src/files.h (guard_obstack): Remove.
	* src/output.c (output): Adjust.
	* src/reader.c (parse_braces): New, factoring...
	(copy_action, copy_guard): these two which are renamed as...
	(parse_action, parse_guard): these.
	As a voluntary consequence, using braces around guards is now
	mandatory.

2001-12-27  Akim Demaille  <akim@epita.fr>

	* src/gram.h (rule_t): `guard' and `guard_line' are new members.
	* src/reader.c (symbol_list): `guard' and `guard_line' are new
	members.
	(symbol_list_new): Adjust.
	(copy_action): action_line is the first line, not the last.
	(copy_guard): Just as for actions, store the `action' only, not
	the switch/case/break flesh.
	Don't parse the user action that might follow the guard, let...
	(readgram): do it, i.e., now, there can be an action after a
	guard.
	In other words the guard is just explicitly optional.
	(packgram): Adjust.
	* src/output.c (guards_output): New.
	(output_parser): Call it when needed.
	(output): Also free the guard and attrs obstacks.
	* src/files.c, src/files.h (obstack_save): Remove.
	(output_files): Remove.
	As a result, if one needs the former `.act' file, using an
	appropriate skeleton which requires actions and guards is now
	required.
	* src/main.c (main): Adjust.
	* tests/semantic.at: New.
	* tests/regression.at: Use `input.y' as input file name.
	Avoid 8+3 problems by requiring input.c when the test needs the
	parser.

2001-12-27  Akim Demaille  <akim@epita.fr>

	* src/reader.c (symbol_list_new): Be sure to initialize all the
	fields.

2001-12-27  Akim Demaille  <akim@epita.fr>

	All the hacks using a final pseudo state are now useless.

	* src/LR0.c (set_state_table): state_table holds exactly nstates.
	* src/lalr.c (nLA): New.
	(initialize_LA, compute_lookaheads, initialize_lookaheads): Use it
	instead of lookaheadsp from the pseudo state (nstate + 1).

2001-12-27  Akim Demaille  <akim@epita.fr>

	* src/output.c (action_row, token_actions): Use a state_t instead
	of a integer, and nlookaheads instead of the following state's
	lookaheadsp.

2001-12-27  Akim Demaille  <akim@epita.fr>

	* src/conflicts.c (log_resolution, flush_shift)
	(resolve_sr_conflict, set_conflicts, solve_conflicts)
	(count_sr_conflicts, count_rr_conflicts, conflicts_output)
	(conflicts_print, print_reductions): Use a state_t instead of an
	integer when referring to a state.
	As much as possible, depend upon nlookaheads, instead of the
	`lookaheadsp' member of the following state (since lookaheads of
	successive states are successive, the difference between state n + 1
	and n served as the number of lookaheads for state n).
	* src/lalr.c (add_lookback_edge): Likewise.
	* src/print.c (print_core, print_actions, print_state)
	(print_results): Likewise.
	* src/print_graph.c (print_core, print_actions, print_state)
	(print_graph): Likewise.
	* src/conflicts.h: Adjust.

2001-12-27  Akim Demaille  <akim@epita.fr>

	* src/bison.hairy: Formatting/comment changes.
	ANSIfy.
	Remove `register' indications.
	Add plenty of `static'.

2001-12-27  Akim Demaille  <akim@epita.fr>

	* src/output.c (prepare): Drop the muscle `ntbase' which
	duplicates ntokens.
	* src/bison.simple: Formatting/comment changes.
	Use YYNTOKENS only, which is documented, but not YYNTBASE, which
	is an undocumented synonym.

2001-12-22  Akim Demaille  <akim@epita.fr>

	* src/output.c (output_table_data): Change the prototype to use
	`int' for array ranges: some invocations do pass an int, not a
	short.
	Reported by Wayne Green.

2001-12-22  Akim Demaille  <akim@epita.fr>

	Some actions of web2c.y are improperly triggered.
	Reported by Mike Castle.

	* src/lalr.c (traverse): s/F (i)[k] = F (j)[k]/F (j)[k] = F (i)[k]/.
	* tests/regression.at (Web2c): Rename as...
	(Web2c Report): this.
	(Web2c Actions): New.

2001-12-22  Akim Demaille  <akim@epita.fr>

	Reductions in web2c.y are improperly reported.
	Reported by Mike Castle.

	* src/conflicts.c (print_reductions): Fix.
	* tests/regression.at (Web2c): New.

2001-12-18  Akim Demaille  <akim@epita.fr>

	Some host fail on `assert (!"foo")', which expands to
	((!"foo") ? (void)0 : __assert("!"foo."", __FILE__, __LINE__))
	Reported by Nelson Beebee.

	* src/output.c, src/vcg.c: Replace `assert (!"it succeeded")' with
	`#define it_succeeded 0' and `assert (it_succeeded)'.

2001-12-17  Marc Autret  <autret_m@epita.fr>

	* src/bison.simple: Don't hard code the skeleton line and filename.
	* src/output.c (output_parser): Rename 'line' as 'output_line'.
	New line counter 'skeleton_line' (skeleton-line muscle).

2001-12-17  Paul Eggert  <eggert@twinsun.com>

	* NEWS, doc/bison.texinfo, doc/bison.1, doc/bison.rnh: Document that
	YYDEBUG must be defined to a nonzero value.

	* src/bison.simple (yytname): Do not assume that the user defines
	YYDEBUG to a properly parenthesized expression.

2001-12-17  Akim Demaille  <akim@epita.fr>

	* src/state.h (state_t): Rename lookaheads as lookaheadsp.
	nlookaheads is a new member.
	Adjust all users.
	* src/lalr.h (nlookaheads): Remove this orphan declaration.
	* src/lalr.c (initialize_lookaheads): Set nlookaheads for each
	state.

2001-12-17  Akim Demaille  <akim@epita.fr>

	* src/files.h, src/files.c (open_files, close_files): Remove.
	* src/main.c (main): Don't open/close files, nor invoke lex_free,
	let...
	* src/reader.c (reader): Do it.

2001-12-17  Akim Demaille  <akim@epita.fr>

	* src/conflicts.c (print_reductions): Formatting changes.

2001-12-17  Akim Demaille  <akim@epita.fr>

	* src/conflicts.c (flush_shift): Also adjust lookaheadset.
	(flush_reduce): New.
	(resolve_sr_conflict): Adjust.

2001-12-17  Akim Demaille  <akim@epita.fr>

	* src/output.c (output_obstack): Be static and rename as...
	(format_obstack): this, to avoid any confusion with files.c's
	output_obstack.
	* src/reader.h (muscle_obstack): Move to...
	* src/output.h: here, since it's defined in output.c.

2001-12-17  Akim Demaille  <akim@epita.fr>

	* src/output.c (action_row, save_column, default_goto)
	(sort_actions, matching_state, pack_vector): Better variable
	locality.

2001-12-17  Akim Demaille  <akim@epita.fr>

	* src/output.c: Various formatting changes.

2001-12-17  Akim Demaille  <akim@epita.fr>

	* src/files.c (output_files): Free the output_obstack.
	* src/main.c (main): Call print and print_graph conditionally.
	* src/print.c (print): Work unconditionally.
	* src/print_graph.c (print_graph): Work unconditionally.
	* src/conflicts.c (log_resolution): Output only if verbose_flag.

2001-12-16  Marc Autret  <autret_m@epita.fr>

	* src/output.c (actions_output): Fix. When we use %no-lines,
	there is one less line per action.

2001-12-16  Marc Autret  <autret_m@epita.fr>

	* src/bison.simple: Remove a useless #line directive.
	s/#line %%line %%skeleton/#line %%line "%%parser-file-name"/'.
	* src/output.c (get_lines_number): New.
	(output_parser): Adjust, now takes care about the lines of a
	output muscles.
	Fix line numbering.
	(actions_output): Computes the number of lines taken by actions.
	(output_master_parser): Insert new skeleton which is the name of
	the output parser file name.

2001-12-15  Marc Autret  <autret_m@epita.fr>

	* src/bison.simple [YYERROR_VERBOSE]: Restore backward compatibility.

2001-12-15  Marc Autret  <autret_m@epita.fr>

	* src/output.c (output_gram): Keep track of the hairy one.

2001-12-15  Akim Demaille  <akim@epita.fr>

	Make `make distcheck' work.

	* lib/Makefile.am (INCLUDES): Add top_srcdir/intl, since hash uses
	system.h which uses libgettext.h.

2001-12-15  Akim Demaille  <akim@epita.fr>

	* src/nullable.c (set_nullable): Useless rules must be skipped,
	otherwise, since we range over their symbols, we might look at a
	nonterminal which no longer ``exists'', i.e., it is not counted in
	`nvars', hence we overflow our arrays.

2001-12-15  Akim Demaille  <akim@epita.fr>

	The header can also be produced directly, without any obstack!
	Yahoo!

	* src/files.c, src/files.h (defines_obstack): Remove.
	(compute_header_macro): Global.
	(defines_obstack_save): Remove.
	* src/reader.c (parse_union_decl): No longer output to
	defines_obstack: its content can be found in the `stype' muscle
	anyway.
	(output_token_translations): Merge into...
	(symbols_output): this.
	Rename as...
	(symbols_save): this.
	(reader): Adjust.
	* src/output.c (header_output): New.
	(output): Call it.

2001-12-15  Akim Demaille  <akim@epita.fr>

	* src/reader.c (parse_union_decl): Instead of handling two obstack
	simultaneously, use one to define the `stype' muscle, and use the
	value of the latter to fill defines_obstack.
	(copy_comment): Remove.
	(copy_comment2): Work for a single obstack.
	Rename as...
	(copy_comment): this.

2001-12-15  Akim Demaille  <akim@epita.fr>

	* src/lex.c, src/lex.h (xgetc): No longer static.
	* src/reader.c (parse_union_decl): Revamp.

2001-12-15  Akim Demaille  <akim@epita.fr>

	Still making progress in separating Bison into (i) input, (ii)
	process, (iii) output: now we can directly output the parser file
	without using table_obstack at all.

	* src/files.c, src/files.h (table_obstack): Bye bye.
	(parser_file_name): New.
	* src/files.c (compute_output_file_names): Compute it.
	* src/output.c (actions_output, output_parser)
	(output_master_parser): To a file instead of an obstack.

2001-12-15  Akim Demaille  <akim@epita.fr>

	Attach actions to rules, instead of pre-outputting them to
	actions_obstack.

	* src/gram.h (rule_t): action and action_line are new members.
	* src/reader.c (symbol_list): Likewise.
	(copy_action): Save the actions within the rule.
	(packgram): Save them in rule_table.
	* src/output.c (actions_output): New.
	(output_parser): Use it on `%%actions'.
	(output_rule_data): Don't free rule_table.
	(output): Do it.
	(prepare): Don't save the `action' muscle.
	* src/bison.simple: s/%%action/%%actions/.

2001-12-15  Akim Demaille  <akim@epita.fr>

	* src/reader.c (copy_action): When --yacc, don't append a `;'
	to the user action: let it fail if lacking.
	Suggested by Arnold Robbins and Tom Tromey.

2001-12-14  Akim Demaille  <akim@epita.fr>

	* src/lex.c (literalchar): Simply return the char you decoded, non
	longer mess around with obstacks and int pointers.
	Adjust all callers.

2001-12-14  Akim Demaille  <akim@epita.fr>

	* src/lex.c (literalchar): Don't escape the special characters,
	just decode them, and keep them as char (before, eol was output as
	the 2 char string `\n' etc.).
	* src/output.c (output_rule_data): Use quotearg to output the
	token strings.

2001-12-13  Paul Eggert  <eggert@twinsun.com>

	* src/bison.simple (YYSIZE_T, YYSTACK_ALLOC, YYSTACK_FREE):
	Do not infringe on the global user namespace when using C++.
	(YYFPRINTF, YYSTDERR): New macros, needed for the above.
	All uses of `fprintf' and `stderr' changed.

	* doc/bison.texinfo: Document YYFPRINTF, YYSTDERR.

2001-12-13  Akim Demaille  <akim@epita.fr>

	The computation of nullable is broken: it doesn't handle empty
	RHS's properly.

	* tests/torture.at (GNU AWK Grammar): New.
	* tests/sets.at (Nullable): New.
	* src/nullable.c (set_nullable): Instead of blindly looping over
	`ritems', loop over the rules, and then over their rhs's.

	Work around Autotest bugs.

	* src/warshall.c (bitmatrix_print): Don't use `+--+' as table
	frame, because Autotest understand lines starting with a `+' as
	traces from the shell.  Then, they are not processed properly.
	Admittedly an Autotest bug, but we don't have time to wait for
	Autotest to catch up.
	* tests/regression.at (Broken Closure): Adjust to the new table
	frames.
	Move to...
	* tests/sets.at: here.

2001-12-13  Akim Demaille  <akim@epita.fr>

	* src/closure.c (closure): Use nrules instead of playing tricks
	with BITS_PER_WORD.

2001-12-13  Akim Demaille  <akim@epita.fr>

	* src/print.c (print_actions): Output the handling of `$' as the
	traces do: shifting the token EOF.  Before EOF was treated as a
	nonterminal.
	* tests/regression.at: Adjust some tests.
	* src/print_graph.c (print_core): Complete the set of items via
	closure.  The next-to-final and final states are still unsatisfying,
	but that's to be addressed elsewhere.
	No longer output the rule numbers, but do output the state number.
	A single loop for the shifts + gotos is enough, but picked a
	distinct color for each.
	(print_graph): Initialize and finalize closure.

2001-12-13  Akim Demaille  <akim@epita.fr>

	* src/reader.c (readgram): Remove dead code, an strip useless
	braces.
	(get_type): Remove, unused.

2001-12-12  Akim Demaille  <akim@epita.fr>

	* src/complain.h, src/complain.c: Remove error_one_per_line, rely
	on that of lib/error.c.

2001-12-12  Akim Demaille  <akim@epita.fr>

	Some hosts don't like `/' in includes.

	* src/system.h: Include libgettext.h without qualifying the path.
	* src/Makefile.am (INCLUDES): Add $(top_srcdir)/intl, remove
	$(top_srcdir).

2001-12-11  Marc Autret  <autret_m@epita.fr>

	* src/output.c (output_parser): Remove useless muscle.

2001-12-11  Marc Autret  <autret_m@epita.fr>

	* src/bison.simple: Remove #line just before %%epilogue. It
	is now handled in ...
	* src/reader.c (read_additionnal_code): Add the output of a
	#line for the epilogue.

2001-12-10  Marc Autret  <autret_m@epita.fr>

	* src/reader.c (copy_definition): Re-use CPP-outed code which
	replace precedent remove.
	* src/bison.simple: Remove #line before %%prologue because
	%%input-line is wrong at this time.

2001-12-10  Marc Autret  <autret_m@epita.fr>

	* src/reader.c (symbols_output): Clean up.
	* src/output.c (output_gram, output): Clean up.

2001-12-10  Akim Demaille  <akim@epita.fr>

	* src/lalr.c (initialize_lookaheads): New.  Extracted from...
	* src/LR0.c (set_state_table): here.
	* src/lalr.c (lalr): Call it.

2001-12-10  Akim Demaille  <akim@epita.fr>

	* src/state.h (shifts): Remove the `number' member: shifts are
	attached to state, hence no longer need to be labelled with a
	state number.

2001-12-10  Akim Demaille  <akim@epita.fr>

	Now that states have a complete set of members, the linked list of
	shifts is useless: just fill directly the state's shifts member.

	* src/state.h (shifts): Remove the `next' member.
	* src/LR0.c (first_state, last_state): Remove.
	Adjust the callers.
	(augment_automaton): Don't look for the shifts that must be added
	a shift on EOF: it is those of the state we looked for!  But now,
	since shifts are attached, it is no longer needed to looking
	merely by its id: its number.

2001-12-10  Akim Demaille  <akim@epita.fr>

	* src/LR0.c (augment_automaton): Better variable locality.
	Remove an impossible branch: if there is a state corresponding to
	the start symbol being shifted, then there is shift for the start
	symbol from the initial state.

2001-12-10  Akim Demaille  <akim@epita.fr>

	* src/LR0.c (augment_automaton): Call `insert_eof_shifting_state'
	only when appropriate: when insert_start_shifting_state' is not
	invoked.
	* tests/regression.at (Rule Line Numbers): Adjust.

2001-12-10  Akim Demaille  <akim@epita.fr>

	* src/LR0.c (augment_automaton): Now that all states have shifts,
	merge the two cases addition shifts to the initial state.

2001-12-10  Akim Demaille  <akim@epita.fr>

	* src/lalr.c (set_state_table): Move to...
	* src/LR0.c: here.
	* src/lalr.c (lalr): Don't call it...
	* src/LR0.c (generate_states): do it.
	* src/LR0.h (first_state): Remove, only the table is used.

2001-12-10  Akim Demaille  <akim@epita.fr>

	* src/LR0.h (first_shift, first_reduction): Remove.
	* src/lalr.c: Don't use first_shift: find shifts through the
	states.

2001-12-10  Akim Demaille  <akim@epita.fr>

	* src/LR0.c: Attach shifts to states as soon as they are
	computed.
	* src/lalr.c (set_state_table): Instead of assigning shifts to
	state, just assert that the mapping was properly done.

2001-12-10  Akim Demaille  <akim@epita.fr>

	* src/LR0.c (insert_start_shift): Rename as...
	(insert_start_shifting_state): this.
	(insert_eof_shifting_state, insert_accepting_state): New.
	(augment_automaton): Adjust.
	Better locality of the variables.
	When looking if the start_symbol is shifted from the initial
	state, using `while (... symbol != start_symbol ...)' sounds
	better than `while (... symbol < start_symbol ...)': If fail
	to see how the order between symbols could be relevant!

2001-12-10  Akim Demaille  <akim@epita.fr>

	* src/getargs.h: Don't declare `spec_name_prefix' and
	`spec_file_prefix', declared by src/files.h.
	* src/files.c, src/files.h: Default for spec_name_prefix is "yy".
	* src/muscle_tab.c (muscle_init): Default prefix to NULL.
	* src/output.c (prepare): Adjust.
	* src/reader.c (symbols_output): Likewise.
	* src/vmsgetargs.c: Vaguely adjust, but who cares?

2001-12-10  Akim Demaille  <akim@epita.fr>

	* src/muscle_tab.c (muscle_init): NULL is a better default than
	`"0"'.

2001-12-10  Akim Demaille  <akim@epita.fr>

	* src/reader.c (reader): Calling symbols_output once is enough.

2001-12-10  Akim Demaille  <akim@epita.fr>

	Now that states have a complete set of members, the linked list of
	reductions is useless: just fill directly the state's reductions
	member.

	* src/state.h (struct reductions): Remove member `number' and
	`next'.
	* src/LR0.c (first_reduction, last_reduction): Remove.
	(save_reductions): Don't link the new reductions, store them in
	this_state.
	* src/lalr.c (set_state_table): No need to attach reductions to
	states, it's already done.
	* src/output.c (output_actions): No longer free the shifts, then
	the reductions, then the states: free all the states and their
	members.

2001-12-10  Akim Demaille  <akim@epita.fr>

	* src/options.c (OPTN, DRTV, BOTH): New.
	(option_table): Use them.

	* src/muscle_tab.c: Don't include xalloc.h and string.h: that's
	the job of system.h.
	* src/options.c: Don't include stdio.h and xalloc.h for the same
	reasons.

2001-12-10  Akim Demaille  <akim@epita.fr>

	* src/output.c (output, prepare): Make sure the values of the
	muscles `action' and `prologue' are 0-terminated.

2001-12-10  Akim Demaille  <akim@epita.fr>

	Clean up GCC warnings.

	* src/reader.c (copy_action): `buf' is not used.
	(parse_skel_decl): Be static.
	* src/muscle_tab.c (mhash1, mhash2, muscle_insert): Preserve `const'.
	* src/options.h (create_long_option_table): Have a real prototype.
	* lib/hash.c, lib/hash.h (hash_insert, hash_insert_at, hash_delete)
	(hash_delete_at): Return const void *.
	Adjust casts to preserve the const.

2001-12-10  Akim Demaille  <akim@epita.fr>

	* configure.in: Require 2.52g.
	M4 is not needed, but AUTOM4TE is.
	* m4/m4.m4: Remove.
	* tests/Makefile.am: Adjust.

2001-12-10  Akim Demaille  <akim@epita.fr>

	One structure for states is enough, even though theoretically
	there are LR(0) states and LALR(1) states.

	* src/lalr.h (state_t): Remove.
	(state_table): Be state_t **, not state_t *.
	* src/state.h (core, CORE_ALLOC): Rename as...
	(state_t, STATE_ALLOC): this.
	Add the LALR(1) members: shifts, reductions, errs.
	* src/LR0.c (state_table): Rename as...
	(state_hash): this, to avoid name clashes with the global
	`state_table'.
	* src/print_graph.c, src/LR0.c, src/LR0.h, src/conflicts.c
	* src/lalr.c, src/lalr.h, src/output.c, src/print.c: Adjust.

2001-12-10  Akim Demaille  <akim@epita.fr>

	Bison dumps core on bash.y.
	Reported by Pascal Bart.

	* src/warshall.c (bitmatrix_print): New.
	(TC): Use it.
	When performing a transitive closure R(i, j) && R(j, k) => R(i,	k),
	j must be the outer loop.
	* tests/regression.at (Broken Closure): New.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* tests/atlocal.in (CPPFLAGS): Do not leave a space between -I and
	its argument.
	Reported by Peter Hámorský.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/conflicts.c (err_table): Remove.
	(resolve_sr_conflict): Adjust.
	* src/lalr.h (state_t.reduction_table, state_t.shift_table):
	Rename as...
	(state_t.reductions, state_t.shifts): this.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/reduce.c (reduce_grammar_tables): No longer disable the
	removal of useless rules via CPP but via `if (0)', so that the
	compiler still check the code is valid.
	For instance, it should have noticed `rline' no longer exists: use
	the `line' member of rule_t.
	* src/gram.c (dummy, rline): Remove, unused.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/output.c (pack_vector): Use assert, not berror.
	* src/main.c (berror): Remove, unused.

2001-12-05  Akim Demaille  <akim@epita.fr>

	New experimental feature: if --verbose --trace output all the
	items of a state, not only its kernel.

	* src/print.c (print_core): If `trace_flag', then invoke closure
	before outputting the items of the state (print_core is no longer
	a correct name them).
	(print_results): Invoke new_closure/free_closure if needed.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/LR0.c (new_itemsets): Use nshifts only, not shiftcount.
	* src/closure.c, src/closure.h (itemsetsize): Rename as...
	(nitemset): for consistency with the rest of the project.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/closure.c (print_closure): Improve.
	(closure): Use it for printing input and output.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/closure.c (FIRSTS, FDERIVES): Adjust to reality: they are
	indexed by nonterminals.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/warshall.c (TC, RTC): De-obsfucate (source reduced to 22% of
	what it was!).
	* src/warshall.h: Remove accidental duplication of the content.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/closure.c (set_fderives): De-obfuscate.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/closure.c (print_firsts, print_fderives): De-obfuscate.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/closure.c (set_firsts): De-obfuscate.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/output.c (action_row): De-obfuscate
	using the good o' techniques: arrays not pointers, variable
	locality, BITISSET, RESETBIT etc.

2001-12-05  Akim Demaille  <akim@epita.fr>

	Pessimize the code to simplify it: from now on, all the states
	have a valid SHIFTS, which NSHIFTS is possibly 0.

	* src/LR0.c (shifts_new): Be global and move to..
	* src/state.c, src/state.h: here.
	* src/conflicts, src/lalr.c, src/output.c, src/print.c,
	* src/print_graph: Adjust.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/state.h (SHIFT_DISABLE, SHIFT_IS_DISABLED): New.
	* src/conflicts.c: Use it.
	Restore a few missing `if (!SHIFT_IS_DISABLED)' which were
	incorrectly ``simplified''.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/conflicts.c (flush_shift, resolve_sr_conflict): De-obfuscate
	using the good o' techniques: arrays not pointers, variable
	locality, BITISSET, RESETBIT etc.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/state.h (SHIFT_SYMBOL): New.
	* src/conflicts.c: Use it to deobfuscate.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/conflicts.c (count_sr_conflicts, count_rr_conflicts)
	(print_reductions): De-obfuscate using the good o' techniques:
	arrays not pointers, variable locality, BITISSET.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/conflicts.c (print_reductions): Arrays, not pointers.
	Use BITISSET.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/conflicts.c (print_reductions): Pessimize, but clarify.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/conflicts.c (print_reductions): Improve variable locality.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/conflicts.c (print_reductions): Pessimize, but clarify.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/conflicts.c (print_reductions): Improve variable locality.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/state.h (SHIFT_IS_ERROR, SHIFT_IS_GOTO, SHIFT_IS_SHIFT): New.
	* src/lalr.c: Use them.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/LR0.c (augment_automaton): Formatting changes.
	Better variable locality.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/lalr.c (matrix_print): New.
	(transpose): Use it.
	Use arrays instead of pointers.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/lalr.c (maxrhs): Move to...
	* src/gram.c, src/gram.h (ritem_longest_rhs): here.
	* src/lalr.c (build_relations): Adjust.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/lalr.c (transpose): Free the memory allocated to the
	argument, as it is replaced by the results by the unique caller.
	(build_relations): Merely invoke transpose: it handles the memory
	deallocation.
	Improve variable locality.
	Avoid variables used as mere abbreviations.
	(compute_lookaheads): Use arrays instead of pointers.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/lalr.c (initialize_F): Improve variable locality.
	Avoid variables used as mere abbreviations.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/derives.c (print_derives): Display the ruleno.
	* src/lalr.c (initialize_F, transpose): Better variable locality
	to improve readability.
	Avoid variables used as mere abbreviations.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/lalr.c (traverse): Use arrays instead of pointers.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/nullable.c (set_nullable): Use a for loop to de-obfuscate
	the handling of squeue.
	`symbol >= 0' is wrong now, use `rule_table[ruleno].useful'.

2001-12-05  Akim Demaille  <akim@epita.fr>

	Because useless nonterminals are now kept alive (instead of being
	`destroyed'), we now sometimes examine them, and store information
	related to them.  Hence we need to know their number, and adjust
	memory allocations.

	* src/reduce.c, src/reduce.h (nuseless_nonterminals): No longer
	static.
	* src/LR0.c (allocate_itemsets): The memory allocated to
	`symbol_count' was used for two different purpose: once to count
	the number of occurrences of each symbol, and later reassigned to
	`shift_symbol', containing the symbol that can be shifted from a
	given state.
	Deobfuscate, i.e., allocate, use and free `symbol_count' here
	only, and...
	(new_itemsets): Allocate `shift_symbol' here.
	(allocate_itemsets): symbol_count includes useless nonterminals.
	Make room for them.
	(free_storage): Use `free', not `XFREE', for pointers that cannot
	be null.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/nullable.c (set_nullable): Deobfuscate the handling of
	ritem.
	`symbol >= 0' is wrong now, use `rule_table[ruleno].useful'.

2001-12-05  Akim Demaille  <akim@epita.fr>

	* src/gram.c, src/gram.h (ritem_print): New.
	* src/gram.c (dummy): Remove, now there is actual code in gram.c.
	(This useless function was defined only to work around VMS linkers
	that can't handle compilation units with variables only).
	* src/reduce.c (dump_grammar): Use it to trace the construction of
	ritem.

2001-12-04  Paul Eggert  <eggert@twinsun.com>

	* src/bison.simple (union yyalloc): Change member names
	to be the same as the stack names.
	(yyparse): yyptr is now union yyalloc *, not char *.
	(YYSTACK_RELOCATE): Likewise.  This avoids a GCC warning,
	and may generate better code on some machines.
	(yystpcpy): Use prototype if __STDC__ is defined, not just
	if __cplusplus is defined.

2001-11-30  Akim Demaille  <akim@epita.fr>

	* configure.in (WARNING_CFLAGS): Add -Werror when possible.
	(CFLAGS): Do not include the WARNING_CFLAGS here, since GNU
	Gettext doesn't compile cleanly, and dies with -Werror.
	* src/Makefile.am, lib/Makefile.am, tests/atlocal.in (CFLAGS):
	Include WARNING_CFLAGS here.
	* lib/xstrdup.c: Include xalloc.h, so that xstrdup be declared
	before being defined.

2001-11-27  Paul Eggert  <eggert@twinsun.com>

	* lib/quotearg.h (quotearg_n, quotearg_n_style):
	First arg is int, not unsigned.
	* lib/quotearg.c (quotearg_n, quotearg_n_style): Likewise.
	(SIZE_MAX, UINT_MAX): New macros.
	(quotearg_n_options): Abort if N is negative.
	Avoid overflow check on hosts where size_t is 64 bits and int
	is 32 bits, as overflow is impossible there.
	Fix off-by-one typo that caused unnecessary reallocation.

2001-11-29  Paul Eggert  <eggert@twinsun.com>

	Name space cleanup in generated parser.

	* doc/bison.texinfo (Bison Parser): Discuss system headers
	and their effect on the user name space.

	* src/bison.simple:
	(YYSTACK_ALLOC, YYSTACK_FREE, union yyalloc, YYSTACK_GAP_MAX,
	YYSTACK_BYTES, YYSTACK_RELOCATE): Do not define unless necessary,
	i.e. unless ! defined (yyoverflow) || defined (YYERROR_VERBOSE).

	(YYSIZE_T): New macro.  Use it instead of size_t, to avoid infringing
	on user names when possible.

	(YYSTACK_USE_ALLOCA): Do not define; just use any existing defn.
	Simplify test for whather <alloca.h> exists.

	(<stdlib.h>): Include if we will use malloc, and if standard C or C++.

	(<stdio.h>): Include if YYDEBUG.

	(yymemcpy): Renamed from __yy_memcpy.  Do not define unless
	! defined (yyoverflow) && ! defined (yymemcpy).

	(yymemcpy, yyparse): Rename local variables as needed so that
	they all begin with 'yy'.

	(yystrlen, yystpcpy): New functions.

	(YY_DECL_NON_LSP_VARIABLES): Renamed from _YY_DECL_VARIABLES.
	All uses changed.

	(yyparse): size_t -> YYSIZE_T.  Use yystrlen and yystpcpy
	instead of relying on string.h functions.  Use YYSTACK_ALLOC
	and YYSTACK_FREE instead of malloc and free.

2001-11-30  Akim Demaille  <akim@epita.fr>

	* src/bison.simple (YYSTYPE, YYLTYPE): Move their definitions
	before their first uses.
	(YYBISON, YYPURE): Move to the top of the output.

2001-11-30  Akim Demaille  <akim@epita.fr>

	* tests/reduce.at (Useless Nonterminals): Fix.

2001-11-30  Akim Demaille  <akim@epita.fr>

	* src/bison.simple (YYSTACK_FREE): Use `do {;} while (0)' as empty
	if body instead of `;' to pacify GCC's warnings.

2001-11-30  Akim Demaille  <akim@epita.fr>

	Instead of mapping the LHS of unused rules to -1, keep the LHS
	valid, but flag the rules as invalid.

	* src/gram.h (rule_t): `useful' is a new member.
	* src/print.c (print_grammar): Adjust.
	* src/derives.c (set_derives): Likewise.
	* src/reader.c (packgram, reduce_output): Likewise.
	* src/reduce.c (reduce_grammar_tables): Likewise.
	* tests/reduce.at (Underivable Rules, Useless Rules): New.

2001-11-30  Akim Demaille  <akim@epita.fr>

	* src/reduce.c (reduce_output): Formatting changes.
	* src/print.c (print_results, print_grammar): Likewise.
	* tests/regression.at (Rule Line Numbers)
	(Solved SR Conflicts, Unresolved SR Conflicts): Adjust.

2001-11-30  Akim Demaille  <akim@epita.fr>

	* src/reduce.c (nonterminals_reduce): Instead of throwing away
	useless nonterminals, move them at the end of the symbol arrays.
	(reduce_output): Adjust.
	* tests/reduce.at (Useless Nonterminals): Adjust.

2001-11-30  Akim Demaille  <akim@epita.fr>

	* src/reduce.c: Various comment/formatting changes.
	(nonterminals_reduce): New, extracted from...
	(reduce_grammar_tables): here.
	(reduce_grammar): Call nonterminals_reduce.

2001-11-29  Paul Eggert  <eggert@twinsun.com>

	* src/bison.simple (YYSTACK_REALLOC): Remove.
	(YYSTACK_ALLOC): Resurrect this macro, with its old meaning.
	(YYSTACK_FREE, YYSTACK_GAP_MAX, YYSTACK_BYTES, YYSTACK_RELOCATE):
	New macros.
	(union yyalloc): New type.
	(__yy_memcpy): Last arg is size_t, not unsigned int, to remove
	an arbitrary restriction on hosts where size_t is wider than int.

	(yyparse): Don't dump core if alloca or malloc fails; instead, report
	a parser stack overflow.  Allocate just one block of memory for all
	three stacks, instead of allocating three blocks; this typically is
	faster and reduces fragmentation.

	Do not limit the number of items in the stack to a value that fits
	in 'int', as this is an arbitrary limit on hosts with 64-bit
	size_t and 32-bit int.

2001-11-29  Marc Autret  <autret_m@epita.fr>

	* tests/calc.at [AT_DATA_CALC_Y]: Use %error-verbose instead
	of defining YYERROR_VERBOSE.
	[AT_DATA]: $4 is now out of C declarations in the prologue.

2001-11-28  Marc Autret  <autret_m@epita.fr>

	* src/reader.c (parse_dquoted_param): New.
	(parse_skel_decl): Use it.
	* src/lex.h: Add its prototype.
	* src/lex.c (literalchar): Become not static.

2001-11-28  Marc Autret  <autret_m@epita.fr>

	* src/output.h: And put its extern declaration here.
	* src/output.c (error_verbose): Define here.
	(prepare): Echo name modification.
	* src/getargs.h: Clean its extern declaration.
	* src/getargs.c (error_verbose_flag): Remove.
	(getargs): Remove case 'e'.
	* src/options.c (option_table): 'error-verbose' is now seen as simple
	percent option.
	Include output.h.

	* src/reader.c (read_declarations): Remove case tok_include.
	(parse_include_decl): Remove.
	* src/lex.h (token_t): Remove tok_include.
	* src/options.c (option_table): 'include' is now a simple command line
	option.

2001-11-28  Marc Autret  <autret_m@epita.fr>

	* src/bison.simple: Adjust muscle names.
	* src/muscle_tab.c (muscle_init): Also rename the muscles.
	* src/output.c (prepare): s/_/-/ for the muscles names.
	(output_parser): When scanning for a muscle, allow '-' instead of '_'.

2001-11-28  Marc Autret  <autret_m@epita.fr>

	* src/bison.simple: Fix debug.
	[YYERROR_VERBOSE]: Re-integrate as an internal macro.

2001-11-28  Akim Demaille  <akim@epita.fr>

	* src/LR0.c (shifts_new): New.
	(save_shifts, insert_start_shift, augment_automaton): Use it.

2001-11-28  Akim Demaille  <akim@epita.fr>

	* src/closure.c (closure): `b' and `ruleno' denote the same value:
	keep ruleno only.

2001-11-28  Akim Demaille  <akim@epita.fr>

	* src/closure.c (closure): Instead of looping over word in array
	then bits in words, loop over bits in array.

2001-11-28  Akim Demaille  <akim@epita.fr>

	* src/closure.c (closure): No longer optimize the special case
	where all the bits of `ruleset[r]' are set to 0, to make the code
	clearer.

2001-11-28  Akim Demaille  <akim@epita.fr>

	* src/closure.c (closure): `r' and `c' are new variables, used to
	de-obfuscate accesses to RULESET and CORE.

2001-11-28  Akim Demaille  <akim@epita.fr>

	* src/reduce.c (reduce_print): Use ngettext.
	(dump_grammar): Improve the trace accuracy.

2001-11-28  Akim Demaille  <akim@epita.fr>

	* src/reduce.c (dump_grammar): Don't translate trace messages.

2001-11-28  Akim Demaille  <akim@epita.fr>

	* tests/reduce.at (Useless Terminals, Useless Nonterminals): New.
	* src/reduce.c (reduce_grammar_tables): Do not free useless tags,
	as all tags are free'ed afterwards.
	From Enrico Scholz.

2001-11-27  Paul Eggert  <eggert@twinsun.com>

	* src/bison.simple (YYSTACK_REALLOC): Fix typo that caused us to
	use alloca when we didn't want to, and vice versa.

2001-11-27  Marc Autret  <autret_m@epita.fr>

	* src/muscle_tab.c (muscle_init): Remove 'verbose' muscle
	initialization.
	* src/output.c (prepare): Remove its update.

2001-11-27  Marc Autret  <autret_m@epita.fr>

	* tests/torture.at [AT_DATA]: Remove YYERROR_VERBOSE definition.
	Use %error-verbose.

2001-11-27  Marc Autret  <autret_m@epita.fr>

	* src/bison.simple: Remove YYERROR_VERBOSE using.
	Use %%error_verbose.
	(yyparse): Likewise.
	* src/output.c (prepare): Give its final value.
	* src/muscle_tab.c (muscle_init): Init new muscle 'error_verbose'.
	* src/getargs.h: Add its extern declaration.
	* src/getargs.c (error_verbose_flag): New int.
	(getargs): Update to catch new case.
	* src/options.c (option_table): 'error-verbose' is a new option.
	(shortopts): Update.

2001-11-27  Akim Demaille  <akim@epita.fr>

	* src/system.h: Use intl/libgettext.h.
	* src/Makefile.am (INCLUDES): Add -I $(top_srcdir).

2001-11-27  Akim Demaille  <akim@epita.fr>

	* tests/torture.at (Exploding the Stack Size with Malloc):
	s/YYSTACK_USE_ALLOCA_ALLOCA/YYSTACK_USE_ALLOCA/.

2001-11-27  Akim Demaille  <akim@epita.fr>

	* src/files.c: Include error.h.
	Reported by Hans Aberg.

2001-11-26  Marc Autret  <autret_m@epita.fr>

	* src/reader.c (parse_include_decl): New, not yet implemented.
	(read_declarations): Add case tok_include.
	* src/getargs.h (include): Add its extern definition.
	* src/getargs.c (include): New const char *.
	(getargs): Add case '-I'.
	* src/options.c (option_table): Add include as command line and
	percent option.
	* src/lex.h (token_t): Add tok_include.

2001-11-26  Akim Demaille  <akim@epita.fr>

	* src/reader.c (readgram): Make sure rules for mid-rule actions
	have a lineno equal to that of their host rule.
	Reported by Hans Aberg.
	* tests/regression.at (Rule Line Numbers): New.

2001-11-26  Akim Demaille  <akim@epita.fr>

	* src/LR0.c (allocate_itemsets): kernel_size contains ints, not
	size_ts.

2001-11-26  Akim Demaille  <akim@epita.fr>

	* src/complain.c, src/complain.h (error): Remove, provided by
	lib/error.[ch].

2001-11-26  Akim Demaille  <akim@epita.fr>

	* src/reader.c (read_declarations): Don't abort on tok_illegal,
	issue an error message.
	* tests/regression.at (Invalid %directive): New.
	Reported by Hans Aberg.

2001-11-26  Akim Demaille  <akim@epita.fr>

	* configure.in: Invoke AC_FUNC_OBSTACK and AC_FUNC_ERROR_AT_LINE.
	* lib/Makefile.am (libbison_a_SOURCES): Adjust.

2001-11-26  Akim Demaille  <akim@epita.fr>

	* src/conflicts.c (conflicts_print): Don't complain at all when
	there are no reduce/reduce conflicts, and as many shift/reduce
	conflicts as expected.
	* tests/regression.at (%expect right): Adjust.

2001-11-23  Akim Demaille  <akim@epita.fr>

	* lib/alloca.c: Update, from fileutils.

2001-11-23  Akim Demaille  <akim@epita.fr>

	* lib/Makefile.am (libbison_a_LIBADD): Add @ALLOCA@.

2001-11-23  Akim Demaille  <akim@epita.fr>

	* src/system.h: Include alloca.h.
	* src/main.c (main) [C_ALLOCA]: Call alloca (0).

2001-11-23  Akim Demaille  <akim@epita.fr>

	* src/print_graph.c (print_actions): Remove `rule', unused.
	* src/LR0.c (kernel_size): Contain `int' instead of `size_t' to
	pacify GCC's signed < unsigned warnings.
	* src/closure.c (itemsetsize): Likewise.
	* src/reader.c (symbol_list_new): Static.

2001-11-23  Akim Demaille  <akim@epita.fr>

	Attaching lineno to buckets is stupid, since only one copy of each
	symbol is kept, only the line of the first occurrence is kept too.

	* src/symtab.h, src/symtab.c (bucket): Remove the line member.
	* src/reader.c (rline_allocated): Remove, unused.
	(symbol_list): Have a `line' member.
	(symbol_list_new): New.
	(readgram): Use it.
	* src/print.c (print_grammar): Output the rule line numbers.
	* tests/regression.at (Solved SR Conflicts)
	(Unresolved SR Conflicts): Adjust.
	Reported by Hans Aberg.

2001-11-22  Marc Autret  <autret_m@epita.fr>

	* src/bison.simple [YYERROR_VERBOSE]: Force its value to be 1 or 0.

2001-11-22  Marc Autret  <autret_m@epita.fr>

	* src/muscle_tab.c (muscle_init): Remove initialization of
	skeleton muscle.
	* src/output.c (output_master_parser): Do it here.

2001-11-20  Akim Demaille  <akim@epita.fr>

	* po/sv.po: New.
	* configure.in (ALL_LINGUAS): Adjust.
	* po/POTFILE.in: Remove `nullable.c' and `derives.c' which no
	longer contains strings to translate.

2001-11-19  Akim Demaille  <akim@epita.fr>

	* src/conflicts.c (conflicts_print): Add a missing \n.

2001-11-19  Akim Demaille  <akim@epita.fr>

	* src/nullable.c (nullable_print): New.
	(set_nullable): Call it when tracing.
	Better locality of variables.

2001-11-19  Akim Demaille  <akim@epita.fr>

	* src/print.c (print_actions): Better locality of variables.

2001-11-19  Akim Demaille  <akim@epita.fr>

	* src/derives.c (print_derives): Fix and enrich.
	* src/closure.c (print_fderives): Likewise.

2001-11-19  Akim Demaille  <akim@epita.fr>

	* src/closure.c (itemsetend): Remove, replaced with...
	(itemsetsize): new.

2001-11-19  Akim Demaille  <akim@epita.fr>

	* src/LR0.c (kernel_end): Remove, replaced with...
	(kernel_size): new.

2001-11-19  Akim Demaille  <akim@epita.fr>

	* src/conflicts.c (set_conflicts): Use arrays instead of pointers
	to clarify.

2001-11-19  Akim Demaille  <akim@epita.fr>

	* src/closure.c (closure): Use arrays instead of pointers to clarify.

2001-11-19  Akim Demaille  <akim@epita.fr>

	* src/closure.c, src/derives.c, src/nullable.c: Adjust various
	trace messages.
	* src/LR0.c: Likewise.
	(allocate_itemsets): Use arrays instead of pointers to clarify.

2001-11-19  Akim Demaille  <akim@epita.fr>

	* src/getargs.c (statistics_flag): Replace with...
	(trace_flag): New.
	(longopts): Accept --trace instead of --statistics.
	* src/getargs.h, src/options.c: Adjust.
	* src/LR0.c, src/closure.c, src/derives.c, src/nullable.c,
	* src/reduce.c: Use trace_flags instead of the CPP conditional TRACE.

2001-11-19  Akim Demaille  <akim@epita.fr>

	* src/LR0.c (new_itemsets, get_state): Use more arrays and fewer
	pointers to clarify the code.
	(save_reductions, save_shifts): Factor common parts of alternatives.

2001-11-19  Akim Demaille  <akim@epita.fr>

	* src/LR0.c (new_state, get_state): Complete TRACE code.
	* src/closure.c: Include `reader.h' to get `tags', needed by the
	trace code.
	Rename the conditional DEBUG as TRACE.
	Output consistently TRACEs to stderr, not stdout.
	* src/derives.c: Likewise.
	* src/reduce.c: (inaccessable_symbols): Using if is better style
	than goto.
	Use `#if TRACE' instead of `#if 0' for tracing code.

2001-11-19  Akim Demaille  <akim@epita.fr>

	* src/system.h (LIST_FREE, shortcpy): New.
	* src/LR0.c: Use them.
	* src/output.c (free_itemsets, free_reductions, free_shifts):
	Remove, replaced by LIST_FREE.

2001-11-19  Akim Demaille  <akim@epita.fr>

	* src/state.h (CORE_ALLOC, SHIFTS_ALLOC, ERRS_ALLOC)
	(REDUCTIONS_ALLOC):  New.
	* src/LR0.c, src/conflicts.c: Use them to de-obfuscate memory
	allocation.

2001-11-19  Akim Demaille  <akim@epita.fr>

	* src/LR0.c (new_state): Complete trace code.
	* src/nullable.c (set_nullable): Don't translate traces.

2001-11-19  Akim Demaille  <akim@epita.fr>

	* src/print_graph.c (print_core): Better locality of variables.
	* src/print.c (print_core): Likewise.

2001-11-19  Akim Demaille  <akim@epita.fr>

	* src/vcg.c: You do the output, so you are responsible of the
	handling of VCG syntax, in particular: use quotearg.
	* src/print_graph.c: Don't.
	(print_actions): Don't output the actions as part of the nodes,
	since that's the job of the edges.
	(print_state): Don't output by hand: fill the node description,
	and ask for its output.

2001-11-19  Akim Demaille  <akim@epita.fr>

	* src/bison.simple (yyparse): When verbosely reporting an error,
	no longer put additional quotes around token names.
	* tests/calc.at: Adjust.

2001-11-19  Akim Demaille  <akim@epita.fr>

	* src/symtab.h, src/symtab.c: `line' is a new member of `bucket'.
	* src/reader.c (record_rule_lines, rline, rline_allocated): Remove.
	* src/output.c: Adjust.

2001-11-19  Akim Demaille  <akim@epita.fr>

	* src/gram.h (rprec, rprecsym, rassoc): Remove, now part of...
	(rule_t): this.
